#include <iostream.h>
#include "CifFileObj.h"


static void ShowUsage(void);


int main(int argc, char** argv)
{

    char inFile[500];
    char outFile[600];
    char* diags=NULL;
    CifFileObj* fobjR = NULL;
    CifFileReadDef readDef;
    type readType;
    ReVarCifArray<CifString> catlist;
    int retTest;


    if (argc < 2)
    {
        ShowUsage();
        exit(1);
    }

    strcpy(inFile, argv[1]);

    strcpy(outFile, inFile);
    strcat(outFile, ".out");

    if (argc > 2)
    {
        if (argc == 3)
        {
            ShowUsage();
            exit(1);
        }
 
        if (strcmp(argv[2], "A") == 0)
        {
            readType = A;
        }
        else
        {
            readType = D;
        }

        for (int i = 3; i < argc; i++)
        {
            /* Add categories to the list. */
            catlist.Add(argv[i]);
        }

        readDef.SetCategoryList(catlist, readType);
    }

//    ReVarCifArray<CifString> blocklist;
//    blocklist.Add("ADH041");

    /* Set the datablock list to accepted. */
//    readDef.SetDataBlockList(blocklist, A);

//    fobjR = new CifFileObj("./cif-reader.odb", WRITE_MODE, 80, "?", 1, CASE_INSENSITIVE);
    fobjR = new CifFileObj("./cif-reader.odb", WRITE_MODE, 80, "?", 1);
    fobjR->Read(inFile, diags, readDef);

    if (diags)
    {
        cout << " Diagnostics [" << strlen(diags) << "] " << diags << endl;
    }

    retTest = fobjR->IsTablePresent("atom_site");
    cout << "Return from IsTablePresent(atom_site): " << retTest << endl;
    retTest = fobjR->IsTablePresent("ATOM_site");
    cout << "Return from IsTablePresent(ATOM_site): " << retTest << endl;

    fobjR->Write(outFile);

    fobjR->CloseFile(1);

    if (fobjR) delete fobjR;

    exit(0);

} /* End of main() */

void ShowUsage(void)
{

    cout << "Usage: CifReader input_file [readType] [category]*" << endl;

}
