/*
FILE:     erf_iolib_global.h
*/
/*
VERSION:  1.700
*/
/*
DATE:     7/13/2005
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2005 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
int ALTSQN_TOKEN = -1;
int ALTSQR_TOKEN = -1;
int ANISOU_TOKEN = -1;
int ATOMMN_TOKEN = -1;
int ATOMMP_TOKEN = -1;
int ATOMN_TOKEN  = -1;
int ATOMP_TOKEN  = -1;
int ATOMS_TOKEN  = -1;
int AUTHOR_TOKEN = -1;
int BIOMT_TOKEN  = -1;
int BIOUNI_TOKEN = -1;
int BSPAIR_TOKEN = -1;
int COMPND_TOKEN = -1;
int CRMETH_TOKEN = -1;
int CRSOLU_TOKEN = -1;
int CRYST1_TOKEN = -1;
int DBREF_TOKEN  = -1;
int DCHEM_TOKEN  = -1;
int DTMEAS_TOKEN = -1;
int DTMETH_TOKEN = -1;
int DTTEMP_TOKEN = -1;
int DTWAVE_TOKEN = -1;
int ECNUM_TOKEN  = -1;
int ENTAIL_TOKEN = -1;
int ENTDES_TOKEN = -1;
int ENTITY_TOKEN = -1;
int ENTNAM_TOKEN = -1;
int ENTMUT_TOKEN = -1;
int EXPDTA_TOKEN = -1;
int FORMUL_TOKEN = -1;
int FRAGMT_TOKEN = -1;
int FREERF_TOKEN = -1;
int HEADER_TOKEN = -1;
int HELIX_TOKEN  = -1;
int HET_TOKEN    = -1;
int HETAC_TOKEN  = -1;
int HETAD_TOKEN  = -1;
int HETAI_TOKEN  = -1;
int HETAIN_TOKEN = -1;
int HETAS_TOKEN  = -1;
int HETIC_TOKEN  = -1;
int HETNAM_TOKEN = -1;
int HETSYN_TOKEN = -1;
int HYDBND_TOKEN = -1;
int INHIBT_TOKEN = -1;
int JRNL_TOKEN   = -1;
int LINK_TOKEN   = -1;
int MASTER_TOKEN = -1;
int MISMAT_TOKEN = -1;
int MISRES_TOKEN = -1;
int MODEL_TOKEN  = -1;
int MODIFB_TOKEN = -1;
int MODIFP_TOKEN = -1;
int MODIFS_TOKEN = -1;
int MODRES_TOKEN = -1;
int MTRIX_TOKEN  = -1;
int NCSGRO_TOKEN = -1;
int NCSMOD_TOKEN = -1;
int NDBFIL_TOKEN = -1;
int NDBPRO_TOKEN = -1;
int NDBSQN_TOKEN = -1;
int NMRECD_TOKEN = -1;
int NMREXP_TOKEN = -1;
int NMRSMP_TOKEN = -1;
int NMRSPM_TOKEN = -1;
int NMRSFT_TOKEN = -1;
int ORIGX_TOKEN  = -1;
int PCOMPN_TOKEN = -1;
int PDBFIL_TOKEN = -1;
int PDBSQN_TOKEN = -1;
int PDBSQR_TOKEN = -1;
int PHVAL_TOKEN  = -1;
int PREMRK_TOKEN = -1;
int PROCES_TOKEN = -1;
int PROTEI_TOKEN = -1;
int PSOURC_TOKEN = -1;
int RADIAT_TOKEN = -1;
int RECVD1_TOKEN = -1;
int REFMET_TOKEN = -1;
int REMARK_TOKEN = -1;
int RENTRY_TOKEN = -1;
int REVDAT_TOKEN = -1;
int RFACTR_TOKEN = -1;
int SCALE_TOKEN  = -1;
int SEQIFO_TOKEN = -1;
int SEQRES_TOKEN = -1;
int SFTWAR_TOKEN = -1;
int SHEET_TOKEN  = -1;
int SIGATM_TOKEN = -1;
int SIGUIJ_TOKEN = -1;
int SITE_TOKEN   = -1;
int SLTBRG_TOKEN = -1;
int SOURCE_TOKEN = -1;
int SSBOND_TOKEN = -1;
int STASYM_TOKEN = -1;
int STATUS_TOKEN = -1;
int STBIOL_TOKEN = -1;
int SYMMA_TOKEN  = -1;
int SYMTRA_TOKEN = -1;
int TARGET_TOKEN = -1;
int TER_TOKEN    = -1;
int TLSGRO_TOKEN = -1;
int TURN_TOKEN   = -1;
int WAVLEN_TOKEN = -1;
int XFILES_TOKEN = -1;
