/*
FILE:     cif_standard.h
*/
/*
VERSION:  1.700
*/
/*
DATE:     7/13/2005
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2005 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
#ifndef _CIF_STANDARD_H_
#define _CIF_STANDARD_H_

typedef struct {
        int  index;
        const char *name;
} _NAME_INDEX;

typedef struct {
        char cif[10];
        char pdb[10];
} CIF_PDB_PAIR;

typedef struct {
        int length;
        CIF_PDB_PAIR **pair;
} PAIR_INDEX;

typedef struct {
        int num;
        char **chnid;
        PAIR_INDEX **index;
} SCHEME_TABLE;

#define NUM_SAENGER  29
#define NUM_WESTHOF  18

static _NAME_INDEX _saenger[NUM_SAENGER] = {
       {  1, "I" },
       {  2, "II" },
       {  3, "III" },
       {  4, "IV" },
       {  5, "V" },
       {  6, "VI" },
       {  7, "VII" },
       {  8, "VIII" },
       {  9, "IX" },
       { 10, "X" },
       { 11, "XI" },
       { 12, "XII" },
       { 13, "XIII" },
       { 14, "XIV" },
       { 15, "XV" },
       { 16, "XVI" },
       { 17, "XVII" },
       { 18, "XVIII" },
       { 19, "Watson-Crick" },
       { 20, "Watson-Crick" },
       { 21, "reversed Watson-Crick" },
       { 22, "reversed Watson-Crick" },
       { 23, "Hoogsteen" },
       { 24, "reversed Hoogsteen" },
       { 25, "XXV" },
       { 26, "XXVI" },
       { 27, "XXVII" },
       { 28, "XXVIII" },
       { 29, "XXIX" }
};

static _NAME_INDEX _westhof[NUM_WESTHOF] = {
       {  1, "Cis Watson-Crick/Watson-Crick" },
       {  2, "Trans Watson-Crick/Watson-Crick" },
       {  3, "Cis Watson-Crick/Hoogsteen" },
       {  3, "Cis Hoogsteen/Watson-Crick" },
       {  4, "Trans Watson-Crick/Hoogsteen" },
       {  4, "Trans Hoogsteen/Watson-Crick" },
       {  5, "Cis Watson-Crick/Sugar Edge" },
       {  5, "Cis Sugar Edge/Watson-Crick" },
       {  6, "Trans Watson-Crick/Sugar Edge" },
       {  6, "Trans Sugar Edge/Watson-Crick" },
       {  7, "Cis Hoogsteen/Hoogsteen" },
       {  8, "Trans Hoogsteen/Hoogsteen" },
       {  9, "Cis Hoogsteen/Sugar Edge" },
       {  9, "Cis Sugar Edge/Hoogsteen" },
       { 10, "Trans Hoogsteen/Sugar Edge" },
       { 10, "Trans Sugar Edge/Hoogsteen" },
       { 11, "Cis Sugar Edge/Sugar Edge" },
       { 12, "Trans Sugar Edge/Sugar Edge" }
};

#define NUM_ITEM             8

typedef struct {
        const char *category;
        int  num_items;
        const char *items[NUM_ITEM];
} _PDB_INSERT_CODE;

#define NUM_PDB_INSERT_CODE  1

static _PDB_INSERT_CODE _pdb_insert_code[NUM_PDB_INSERT_CODE] = {
/*
       { "rcsb_struct_sheet_hbond", 2, 
            { "range_1_auth_seq_id",      "range_1_PDB_ins_code",
              "range_2_auth_seq_id",      "range_2_PDB_ins_code"
            }
       },
       { "struct_conf",             2,
            { "beg_auth_seq_id",          "ndb_beg_label_ins_code_pdb",
              "end_auth_seq_id",          "ndb_end_label_ins_code_pdb"
            }
       },
       { "struct_conn",             2,
            { "ptnr1_auth_seq_id",        "ndb_ptnr1_label_ins_code",
              "ptnr2_auth_seq_id",        "ndb_ptnr2_label_ins_code"
            }
       },
*/
       { "struct_mon_prot_cis",     2,
            { "auth_seq_id",              "ndb_auth_ins_code",
              "ndb_auth_seq_id_2",        "ndb_auth_ins_code_2"
            }
       },
/*
       { "struct_sheet_hbond",      2,
            { "range_1_beg_auth_seq_id",  "ndb_range_1_beg_label_ins_code",
              "range_1_end_auth_seq_id",  "ndb_range_1_end_label_ins_code"
            }
       },
       { "struct_sheet_range",      2,
            { "beg_auth_seq_id",          "ndb_beg_label_ins_code_pdb",
              "end_auth_seq_id",          "ndb_end_label_ins_code_pdb"
            }
       },
       { "struct_site_gen",         1,
            { "auth_seq_id",              "ndb_label_ins_code",
              "",                         ""
            }
       }
*/
};

#define NUM_TABLELIST   19

static const char *_table_list[NUM_TABLELIST] = {
       "atom_sites",
       "cell",
       "computing",
       "database",
       "database_PDB_matrix",
       "exptl",
       "ndb_na_struct_keywds",
       "ndb_refine",
       "rcsb_nmr_details",
       "rcsb_nmr_ensemble",
       "rcsb_nmr_refine",
       "rcsb_nmr_representative",
       "refine",
       "refine_analyze",
       "refine_ls_restr_ncs",
       "reflns",
       "struct",
       "struct_keywords",
       "symmetry"
};

#define NUM_DIFFRN   3

static const char *diffrn_related_categories[NUM_DIFFRN] = {
        "diffrn_detector",
        "diffrn_radiation",
        "diffrn_source"
};

#define NUM_MISSING_M_I_C   11
#define NUM_MISSIMG_V_I_C    5

static _PDB_INSERT_CODE _Miss_Man_I_cat[NUM_MISSING_M_I_C] = {
       { "diffrn", 1,
         { "crystal_id" }
       },
       { "diffrn_radiation_wavelength", 2,
         { "wavelength", "wt" }
       }, 
       { "exptl_crystal_grow", 1,
         { "rcsb_pH_range" }
       },
       { "ndb_database_status", 4,
         { "dep_release_code_sequence", "dep_release_code_coordinates",
           "dep_release_code_struct_fact", "dep_release_code_nmr_constraints" }
       },
       { "rcsb_nmr_exptl_sample_conditions", 1,
         { "pressure_units" }
       },
       { "refine_hist", 2,
         { "d_res_high", "d_res_low" }
       },
/*
       { "struct_ncs_dom_lim", 8,
         { "beg_label_asym_id", "beg_label_comp_id", "beg_label_seq_id", "beg_label_alt_id",
           "end_label_asym_id", "end_label_comp_id", "end_label_seq_id", "end_label_alt_id" }
       },
*/
       { "struct_ncs_ens_gen", 1,
         { "ens_id" }
       },
       { "struct_ref", 2,
         { "biol_id", "entity_id" }
       },
       { "struct_ref_seq", 2,
         { "ndb_auth_seq_align_beg", "ndb_auth_seq_align_end" }
       },
       { "struct_ref_seq_dif", 1,
         { "ndb_auth_seq_num" }
       },
       { "struct_site_gen", 2,
         { "label_atom_id", "label_alt_id" }
       }
};
/*
static _PDB_INSERT_CODE _Struct_Ref_Seq = {
       "struct_ref_seq", 2,
         { "ndb_auth_seq_align_beg", "ndb_auth_seq_align_end" }
};

static _PDB_INSERT_CODE _Struct_Ref_Seq_Dif = {
       "struct_ref_seq_dif", 1,
         { "ndb_auth_seq_num" }
};
*/
static _PDB_INSERT_CODE _Miss_Value_I_cat[NUM_MISSIMG_V_I_C] = {
       { "ndb_database_status", 4,
         { "dep_release_code_sequence", "dep_release_code_coordinates",
           "dep_release_code_struct_fact", "dep_release_code_nmr_constraints" }
       },
       { "refine_hist", 2,
         { "d_res_high", "d_res_low" }
       },
/*
       { "struct_ncs_dom_lim", 8,
         { "beg_label_asym_id", "beg_label_comp_id", "beg_label_seq_id", "beg_label_alt_id",
           "end_label_asym_id", "end_label_comp_id", "end_label_seq_id", "end_label_alt_id" }
       },
*/
       { "struct_ncs_ens_gen", 1,
         { "ens_id" }
       },
       { "struct_ref", 2,
         { "biol_id", "entity_id" }
       },
       { "struct_site_gen", 2,
         { "label_atom_id", "label_alt_id" }
       }
};

#define NUM_SYMM_V_C  2

static _PDB_INSERT_CODE _Symmetry_Value_Cat[NUM_SYMM_V_C] = {
       { "rcsb_struct_link", 2,
         { "ptnr1_symmetry", "ptnr2_symmetry" }
       },
       { "struct_conn", 2,
         { "ptnr1_symmetry", "ptnr2_symmetry" }
       }
};

typedef struct {
       const char *category;
       const char *item;
} _CAT_ITEM;

#define NUM_CAT_ITEM  3

static _CAT_ITEM _cat_items[NUM_CAT_ITEM] = {
        { "diffrn_detector", "ndb_collection_date" },
        { "ndb_database_PDB_obs_spr", "date" },
        { "database_PDB_rev", "date_original" }
};

#define NUM_CAT_ITEM_TO_LOWER 4

static _CAT_ITEM _cat_items_to_lower[NUM_CAT_ITEM_TO_LOWER] = {
        { "ndb_database_status", "author_approval_type" },
        { "rcsb_nmr_representative", "selection_criteria" },
        { "rcsb_nmr_software", "classification" },
        { "symmetry", "cell_setting" }
};

#define NUM_STRUCT_SITE  2

static _CAT_ITEM _struct_sites[NUM_STRUCT_SITE] = {
        { "struct_site_gen", "site_id" },
        { "struct_site_keywords", "site_id" }
};

typedef struct {
        const char *item;
        int  is_entry_id;
} KEY_ITEMS;

typedef struct {
        const char *category;
	int NumItems;
        KEY_ITEMS items[5];
} EM_CATEGORYS;

#define NUM_EM_CATEGORYS 14

static EM_CATEGORYS em_categories[NUM_EM_CATEGORYS] = {
       { "em_2d_projection_selection", 1, {{ "entry_id", 1 }}},
       { "em_3d_fitting",              2, {{ "id", 0 }, { "entry_id", 1 }}},
       { "em_3d_fitting_list",         2, {{ "id", 0 }, { "3d_fitting_id", 0 }}},
       { "em_3d_reconstruction",       2, {{ "id", 0 }, { "entry_id", 1 }}},
       { "em_assembly",                2, {{ "id", 0 }, { "entry_id", 1 }}},
       { "em_buffer",                  1, {{ "id", 0 }}},
       { "em_detector",                2, {{ "id", 0 }, { "entry_id", 1 }}},
       { "em_entity_assembly",         2, {{ "id", 0 }, { "assembly_id", 2 }}}, 
       { "em_imaging",                 5, {{ "id", 0 }, { "entry_id", 1 },
             { "sample_support_id", 0}, { "detector_id", 0 }, { "scans_id", 0 }}},
       { "em_image_scans",             2, {{ "id", 0 }, { "entry_id", 1 }}},
       { "em_sample_preparation",      2, {{ "id", 0 }, { "entry_id", 1 }}},
       { "em_sample_support",          1, {{ "id", 0 }}},
       { "em_virus_entity",            2, {{ "id", 0 }, { "entity_assembly_id", 0 }}}, 
       { "em_vitrification",           2, {{ "id", 0 }, { "entry_id", 1 }}}
};

#endif
