/*
FILE:     derived_features_global.h
*/
/*
VERSION:  1.700
*/
/*
DATE:     7/13/2005
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2005 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
#ifndef _DERIVED_FEATURES_
#define _DERIVED_FEATURES_

#define NUM_CHIRAL_ATOM            15
#define NUM_VIRTUAL_ATOM            3
#define NUM_PATTERN                30
#define NUM_BOND_ATOM_INDEX        17
#define NUM_ANGLE_ATOM_INDEX       20
#define NUM_TORSION_ATOM_INDEX     18

#define BASE       1
#define SUGAR      2
#define PHOSPHATE  3

#ifndef PI
#define PI 3.14159265358979323846
#endif

typedef struct {
        char  center_atom[5];
        char  first_atom[5];
        char  second_atom[5];
        char  check_atom[5];
} _CHIRAL_ATOM;

typedef struct {
        const char *pattern;
        int  patternlen;
} SEQ_PATTERN;

typedef struct {
        const char *at1;
        const char *at2;
        int  type;
        int  col;
} _BOND_ATOM_INDEX;

typedef struct {
        const char *at1;
        const char *at2;
        const char *at3;
        int  type;
        int  col;
} _ANGLE_ATOM_INDEX;

typedef struct {
        const char *at1;
        const char *at2;
        const char *at3;
        const char *at4;
        int  type;
        int  col;
} _TORSION_ATOM_INDEX;

static _CHIRAL_ATOM chiral_atom[NUM_CHIRAL_ATOM] = {
       { "C1*", "O4*", "C2*", "N9" },
       { "C1*", "O4*", "C2*", "N1" },
       { "C1*", "O4*", "C2*", "H1*" },
       { "C2*", "C1*", "C3*", "O2*" },
       { "C2*", "C1*", "C3*", "H2*" },
       { "C2*", "C1*", "C3*", "1H2*" },
       { "C2*", "C1*", "C3*", "2H2*" },
       { "C3*", "C2*", "C4*", "O3*" },
       { "C3*", "C2*", "C4*", "H3*" },
       { "C4*", "C3*", "O4*", "C5*" },
       { "C4*", "C3*", "O4*", "H4*" },
       { "C5*", "O5*", "C4*", "1H5*" },
       { "C5*", "O5*", "C4*", "2H5*" },
       { "P",   "O5*", "O3*", "O2P" },
       { "P",   "O5*", "O3*", "O1P" }
};

static const char *virtual_atom[NUM_VIRTUAL_ATOM] = { "P", "C1*", "C4*" };
static SEQ_PATTERN seq_pattern[NUM_PATTERN] = {
       { "A",  1 },
       { "C",  1 },
       { "G",  1 },
       { "T",  1 },
       { "U",  1 },
       { "AA", 2 },
       { "AC", 2 },
       { "AG", 2 },
       { "AT", 2 },
       { "AU", 2 },
       { "CA", 2 },
       { "CC", 2 },
       { "CG", 2 },
       { "CT", 2 },
       { "CU", 2 },
       { "GA", 2 },
       { "GC", 2 },
       { "GG", 2 },
       { "GT", 2 },
       { "GU", 2 },
       { "TA", 2 },
       { "TC", 2 },
       { "TG", 2 },
       { "TT", 2 },
       { "TU", 2 },
       { "UA", 2 },
       { "UC", 2 },
       { "UG", 2 },
       { "UT", 2 },
       { "UU", 2 }
};

static _BOND_ATOM_INDEX _bond_atom_index[NUM_BOND_ATOM_INDEX] = {
        { "C1*", "C2*", 3, 39 },
        { "C2*", "C3*", 3, 40 },
        { "C3*", "C4*", 3, 41 },
        { "C4*", "O4*", 3, 42 },
        { "O4*", "C1*", 3, 43 },
        { "P",   "O5*", 3, 44 },
        { "O5*", "C5*", 3, 45 },
        { "C5*", "C4*", 3, 46 },
        { "C3*", "O3*", 3, 47 },
        { "P",   "O1P", 3, 49 },
        { "P",   "O2P", 3, 50 },
        { "C1*", "N9",  2, 51 },
        { "C1*", "N1",  1, 51 },
        { "N1",  "C2",  1, 52 },
        { "N1",  "C6",  1, 53 },
        { "N9",  "C4",  2, 54 },
        { "N9",  "C8",  2, 55 }
};

static _BOND_ATOM_INDEX _link_bond_atom_index = { "O3*", "P", 3, 48 };

static _ANGLE_ATOM_INDEX _angle_atom_index[NUM_ANGLE_ATOM_INDEX] = {
        { "C1*", "C2*", "C3*", 3, 56 },
        { "C2*", "C3*", "C4*", 3, 57 },
        { "C3*", "C4*", "O4*", 3, 58 },
        { "C4*", "O4*", "C1*", 3, 59 },
        { "O4*", "C1*", "C2*", 3, 60 },
        { "P",   "O5*", "C5*", 3, 61 },
        { "O5*", "C5*", "C4*", 3, 62 },
        { "C5*", "C4*", "C3*", 3, 63 },
        { "C4*", "C3*", "O3*", 3, 64 },
        { "O4*", "C1*", "N9",  2, 67 },
        { "O4*", "C1*", "N1",  1, 67 },
        { "C1*", "N9",  "C4",  2, 68 },
        { "C1*", "N1",  "C2",  1, 68 },
        { "C5*", "C4*", "O4*", 3, 69 },
        { "C2*", "C3*", "O3*", 3, 70 },
        { "O1P", "P",   "O2P", 3, 71 },
        { "C2*", "C1*", "N9",  2, 72 },
        { "C2*", "C1*", "N1",  1, 72 },
        { "C1*", "N9",  "C8",  2, 73 },
        { "C1*", "N1",  "C6",  1, 73 }
};

static _ANGLE_ATOM_INDEX _link_C3_O3_P = { "C3*", "O3*", "P", 3, 65 };
static _ANGLE_ATOM_INDEX _link_O3_P_O5 = { "O3*", "P", "O5*", 3, 66 };
        
static _TORSION_ATOM_INDEX _torsion_atom_index[NUM_TORSION_ATOM_INDEX] = {
        { "P",   "O5*", "C5*", "C4*", 3, 10 },
        { "O5*", "C5*", "C4*", "C3*", 3, 11 },
        { "C5*", "C4*", "C3*", "O3*", 3, 12 },
        { "C4*", "O4*", "C1*", "N9",  2, 15 },
        { "C4*", "O4*", "C1*", "N1",  1, 15 },
        { "O4*", "C1*", "N9",  "C4",  2, 16 },
        { "O4*", "C1*", "N1",  "C2",  1, 16 },
        { "O4*", "C1*", "N9",  "C8",  2, 17 },
        { "O4*", "C1*", "N1",  "C6",  1, 17 },
        { "C4*", "O4*", "C1*", "C2*", 3, 18 },
        { "O4*", "C1*", "C2*", "C3*", 3, 19 },
        { "C1*", "C2*", "C3*", "C4*", 3, 20 },
        { "C2*", "C3*", "C4*", "O4*", 3, 21 },
        { "C3*", "C4*", "O4*", "C1*", 3, 22 },
        { "C5*", "C4*", "C3*", "C2*", 3, 23 },
        { "O4*", "C4*", "C3*", "O3*", 3, 24 },
        { "O3*", "C3*", "C2*", "O2*", 3, 25 },
        { "O5*", "C5*", "C4*", "O4*", 3, 26 }
};

static _TORSION_ATOM_INDEX _alpha   = { "O3*", "P",   "O5*", "C5*", 3,  9 };
static _TORSION_ATOM_INDEX _epsilon = { "C4*", "C3*", "O3*", "P",   3, 13 };
static _TORSION_ATOM_INDEX _zeta    = { "C3*", "O3*", "P",   "O5*", 3, 14 };

class _BondIndex
{
   public:
      _BondIndex();
      int  pos() { return _pos; }
      int  Mol_ID() { return _Mol_ID; }
      char *ResName() { return _ResName; }
      char *ChainID() { return _ChainID; }
      int  ResNum() { return _ResNum; }
      char *ins_code() { return _ins_code; }
      void set_pos(const int a) { _pos = a; }
      void set_Mol_ID(const int a) { _Mol_ID = a; }
      void set_ResName(const char *a) { strcpy(_ResName, a); }
      void set_ChainID(const char *a) { strcpy(_ChainID, a); }
      void set_ResNum(const int a) { _ResNum = a; }
      void set_ins_code(const char *a) { strcpy(_ins_code, a); }
      void operator=(const _BondIndex &index);
      int  operator<(const _BondIndex &index);
      int  operator==(const _BondIndex &index);
      int  operator!=(const _BondIndex &index);
      void DeleteElement() {};
      void Print() {};
   private:
      int  _Mol_ID;
      char _ResName[5];
      char _ChainID[5];
      int  _ResNum;
      char _ins_code[2];
      int  _pos;
};

_BondIndex::_BondIndex()
{
      _Mol_ID = 0;
      memset(_ResName, 0, 5);
      memset(_ChainID, 0, 5);
      _ResNum = 0;
      memset(_ins_code, 0, 2);
      _pos = 0;
}

void _BondIndex::operator=(const _BondIndex &index)
{
      _Mol_ID = index._Mol_ID;
      strcpy(_ResName, index._ResName);
      strcpy(_ChainID, index._ChainID);
      _ResNum = index._ResNum;
      strcpy(_ins_code, index._ins_code);
      _pos = index._pos;
}

int _BondIndex::operator<(const _BondIndex &index)
{
      if (_Mol_ID < index._Mol_ID) return 1;
      else if (_Mol_ID == index._Mol_ID) {
           if (strcmp(_ResName, index._ResName) < 0) return 1;
           else if (strcmp(_ResName, index._ResName) == 0) {
                if (strcmp(_ChainID, index._ChainID) < 0) return 1;
                else if (strcmp(_ChainID, index._ChainID) == 0) {
                     if (_ResNum < index._ResNum) return 1;
                     else if (_ResNum == index._ResNum) {
                          if (strcmp(_ins_code, index._ins_code) < 0) return 1;
                          else return 0;
                     } else return 0;
                } else return 0;
           } else return 0;
      } else return 0;
}

int _BondIndex::operator==(const _BondIndex &index)
{
      if (_Mol_ID == index._Mol_ID && !strcmp(_ResName, index._ResName) &&
          !strcmp(_ChainID, index._ChainID) && _ResNum == index._ResNum &&
          !strcmp(_ins_code, index._ins_code))
           return 1;
      else return 0;
}

int _BondIndex::operator!=(const _BondIndex &index)
{
      if (_Mol_ID != index._Mol_ID || strcmp(_ResName, index._ResName) ||
          strcmp(_ChainID, index._ChainID) || _ResNum != index._ResNum ||
          strcmp(_ins_code, index._ins_code))
           return 1;
      else return 0;
}

#endif
