/*
FILE:     cns.C
*/
/*
VERSION:  1.700
*/
/*
DATE:     7/13/2005
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2005 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
/*  a program to extract information form the CNS program */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "structure.h"
#include "harv.h"
#include "util.h"

# define MAXL 512
void  ndb_convert(char *str);
char **get_phase_set(FILE *fp, char *inpfile, int *nset);
void CNS_phasing_summary(FILE *fout, char *inpfile, char *method);
float **cns_phase_item(FILE *fp,  int *nsh);
void phase_set_head(FILE *fout, char *method, char *category);
extern PDBX_PHASING_DM_SHELL pdbx_phasing_dm_shell;
extern PDBX_PHASING_DM pdbx_phasing_dm;
extern PDBX_PHASING_MR pdbx_phasing_MR;
void rewrite_cns_category(FILE *fout, char **line ,long i, long nline,  const char *id);



void CNS_phase_file_assign(FILE *fout, char *inpfile,char *format,char *method)
{
    char str[512];
    FILE *fp;
    
    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s(routine:CNS_phase_file_assign)\n",
               inpfile);
        return;
    }
/* Note: if CIF, write everythings; if PDB write heavy atom cood.*/
    
    if(!strcmp_case(format, "CIF") || !strcmp_case(format, "PDB")){
        write_cif_or_pdb(fout,  inpfile, format,method);
        return;
    }
        
    while (fgets(str, sizeof str, fp) != NULL) {
        upperstr(str);
        
        if( pattern5(str, "==>}", "SITE.X_", ";", "", "") >0 ){
            fclose(fp);
            CNS_heavy_cood(fout, inpfile, method);
            break;
        }else if(strstr_space(str, "==== lack-of-closure expression") >0){
            fclose(fp);
            CNS_phasing_summary(fout, inpfile, method);
            break;
        }else if(strstr_space(str, "From Friedel(F)->Fref LOCs f' f\'' type")){
            fclose(fp);
            CNS_phasing_wave(fout, inpfile, method);
            break;
        }
    }
    
}

    
void CNS_phasing_DM(FILE *fout, char *inpfile, char *format,char *method)
/*extract information from the log file of density_modification.list file */
{

    char str[MAXL], *tmp=NULL;
    int num, nbin=0, n, i, t3, refln[NBIN], nref;
    float a, res_H[NBIN], res_L[NBIN], fom[NBIN], dphi[NBIN], t1,t2,t4, t5;
    FILE *fp;


    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s (routine:CNS_phasing_DM)\n",inpfile);
        return;
    }
    
    if(!strcmp_case(format, "CIF") || !strcmp_case(format, "PDB")){
        write_cif_or_pdb(fout,  inpfile, format,method);
        return;
    }

    
    while (fgets(str, sizeof str, fp) != NULL) {
        upperstr(str);
        
        if(pattern5(str, ">", "solvent modification method=", "", "", "" )){
            tmp = new char[strlen(str)];
            n =  sscanf(strstr(str,"=")+1,"%s", tmp);
            strcpy(pdbx_phasing_dm.method, tmp);
            delete [] tmp;
            
        }else if(pattern5(str, ">", "solvent mask type=", "", "", "") ){
            tmp = new char[strlen(str)];
            n =  sscanf(strstr(str,"=")+1,"%s", tmp);
            strcpy(pdbx_phasing_dm.mask_type,tmp);
            delete [] tmp;
            
        }else if(pattern5(str, "current high resolution limit=", "", "", "", "") ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.d_res_high =a;
            
        }else if(pattern5(str, "number of reflections phased= ", "", "", "", "") ){
            n = sscanf(strstr(str,"=")+1,"%d", &nref);
            if (n==1)pdbx_phasing_dm.reflns =nref;
            
        }else if(pattern5(str, "solvent mask volume (%)=", "", "", "", "") ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.solvent_percent_sol =a;
            
        }else if(pattern5(str, "mask radius=", "", "", "", "") ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.mask_radius =a;
            
        }else if(pattern5(str, "new solvent density=", "", "", "", "") ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.solvent_mean_density =a;
/*            
        }else if(pattern5(str, "RMS solvent density=", "", "", "", "") ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.solvent_mean_density_esd =a;

        }else if(pattern5(str, "average macromolecular density=", "", "", "", "") ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.protein_mean_density =a;

        }else if(pattern5(str, " RMS macromolecular density=", "", "", "", "") ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.protein_mean_density_esd =a;
*/            
        }else if(strstr_space(str,  " mean FOM=") >0 ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.fom =a;
            
        }else if(strstr_space(str, "delta phi(initial)(degrees)=") >0 ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.delta_phi_initial =a;
            
        }else if(strstr_space(str, "delta phi(last)(degrees)=") >0 ){
            n = sscanf(strstr(str,"=")+1,"%f", &a);
            if (n==1)pdbx_phasing_dm.delta_phi_final =a;
        }
        
    }


    rewind(fp);
    while (fgets(str, sizeof str, fp) != NULL) {
        if (pattern5(str, "bin", "|", "RESOLUTION RANGE", "refl", "|") >0 ){
            n=0;
            while (fgets(str, sizeof str, fp) != NULL){
                num=sscanf(str,"%*s %f %f %d %f  %f",&t1, &t2, &t3, &t4, &t5);
                if(num == 5){
                    res_H[n] = t1;
                    res_L[n] = t2;
                    refln[n] = t3;
                    fom[n] = t4;
                    dphi[n] = t5;
                    n++;
                    if(n>=NBIN-1){
                        printf("The LOG file (%s) may not be checked\n", inpfile);
                        return;
                    }
                }
                if(num!=5 && n !=0 ) {
                    nbin = n;
                    n=0;
                    break;
                }
            }
        }
               
    }
    fclose(fp);
    
    pdbx_phasing_dm_shell.number_bin = nbin;
    
    for(i=0; i<nbin; i++){
        pdbx_phasing_dm_shell.d_res_high[i] = res_H[i];
        pdbx_phasing_dm_shell.d_res_low[i] = res_L[i];
        pdbx_phasing_dm_shell.reflns[i] = refln[i];
        pdbx_phasing_dm_shell.fom[i] = fom[i];
        pdbx_phasing_dm_shell.delta_phi_final[i] = dphi[i];
    }
   
}


void CNS_phasing_wave(FILE *fout, char inpfile[], char method[])
/* extract wavelength */
{
    FILE *fp;

    char str[MAXL], *tmp=NULL, **nwave=NULL, type[MAXL];
    int i, j;
    float a1, a2;
    
    if(!strcmp_case(method,"MIR") || !strcmp_case(method,"SIR"))return;
    

    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s (routine:CNS_phasing_wave)\n",
               inpfile);
        return;
    }
    
    i=0;
    nwave = new char*[50];
    while (fgets(str, sizeof str, fp) != NULL) {
        if(strstr_space(str, "From Friedel(F)->Fref LOCs     f'             f''    type")) {
            while (fgets(str, sizeof str, fp) != NULL) {
                if(is_space_line(str)==0 || strstr(str, "=========")) continue;
                if(pattern5(str,"wavelength ", "(",")",".",".")){
                    tmp = get_substr(str, ")", "\n");
                    if(sscanf(tmp, "%f %f %s", &a1, &a2, type)==3){
                        nwave[i] = new char [strlen(str)];
                        sprintf(nwave[i], "%.3f %.3f  %s",a1, a2, type);
                        i++;
                        if(i>=20){
                            printf("\nWarning! There are too wavelengthes!\n");
                            fclose(fp);  
                            return;
                        }
                    }
                    delete [] tmp;
                }else
                    break;
            }
        }
    }
    
    if(i>0){
        
        fprintf(fout,"\n\n#++++++ MAD wavelength+++++++++++++\n" );    
        fprintf(fout,"loop_\n");
        fprintf(fout,"_phasing_%s_set.expt_id\n",method);
        fprintf(fout,"_phasing_%s_set.clust_id\n",method);
        fprintf(fout,"_phasing_%s_set.set_id\n",method);
        fprintf(fout,"_phasing_%s_set.pdbx_f_prime_refined\n",method);
        fprintf(fout,"_phasing_%s_set.pdbx_f_double_prime_refined\n",method);
        fprintf(fout,"_phasing_%s_set.pdbx_atom_type\n",method);
        for(j=0;j<i; j++){
            fprintf(fout,"1 '%d wavelength' %d  %s\n", i,  j+1,   nwave[j]);
        }
        
    }
    
    free_memory_2d(nwave, i-1);
    
}

void CNS_heavy_cood(FILE *fout, char inpfile[], char method[])
/* extract the Heavy atom coordinates */
{
    FILE *fp;
    long i, n[10], yes=0;
    char str[MAXL], substr[MAXL], atomtype[80],  meth[80];
    
    
    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s (routine:CNS_heavy_cood)\n",inpfile);
        return;
    }
    
    fprintf(fout,"\n\n### %s heavy atom coordinates from CNS ####\n", method);

    while (fgets(str, sizeof str, fp) != NULL) {
        upperstr(str);
        if(pattern5(str, "{===>}", "SITE.TYPE_", ";", "", "") >0 ){
            yes=1;
            break;
        }
    }
    if(yes<=0) return;
    
    rewind(fp);
    fprintf(fout,"loop_\n");
    
    if(!strcmp_case(method,"MAD")){
        strcpy(meth,"_pdbx_phasing_MAD_set_site");
        fprintf(fout,"%s.id\n",meth);
    } else if(!strcmp_case(method,"MIR")){
        strcpy(meth,"_phasing_MIR_der_site");
        fprintf(fout,"%s.der_id\n",meth);
    }
    
    fprintf(fout,"%s.atom_type_symbol\n",meth);
    fprintf(fout,"%s.Cartn_x\n",meth);
    fprintf(fout,"%s.Cartn_y\n",meth);
    fprintf(fout,"%s.Cartn_z\n",meth);
    fprintf(fout,"%s.B_iso\n",meth);
    fprintf(fout,"%s.Occupancy\n",meth);

    for(i=0; i<10; i++) n[i]=0;
    
    while (fgets(str, sizeof str, fp) != NULL) {
        upperstr(str);
        if(pattern5(str, "{===>}", "site.","=",";", "")  ){

            if(strstr(str, "SITE.TYPE_")){
                n[0]++;
                
                get_data_set_id(str, "SITE.TYPE_", ";", substr);
                get_data_set_id(substr, "\"", "\"", atomtype);
                rid_of_space(atomtype);
                if(strlen(atomtype)<=0) strcpy(atomtype, ".");
                fprintf(fout,"%ld %s  ",n[0], atomtype);
            }
            
            if(strstr(str, "SITE.X_")){
                write_CNS_heavy_xyz(fout, str, "SITE.X_", ";");
                n[1]++;
            }
            if(strstr(str, "SITE.Y_")){
                write_CNS_heavy_xyz(fout, str, "SITE.Y_", ";");
                n[2]++;
            }
            if(strstr(str, "SITE.Z_")){
                write_CNS_heavy_xyz(fout, str, "SITE.Z_", ";");
                n[3]++;
            }
            if(strstr(str, "SITE.B_")){
                write_CNS_heavy_xyz(fout, str, "SITE.B_", ";");
                n[4]++;
            }
            if(strstr(str, "SITE.Q_")){
                write_CNS_heavy_xyz(fout, str, "SITE.Q_", ";");
                n[5]++;
            }
        }

        if(strstr(str, "{") && strstr(str, "}") && strstr(str, "CHOICE:")&&
           (strstr(str, "REFINE")||strstr(str, "FIX")||strstr(str, "IGNORE"))){
            if(n[0]==n[1] && n[0]==n[2] && n[0]==n[3] && n[0]==n[4] &&
               n[0]==n[5]){
                if(n[0]>0) fprintf(fout,"\n");
            }else{
                fprintf(fout,"? ? ? ? ? ? ? \n");
            }
        }
        
    }
    if(n[0]<=0 || n[1]<=0) fprintf(fout,"? ? ? ? ? ? ? \n");
    
}

void write_CNS_heavy_xyz(FILE *fout, char *str, const char *start, const char *end)
{
    char *substr=NULL, *tmp=NULL;

    substr = new char[strlen(str)+1];
    tmp = new char[strlen(str)+1];

    get_data_set_id(str, start, end, substr);
    
    if(strstr(substr, "=")){
        strcpy(tmp, strstr(substr,"=")+1);
        rid_of_space(tmp);
        fprintf(fout,"%s  ",tmp);
    }else
        fprintf(fout,".  ");
    
    delete [] substr;
    delete [] tmp;

}


void CNS_fom(FILE *fout, char inpfile[], char method[])
/* get the figure of merit for global phase set from CNS */
{
    char str[512],meth[80];
    int nf, n, nbin, k=0;
    float v1,v2,v4,v5,v6;
    FILE *fp;
    
    const char dash[]= "---------------------------------------";

        
    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s (routine:CNS_fom)\n",inpfile);
        return;
    }

    while (fgets(str, sizeof str, fp) != NULL) { /* for overall shell*/
        if (strstr_space(str,"Figure of merit for global phase set") >0 ){
           
            while (fgets(str, sizeof str, fp) != NULL){
                if(pattern5(str, "bin", "resolution range", "refl", "|" ,"") >0 )
                    break;
            }
            
            if(!strcmp_case(method,"MAD")){
                strcpy(meth,"_pdbx_phasing_MAD_shell");
                
                fprintf(fout,"\nloop_\n");
                fprintf(fout,"%s.d_res_high \n",meth);
                fprintf(fout,"%s.d_res_low  \n",meth);
                fprintf(fout,"%s.Reflns    \n",meth);
                fprintf(fout,"%s.fom_centric \n",meth);
                fprintf(fout,"%s.fom_acentric \n",meth);
                fprintf(fout,"%s.fom  \n",meth);
            }
            else if(!strcmp_case(method,"MIR")){
                strcpy(meth,"_phasing_MIR_shell");
            
                fprintf(fout,"\nloop_\n");
                fprintf(fout,"%s.d_res_high \n",meth);
                fprintf(fout,"%s.d_res_low \n",meth);
                fprintf(fout,"%s.Reflns  \n",meth);
                fprintf(fout,"%s.fom_centric \n",meth);
                fprintf(fout,"%s.fom_acentric \n",meth);
                fprintf(fout,"%s.fom  \n",meth);
            }
            
            k=0;
            while (fgets(str, sizeof str, fp) != NULL){
                if(pattern5(str, "bin", "resolution range", "ref", "" ,"") >0)
                    break;
                n=sscanf(str, "%d %f %f %d %f %f %f",&nbin,
                     &v1, &v2, &nf, &v4, &v5, &v6 );
                
                if(n==7) {
                    k++;
                    fprintf(fout,"%.2f %.2f %d %.4f %.4f %.4f\n",
                            v1, v2, nf, v4, v5, v6);
                }
            }
            if(k<=0) fprintf(fout," ? ? ? ? ? ?\n");
            break;
            
        }
    }
    
    while (fgets(str, sizeof str, fp) != NULL){  /*overall*/
        n=sscanf(str, "%d %f %f %d %f %f %f",&nbin,
                 &v1, &v2, &nf, &v4, &v5, &v6 );
        if(strstr(str, dash)) break;
        if(n==7){
            if(!strcmp_case(method,"MAD")){
                strcpy(meth,"_phasing_MAD");
            
                fprintf(fout,"\n\n");
                fprintf(fout,"%s.entry_id  '%s'\n",meth,DATA_BLOCK);
                fprintf(fout,"%s.pdbx_d_res_high  %.3f\n",meth,v1);
                fprintf(fout,"%s.pdbx_d_res_low  %.3f\n",meth,v2);
                fprintf(fout,"%s.pdbx_Reflns  %d\n",meth,nf);
                fprintf(fout,"%s.pdbx_fom_centric  %.3f\n",meth,v4);
                fprintf(fout,"%s.pdbx_fom_acentric  %.3f\n",meth,v5);
                fprintf(fout,"%s.pdbx_fom  %.3f\n",meth,v6);
            }
            else if(!strcmp_case(method,"MIR")){
                strcpy(meth,"_phasing_MIR");
                
                fprintf(fout,"\n\n");
                fprintf(fout,"%s.entry_id  '%s'\n",meth,DATA_BLOCK);
                fprintf(fout,"%s.d_res_high  %.3f\n",meth,v1);
                fprintf(fout,"%s.d_res_low  %.3f\n",meth,v2);
                fprintf(fout,"%s.Reflns  %d\n",meth,nf);
                fprintf(fout,"%s.fom_centric  %.3f\n",meth,v4);
                fprintf(fout,"%s.fom_acentric  %.3f\n",meth,v5);
                fprintf(fout,"%s.fom  %.3f\n",meth,v6);
            }
            break;
        }
    }
    fclose(fp);
}
    
    
void CNS_final_struct_ref(FILE *fout, char *inpfile, char *id, char *method)
/* only get the coordinates of the final structure */
{

    char *diags=NULL, *blockId=NULL, *fnx=(char *) "cns_mmcif_tmp1";
    char  **line=NULL;
    char **atom_id=NULL;
    char **atom_type_symbol=NULL;
    char **type_symbol=NULL;
    char **label_atom_id=NULL;
    char **label_comp_id=NULL;
    char **label_seq_id=NULL;
    char **label_asym_id=NULL;
    char **auth_seq_id=NULL;
    char **label_alt_id=NULL;
    char **Cartn_x=NULL;
    char **Cartn_y=NULL;
    char **Cartn_z=NULL;
    char **occupancy=NULL;
    char **B_iso_or_equiv=NULL;
    char tmp1[256], tmp2[256];
    

    long n1=0, n2=0, n3=0, n4=0, n5=0, n6=0, n7=0, n8=0, n9=0;
    long  n10=0, n11=0, n12=0,n13=0,n14=0;
    int  i, nline=0;
    
        
    if(!strcmp_case(id, "PDB")){
       pdb_2_cif(fout,  inpfile);
       return;
       
    }else if (!strcmp_case(id, "CIF")){
        
        
        if(is_cif(inpfile)<50) {
            printf("Warning! File (%s) is not the mmCIF file for coordinates\n", inpfile);
            return;
        }
    }
    
    CifFileObj * fobjR = NULL;
    fobjR = new CifFileObj(fnx, WRITE_MODE, 80, "?", 1);
    fobjR->Read(inpfile,diags);
    if (diags != NULL) fprintf(stderr, "Diags for file %s: %s\n",inpfile,diags);
    fobjR->CloseFile();
    if (fobjR) delete fobjR;
    fobjR = new CifFileObj(fnx, READ_MODE);
    blockId = fobjR->GetBlockName(0);


    atom_id = get_attribute_values(fobjR, blockId,"atom_site", "id", &n1);
    atom_type_symbol = get_attribute_values(fobjR, blockId,"atom_site", "atom_type_symbol", &n2);
    type_symbol = get_attribute_values(fobjR, blockId,"atom_site", "type_symbol", &n14);
    label_atom_id = get_attribute_values(fobjR, blockId,"atom_site", "label_atom_id", &n3);
    label_comp_id = get_attribute_values(fobjR, blockId,"atom_site", "label_comp_id", &n4);
    label_seq_id = get_attribute_values(fobjR, blockId,"atom_site", "label_seq_id", &n5);
    label_asym_id = get_attribute_values(fobjR, blockId,"atom_site", "label_asym_id", &n6);
    auth_seq_id = get_attribute_values(fobjR, blockId,"atom_site", "auth_seq_id", &n7);
    label_alt_id = get_attribute_values(fobjR, blockId,"atom_site", "label_alt_id", &n8);
    Cartn_x = get_attribute_values(fobjR, blockId,"atom_site", "Cartn_x", &n9);
    Cartn_y = get_attribute_values(fobjR, blockId,"atom_site", "Cartn_y", &n10);
    Cartn_z = get_attribute_values(fobjR, blockId,"atom_site", "Cartn_z", &n11);
    occupancy = get_attribute_values(fobjR, blockId,"atom_site", "occupancy", &n12);
    B_iso_or_equiv = get_attribute_values(fobjR, blockId,"atom_site", "B_iso_or_equiv", &n13);
    
   
    if(n10>50 ){
        fprintf(fout,"%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n",
                "loop_",
                "_atom_site.id",
                "_atom_site.type_symbol",
                "_atom_site.auth_atom_id",
                "_atom_site.label_atom_id",
                "_atom_site.label_comp_id",
                "_atom_site.label_seq_id",
                "_atom_site.label_asym_id",
                "_atom_site.auth_seq_id",
                "_atom_site.label_alt_id",
                "_atom_site.Cartn_x",
                "_atom_site.Cartn_y",
                "_atom_site.Cartn_z",
                "_atom_site.occupancy",
                "_atom_site.B_iso_or_equiv");
        for(i=0; i<n10; i++){

            (atom_id) ? fprintf(fout," '%s' ",atom_id[i]) : fprintf(fout, " . ");
                
            if (atom_type_symbol) {
                fprintf(fout," '%s' ",atom_type_symbol[i]) ;
            }else if (type_symbol) {
                fprintf(fout," '%s' ",type_symbol[i]) ;
            }else
                fprintf(fout, " . ");
            
            if(label_atom_id) {
                fprintf(fout," '%s' ",label_atom_id[i]);
                
                replace_char(label_atom_id[i], '\'', '*');
                
                fprintf(fout," '%s' ",label_atom_id[i]) ;
                
            }else
                fprintf(fout, " .  .");
            
            (label_comp_id) ? fprintf(fout," '%s' ",label_comp_id[i]) : fprintf(fout, " . ");
            (label_seq_id) ? fprintf(fout," '%s' ",label_seq_id[i]) : fprintf(fout, " . ");
            (label_asym_id) ? fprintf(fout," '%s' ",label_asym_id[i]) : fprintf(fout, " . ");
            (auth_seq_id) ? fprintf(fout," '%s' ",auth_seq_id[i]) : fprintf(fout, " . ");
            (label_alt_id) ? fprintf(fout," '%s' ",label_alt_id[i]) : fprintf(fout, " . ");
            (Cartn_x) ? fprintf(fout," '%s' ",Cartn_x[i]) : fprintf(fout, " . ");
            (Cartn_y) ? fprintf(fout," '%s' ",Cartn_y[i]) : fprintf(fout, " . ");
            (Cartn_z) ? fprintf(fout," '%s' ",Cartn_z[i]) : fprintf(fout, " . ");
            (occupancy) ? fprintf(fout," '%s' ",occupancy[i]) : fprintf(fout, " . ");
            (B_iso_or_equiv) ? fprintf(fout," '%s' ",B_iso_or_equiv[i]) : fprintf(fout, " . ");
            
//            printf("hello=%s %d %ld %s\n", type_symbol[i], i, n10, Cartn_x[i]);

            
            fprintf(fout,"\n");
        }
    }
    if(atom_id)  free_memory_2d(atom_id, n1);
    if(atom_type_symbol) free_memory_2d(atom_type_symbol, n2);
    if(type_symbol) free_memory_2d(type_symbol, n14);
    if(label_atom_id) free_memory_2d(label_atom_id, n3);
    if(label_comp_id) free_memory_2d(label_comp_id, n4);
    if(label_seq_id) free_memory_2d(label_seq_id, n5);
    if(label_asym_id) free_memory_2d(label_asym_id, n6);

            
    if(auth_seq_id) free_memory_2d(auth_seq_id, n7);
    if(label_alt_id) free_memory_2d(label_alt_id, n8);
    if(Cartn_x) free_memory_2d(Cartn_x, n9);
    if(Cartn_y) free_memory_2d(Cartn_y, n10);
    if(Cartn_z) free_memory_2d(Cartn_z, n11);
    if(occupancy) free_memory_2d(occupancy, n12);
    if(B_iso_or_equiv) free_memory_2d(B_iso_or_equiv, n13);


// for all other statistics
       
    line = get_lines_from_file(inpfile, &nline);
    if(nline<=0) return;

    for(i=0; i<nline-1; i++){
        sscanf(line[i],"%s", tmp1);
        sscanf(line[i+1],"%s", tmp2);
        
        if(!strncmp(tmp1, "_cell.", 6) && !strncmp(tmp2, "_cell.", 6)){
            
            rewrite_cns_category(fout, line , i, nline,  "_cell.");
            
        }else if(!strncmp(tmp1, "_symmetry.", 10) && !strncmp(tmp2, "_symmetry.", 10)){
            
            rewrite_cns_category(fout, line , i, nline,  "_symmetry.");


        }else if(!strncmp(tmp1, "_atom_sites.", 12) && !strncmp(tmp2, "_atom_sites.", 12)){
            
            rewrite_cns_category(fout, line , i, nline,  "_atom_sites.");
            
     
        }else if(!strncmp(tmp1, "_reflns.", 8) && !strncmp(tmp2, "_reflns.", 8)){
            
            rewrite_cns_category(fout, line , i, nline,  "_reflns.");

        }else if(!strncmp(tmp1, "_refine.", 8) && !strncmp(tmp2, "_refine.", 8)){
            
            rewrite_cns_category(fout, line , i, nline,  "_refine.");
            

        }else if(!strncmp(tmp1, "_refine_analyze.", 16) && !strncmp(tmp2, "_refine_analyze.", 16)){
            
            rewrite_cns_category(fout, line , i, nline,  "_refine_analyze.");

        }else if(!strncmp(tmp1, "loop_", 5) && !strncmp(tmp2, "_refine_ls_shell.", 17)){
            
            rewrite_cns_category(fout, line , i, nline,  "loop_");

        }else if(!strncmp(tmp1, "loop_", 5) && !strncmp(tmp2, "_refine_ls_restr.", 17)){
            
            rewrite_cns_category(fout, line , i, nline,  "loop_");
            
        }
    }
     if(line) free_memory_2d(line, nline);
    delete_file( "cns_mmcif_tmp1");
    
}

void rewrite_cns_category(FILE *fout, char **line, long i, long nline,  const char *id)
{
    long j;
    char entry[256], tmp[512];

    if(!strcmp(id,"loop_")){
        for(j=i; j<nline; j++){
            strcpy(tmp, line[j]);
            if(tmp[0] == '#' || !strncmp(tmp,"%ESDERR-WRN:", 12)) break;
                
            if(strstr(tmp, "loop_"))
                fprintf(fout,"loop_\n");
            else
                fprintf(fout,"%s",tmp);
        }
        
    }else{
        
        strcpy(entry,"");
        strcat(entry,id);
        strcat(entry,"entry_id");
    

        for(j=i; j<nline; j++){
//            if(!strcmp(id, "_refine_analyze.")){
//                printf("hello=%4ld %4ld %s\n",j, nline,line[j]);
//            }
            
            strcpy(tmp, line[j]);
            if(tmp[0] == '#' ||  !strncmp(tmp,"%ESDERR-WRN:", 12)) break;
                
            if(strstr(tmp, entry)){
                fprintf(fout,"%s  '%s'\n",entry,DATA_BLOCK);
            }else
                fprintf(fout,"%s",tmp);

        }
        
    }
    
}

    
void delete_prime(char *str)
/* delete the prime and convert it to  * if it is double prime */
{
    int len, i;
    char temp[256];
    

    len = strlen(str);
    for(i=0; i<len; i++){
        temp[i]=str[i];

        if(str[i] == '\'' && str[i+1] != '\''){
            temp[i]=' ';
        }else if(str[i] == '\'' && str[i+1] == '\''){            
            temp[i]='*';
        }

        if(i>5){
            if(str[i-3]==' ' && toupper(str[i-2])=='A'&&toupper(str[i-1])=='D'&&
               toupper(str[i])=='E' && str[i+1]==' '){
                temp[i-2]=' ';
                temp[i-1]=' ';
                temp[i]='A';
            }else if (str[i-3]==' ' && toupper(str[i-2])=='G'&&toupper(str[i-1])=='U'&&
                      toupper(str[i])=='A' && str[i+1]==' '){      
                temp[i-2]=' ';
                temp[i-1]=' ';
                temp[i]='G';
            }else if (str[i-3]==' ' && toupper(str[i-2])=='C'&&toupper(str[i-1])=='Y'&&
                      toupper(str[i])=='T' && str[i+1]==' '){      
                temp[i-2]=' ';
                temp[i-1]=' ';
                temp[i]='C';
            }else if (str[i-3]==' ' && toupper(str[i-2])=='T'&&toupper(str[i-1])=='H'&&
                      toupper(str[i])=='Y' && str[i+1]==' '){      
                temp[i-2]=' ';
                temp[i-1]=' ';
                temp[i]='T';
            }else if (str[i-3]==' ' && toupper(str[i-2])=='U'&&toupper(str[i-1])=='R'&&
                      toupper(str[i])=='A' && str[i+1]==' '){      
                temp[i-2]=' ';
                temp[i-1]=' ';
                temp[i]='U';

            }
        }
                
            
    }
    temp[len] =  '\0';
    
    strcpy(str, temp);
    
}

        
    
void  ndb_convert(char *str)
{
    int n=0, i;
    char tmp[512];

    strcpy(tmp, str);
    upperstr(tmp);
    if(!strstr(tmp, " ADE ") && !strstr(tmp, " GUA ") &&
       !strstr(tmp, " CYT ") && !strstr(tmp, " THY ") &&
       !strstr(tmp, " URI ") ) return;
    

    n=strlen(str);

    for(i=0;i<n-5;i++){
        if(str[i]==' ' && toupper(str[i+1])=='A' && toupper(str[i+2])=='D'
           && toupper(str[i+3])=='E' && str[i+4]==' '){
            str[i] = ' ';
            str[i+1] = 'A';
            str[i+2] = ' '; str[i+3] = ' '; str[i+4] = ' ';
            i=i+4;
        }else if (str[i]==' ' && toupper(str[i+1])=='G' && toupper(str[i+2])=='U'
                  && toupper(str[i+3])=='A' && str[i+4]==' '){
            str[i] = ' ';
            str[i+1] = 'G';
            str[i+2] = ' '; str[i+3] = ' '; str[i+4] = ' ';
            i=i+4;

        }else if (str[i]==' ' && toupper(str[i+1])=='C' && toupper(str[i+2])=='Y'
                  && toupper(str[i+3])=='T' && str[i+4]==' '){
            str[i] = ' ';
            str[i+1] = 'C';
            str[i+2] = ' '; str[i+3] = ' '; str[i+4] = ' ';
            i=i+4;
        }else if (str[i]==' ' && toupper(str[i+1])=='T' && toupper(str[i+2])=='H'
                  && toupper(str[i+3])=='Y' && str[i+4]==' '){
            str[i] = ' ';
            str[i+1] = 'T';
            str[i+2] = ' '; str[i+3] = ' '; str[i+4] = ' ';
            i=i+4;
        
        }else if (str[i]==' ' && toupper(str[i+1])=='U' && toupper(str[i+2])=='R'
                  && toupper(str[i+3])=='A' && str[i+4]==' '){
            str[i] = ' ';
            str[i+1] = 'U';
            str[i+2] = ' '; str[i+3] = ' '; str[i+4] = ' ';
            i=i+4;
        }
        
    }
//    printf("%s",str);
    
    
}

void CNS_phasing_summary(FILE *fout, char *inpfile, char *method)
/* extract information from the phase refinement (phase.summary) */
{
    char **phase_set=NULL, str[512], tmp[512] ;
    float **r_cullis=NULL, **r_kraut=NULL, **loc=NULL, **ppower=NULL, **fom=NULL;
    int i, j=0, nset, nsh;
    FILE *fp;

    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s (routine:CNS_phasing)\n",inpfile);
        return;
    }

    fprintf(fout,"\n\n#++++++ %s CNS phasing summary+++++++++++++\n",method);

    CNS_fom(fout,  inpfile, method);
    
    phase_set = get_phase_set(fp, inpfile,  &nset);
    float (*items_all)[20]=new float [nset+1][20]; /*  overall property*/
    
    for(i=0; i<nset; i++){
        
        while(fgets(str, sizeof str, fp) != NULL){
            if(pattern5(str,"====","lack-of-closure","expression", ": ","")){
                strcpy(tmp, strstr(str,": ")+2);    
                rid_of_space(tmp);
                if(!strcmp_case(tmp, phase_set[i]))
                    break;
            }
        }
        if(!strcmp_case(tmp, phase_set[i])){
//            printf("expression= %d %s\n", i, phase_set[i]);
                
            while(fgets(str, sizeof str, fp) != NULL){
            
                if(strstr_space(str, " generalized Cullis R-value")){
                    r_cullis = cns_phase_item(fp, &nsh);
                }else if(strstr_space(str, " Kraut R-value")){
                    r_kraut = cns_phase_item(fp, &nsh);
                }else if(strstr_space(str, " std of lack-of-closure")){
                    loc = cns_phase_item(fp, &nsh);
                }else if(strstr_space(str, " phasing power")){
                    ppower = cns_phase_item(fp,  &nsh);
                }else if(strstr_space(str, " figure-of-merit")){
                    fom = cns_phase_item(fp,  &nsh);
                }else if(strstr_space(str, "== lack-of-closure expression:")||
                         strstr_space(str, "== lack-of-closure expression :")){
                    break;
                }
                if(strstr_space(str, "== lack-of-closure expression:")||
                   strstr_space(str, "== lack-of-closure expression :")||
                   strstr_space(str,"figure of merit after final cycle"))
                    break;
            }
            rewind(fp);
            if(i==0 && nsh>1 && r_cullis[0][1] >0)
                phase_set_head(fout, method, (char *) "set_shell");
            if( r_cullis[0][1]<=0 ) continue;
            
            for(j=0; j<nsh-1; j++){
                fprintf(fout,"%s %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f ",
                       phase_set[i], r_cullis[j][0], r_cullis[j][1],
                       r_cullis[j][2], r_cullis[j][3], r_cullis[j][4],
                       r_kraut[j][2], r_kraut[j][3], r_kraut[j][4]);
                
                fprintf(fout,"%.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n", 
                       loc[j][2], loc[j][3], loc[j][4],
                       ppower[j][2], ppower[j][3], ppower[j][4],
                       fom[j][2], fom[j][3], fom[j][4]);
            }
        }
        j=nsh-1;
        if(r_cullis[j][0]>0 && r_cullis[j][1]>0){
            
            items_all[i][0]= r_cullis[j][0];
            items_all[i][1]= r_cullis[j][1];
            items_all[i][2]= r_cullis[j][2];
            items_all[i][3]= r_cullis[j][3];
            items_all[i][4]= r_cullis[j][4];
            items_all[i][5]= r_kraut[j][2];
            items_all[i][6]= r_kraut[j][3];
            items_all[i][7]= r_kraut[j][4];
            items_all[i][8]= loc[j][2];
            items_all[i][9]= loc[j][3];
            items_all[i][10]= loc[j][4];
            items_all[i][11]= ppower[j][2];
            items_all[i][12]= ppower[j][3];
            items_all[i][13]= ppower[j][4];
            items_all[i][14]= fom[j][2];
            items_all[i][15]= fom[j][3];
            items_all[i][16]= fom[j][4];
        }
        
    }
    if(r_cullis[j][0]<=0 ||  r_cullis[j][1]<=0) return;
        
    phase_set_head(fout, method,(char *) "set");
    for(i=0; i<nset; i++){
        if(!strcmp_case(method,"MIR")){
            fprintf(fout,"%s %d  1 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f ",phase_set[i],i+1,
                    items_all[i][0],items_all[i][1],items_all[i][2],items_all[i][3],
                    items_all[i][4],items_all[i][5],items_all[i][6],items_all[i][7]);
            
        }else {
            fprintf(fout,"%s %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f ",phase_set[i],
                    items_all[i][0],items_all[i][1],items_all[i][2],items_all[i][3],
                    items_all[i][4],items_all[i][5],items_all[i][6],items_all[i][7]);
        }
        
        
        fprintf(fout,"%.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n", 
                items_all[i][8],items_all[i][9],items_all[i][10],
                items_all[i][11],items_all[i][12],items_all[i][13],
                items_all[i][14],items_all[i][15],items_all[i][16]);
    }
    delete [] r_cullis; delete [] r_kraut; delete []loc;
    delete []ppower; delete []fom; delete []items_all;
    
}

float **cns_phase_item(FILE *fp,  int *nsh)
/* for each item (r_cullis ..), only phase set is extracted.
   Ending with --------
*/
{
    char str[512];
    int n, ns=0 ;
    float **shell=NULL, sh0,sh1,sh2, sh3,sh4;
    const char dash[]= "------------------------------------------";

    shell = new float *[NBIN];
    
    while(fgets(str, sizeof str, fp) != NULL){
        if(strstr_space(str,"phase set")){
            break;
        }
    }
        
    while(fgets(str, sizeof str, fp) != NULL){
        if(strstr(str, dash)){
            break;
        }
        
        n=sscanf(str, "%*d %f %f %*f %f %f %f", &sh0,&sh1,&sh2,&sh3,&sh4);
        if(n==5){
            shell[ns]=new float[6];
            shell[ns][0]=sh0;
            shell[ns][1]=sh1;
            shell[ns][2]=sh2;
            shell[ns][3]=sh3;
            shell[ns][4]=sh4;
            
            if(ns>=NBIN-1){
                printf("Statistics for resolution shell is not extracted!\n");
                *nsh =0;
                return (shell);
            }
            ns++;
        }
    }
    *nsh = ns;
    return (shell);
    
}

char **get_phase_set(FILE *fp, char *inpfile, int *nset)
/* get the phase set */
{
    char str[512],tmp[512], **strings=NULL;
    int  n=0, nphs=40; //max 40 derivatives
    
    strings = new char *[nphs];
    while(fgets(str, sizeof str, fp) != NULL){
        if(pattern5(str,"====", "lack-of-closure", "expression", ": ", "")){
            strcpy(tmp, strstr(str,": ")+2);
            strings[n] = new char[strlen(tmp)+1];
            rid_of_space(tmp);
            strcpy(strings[n], tmp);
            
            if(n>=nphs-1){
                printf("The LOG file (%s) may not be checked.\n", inpfile);
                *nset =0;
                return (strings);
            }
            n++;
        }
    }
    *nset = n;
    rewind(fp);
    return (strings);
}

void phase_set_head(FILE *fout, char *method, char *category)
/* print head */
{
    char meth[60];

    
    fprintf(fout,"\nloop_\n");
    
    if(!strcmp_case(method,"MAD")){
        if(!strcmp_case(category, "set_shell"))
            strcpy(meth,"_pdbx_phasing_MAD_set_shell");
        else 
            strcpy(meth,"_pdbx_phasing_MAD_set");

        fprintf(fout,"%s.id \n",meth);
        fprintf(fout,"%s.d_res_high \n",meth);
        fprintf(fout,"%s.d_res_low \n",meth);
        fprintf(fout,"%s.R_cullis_centric \n",meth);
        fprintf(fout,"%s.R_cullis_acentric \n",meth);
        fprintf(fout,"%s.R_cullis \n",meth);
        fprintf(fout,"%s.R_kraut_centric \n",meth);
        fprintf(fout,"%s.R_kraut_acentric \n",meth);
        fprintf(fout,"%s.R_kraut \n",meth);
        fprintf(fout,"%s.loc_centric \n",meth);
        fprintf(fout,"%s.loc_acentric \n",meth);
        fprintf(fout,"%s.loc \n",meth);
        fprintf(fout,"%s.power_centric \n",meth);
        fprintf(fout,"%s.power_acentric \n",meth);
        fprintf(fout,"%s.power \n",meth);
        fprintf(fout,"%s.fom_centric \n",meth);
        fprintf(fout,"%s.fom_acentric \n",meth);
        fprintf(fout,"%s.fom \n",meth);

    }else if(!strcmp_case(method,"MIR")){

        if(!strcmp_case(category, "set_shell")){
            strcpy(meth,"_phasing_MIR_der_shell");
            fprintf(fout,"%s.der_id \n",meth);
            
            fprintf(fout,"%s.d_res_high \n",meth);
            fprintf(fout,"%s.d_res_low \n",meth);
            fprintf(fout,"%s.pdbx_R_cullis_centric \n",meth);
            fprintf(fout,"%s.pdbx_R_cullis_acentric \n",meth);
            fprintf(fout,"%s.R_cullis \n",meth);
            fprintf(fout,"%s.pdbx_R_kraut_centric \n",meth);
            fprintf(fout,"%s.pdbx_R_kraut_acentric \n",meth);
            fprintf(fout,"%s.R_kraut \n",meth);
            fprintf(fout,"%s.pdbx_loc_centric \n",meth);
            fprintf(fout,"%s.pdbx_loc_acentric \n",meth);
            fprintf(fout,"%s.loc \n",meth);
            fprintf(fout,"%s.pdbx_power_centric \n",meth);
            fprintf(fout,"%s.pdbx_power_acentric \n",meth);
            fprintf(fout,"%s.power \n",meth);
            fprintf(fout,"%s.pdbx_fom_centric \n",meth);
            fprintf(fout,"%s.pdbx_fom_acentric \n",meth);
            fprintf(fout,"%s.fom \n",meth);
        

        }else{
            
            strcpy(meth,"_phasing_MIR_der");
            fprintf(fout,"%s.id \n",meth);
            fprintf(fout,"%s.der_set_id \n",meth);
            fprintf(fout,"%s.native_set_id \n",meth);
            
            fprintf(fout,"%s.d_res_high \n",meth);
            fprintf(fout,"%s.d_res_low \n",meth);
            fprintf(fout,"%s.R_cullis_centric \n",meth);
            fprintf(fout,"%s.R_cullis_acentric \n",meth);
            fprintf(fout,"%s.pdbx_R_cullis \n",meth);
            fprintf(fout,"%s.pdbx_R_kraut_centric \n",meth);
            fprintf(fout,"%s.pdbx_R_kraut_acentric \n",meth);
            fprintf(fout,"%s.pdbx_R_kraut \n",meth);
            fprintf(fout,"%s.pdbx_loc_centric \n",meth);
            fprintf(fout,"%s.pdbx_loc_acentric \n",meth);
            fprintf(fout,"%s.pdbx_loc \n",meth);
            fprintf(fout,"%s.power_centric \n",meth);
            fprintf(fout,"%s.power_acentric \n",meth);
            fprintf(fout,"%s.pdbx_power \n",meth);
            fprintf(fout,"%s.pdbx_fom_centric \n",meth);
            fprintf(fout,"%s.pdbx_fom_acentric \n",meth);
            fprintf(fout,"%s.pdbx_fom \n",meth);
        }
        
        
    }
}


void CNS_mr(FILE *fout, char *filename, char *format, char *method)
{
    char str[512], substr[80];
    int n;
    float resL, resH, cc, pack,a1,a2,a3,a4,a5,a6;
    FILE *fp;

    if((fp=fopen(filename, "r"))==NULL){
        printf("Can not open the file %s (routine:CNS_mr)\n",filename);
        return;
    }
    
    while(fgets(str, sizeof str, fp) != NULL){
        if (pattern5(str, "!", "rotation search:", "", "", "")){
            get_data_set_id(str, "!", "rotation", substr);           
            rid_of_front_end_space(substr);
            strcpy(pdbx_phasing_MR.method_rotation, substr);
            
            while(fgets(str, sizeof str, fp) != NULL){
                if (pattern5(str, "! at resolution:", " -", " A", "", "")){
                    resH = get_float(str," -", " A");
                    resL = get_float(str,":", " -");

                    pdbx_phasing_MR.d_res_high_rotation = resH;
                    pdbx_phasing_MR.d_res_low_rotation = resL;
                    
                }else if(pattern5(str, "! reflections with |Fobs|/sigma_F <", " rejected", "", "", "")){
                    pdbx_phasing_MR.sigma_F_rotation = get_float(str," <", " rejected");
                    
                }else if(pattern5(str, "! total number of reflections used:","(", " %", ")", "")){
                    pdbx_phasing_MR.reflns_percent_rotation = get_float(str,"("," %");
                    
                    break;
                }
            }
            break;
        }else if (pattern5(str, "!", "translation", "search", "", "")){
            
            while(fgets(str, sizeof str, fp) != NULL){
                if (pattern5(str, "! method= ", "", "", "", "")){
                    get_data_set_id(str, "= ", "\n", substr);
                    rid_of_front_end_space(substr);
                    strcpy(pdbx_phasing_MR.method_translation, substr);
                    
                }else if (pattern5(str, "! at resolution:", " A", "", "", "")){
                    pdbx_phasing_MR.d_res_high_translation = get_float(str," -", " A");
                    pdbx_phasing_MR.d_res_low_translation = get_float(str,"resolution:", "-");
                    
                }else if(pattern5(str, "! reflections with |Fobs|/sigma_F <", " rejected", "", "", "")){
                    pdbx_phasing_MR.sigma_F_translation = get_float(str," <", " rejected");

                }else if(pattern5(str, "! total number of reflections used:", "(", " %", ")", "")){
                    pdbx_phasing_MR.reflns_percent_translation = get_float(str,"(", " %");
                    
                }else if(strstr_space(str,"=== best solution ===")){
                   while(fgets(str, sizeof str, fp) != NULL){
                       if(strstr(str,"R# ")){
                           n=sscanf(str,"%*s%*s  %f%f%f%f %f%f%f%f",&a1,&a2,&a3,&a4,&a5,&a6, &cc, &pack);
                           if(n==8){
                               pdbx_phasing_MR.correlation_coeff_Fo_to_Fc = cc;
                               pdbx_phasing_MR.packing = pack;
                               pdbx_phasing_MR.angle_alpha = a1;
                               pdbx_phasing_MR.angle_beta = a2;
                               pdbx_phasing_MR.angle_gamma = a3;
                               pdbx_phasing_MR.Cartn_x = a4;
                               pdbx_phasing_MR.Cartn_y = a5;
                               pdbx_phasing_MR.Cartn_z = a6;
                               break;
                           }
                           
                       }
                   }
                }
                
            }
            break;
            
        }
    }
}

                
void EPMR_mr(FILE *fout, char *filename, char *format, char *method)
/* get items from EPMR */
{
    char str[512], substr[256], tmp[256], version[80];
    float  resH, resL, a1, a2, a3;
    int n=0;
    FILE *fp;

    if((fp=fopen(filename, "r"))==NULL){
        printf("Can not open the file %s (routine:EPMR_mr)\n",filename);
        return;
    }
    while(fgets(str, sizeof str, fp) != NULL){
        
                       
        if (pattern5(str, "EPMR", "-", "Version", "(", ")")){
            fprintf(fout,"_software.name  'EPMR'\n");
            strcpy(tmp, strstr_case(str,"Version")+7);
            
            if(sscanf(tmp,"%s", version)==1){
                fprintf(fout,"_software.version  %s\n", version);
            }
            fprintf(fout,"_software.classification  'Molecular replacement'\n");
            
            fprintf(fout,"##\n\n\n");
        }else if(pattern5(str,"Resolution range:", " -", " Angstroms", "", "")){
            
            strcpy(substr, strstr_case(str,":")+1);
            n=sscanf(substr,"%f%s%f",&resL,tmp, &resH);
            if(n==3){
                pdbx_phasing_MR.d_res_high_translation  = resH;
                pdbx_phasing_MR.d_res_low_translation = resL;
            }
        }else if(pattern5(str, "Soln", "Rot=", "Trn=", "CC=", "R=")){
            
            get_data_set_id(str, "Rot=", "Trn=", substr);
            n = sscanf(substr, "%f%f%f", &a1, &a2,  &a3);
            if(n==3){
                pdbx_phasing_MR.angle_alpha = a1;
                pdbx_phasing_MR.angle_beta = a2;
                pdbx_phasing_MR.angle_gamma = a3;
            }
            
            get_data_set_id(str,  "Trn=","CC=", substr);
            n = sscanf(substr, "%f%f%f", &a1, &a2,  &a3);
            if(n==3){
                pdbx_phasing_MR.Cartn_x = a1;
                pdbx_phasing_MR.Cartn_y = a2;
                pdbx_phasing_MR.Cartn_z = a3;
            }
            
            get_data_set_id(str,  "CC=","R=", substr);
            n = sscanf(substr, "%f", &a1);
            if(n==1){
                pdbx_phasing_MR.correlation_coeff_Fo_to_Fc = a1;
            }

            get_data_set_id(str,  "R=", "\n",substr);
            n = sscanf(substr, "%f", &a1);
            if(n==1){
                pdbx_phasing_MR.R_factor = a1;
            }

            break;
            
        }
    }
    
}

                       
            
