/*
FILE:     sf-initial.C
*/
/*
VERSION:  1.700
*/
/*
DATE:     7/13/2005
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2005 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
/* a program to gather all the reflection data and convert it to
   cif format.   March, 2002
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <sys/types.h>
#include "sf.h"
#include "util.h"

    
/***************** structure factors from beam line  ****************/
void write_refl_initial(FILE *fout, int argc, char **argv)
{
    char infile[MAXL], prog[80], I_F_type[10], ncryst[10], nwave[10];
    long i=0, k, n=0;
    static int nset;
    
    printf("\n");
    
    fprintf(fout,"data_set2_for_phasing\n");

    for(i=1; i<argc-1; i++){
        if(!strcmp_case(argv[i], "-DP") ) strcpy(prog, argv[i+1]);
        if(!strcmp_case(argv[i], "-DT") ) strcpy(I_F_type, argv[i+1]);
    }

    if(!strcmp_case(prog,"HKL") || !strcmp_case(prog,"HKL2000") ||
       !strcmp_case(prog,"SCALEPACK")) strcpy(prog,"HKL");
    
    
    for(i=1; i<argc-3; i++){     // for all the cif reflections    
        if(!strcmp_case(argv[i],"-C") && !strcmp_case(argv[i+2],"-W")){
            strcpy(ncryst, argv[i+1]);
            strcpy(nwave, argv[i+3]);
            
            for(k=i+3; k<argc-1; k++){
                if(!strcmp_case(argv[k], "-C")
                   || !strcmp_case(argv[k], "-rt")
                   || !strcmp_case(argv[k], "-rp")

                   ) {
                    i=k-1;					
                    break;
                }
                
                if(!strcmp_case(argv[k],"-icif") ){
                    strcpy(infile, argv[k+1]);
                    printf("Input data file name = %s : (format mmCIF)\n", infile);
                    write_cif_data(fout, ncryst, nwave, infile);
                    
                }else if(!strcmp_case(argv[k],"-idat") ){
                    strcpy(infile, argv[k+1]);
                    
                    n=is_refl_cif(infile);
                    
                    if(n>0){
                        printf("Input data file name = %s : (format mmCIF)\n", infile);
                        write_cif_data(fout, ncryst, nwave, infile);
                    }else{
                        printf("Input data file name = %s : (format %s)\n", infile, prog);
                        nset=nset+1;
                        if(nset==1){
                            if(strcmp_case(I_F_type, "I")){
                                printf("Warnning! The given data type (%s) is not intensity!\n", I_F_type);
                                printf("It is recommended to deposit original scaled data.\n");
                            }
                            write_data_type_head_phs(fout, I_F_type);
                        }
                        write_data(fout, ncryst, nwave, infile, prog,I_F_type);
                    }  
                }
                
                
            }
            
        }
    }

    fprintf(fout, "# END OF REFLECTIONS\n");
    

}

    
void write_data_type_head_phs(FILE *fout, char *I_F_type)
/* write the data head */
{
    
    if(!strcmp_case(I_F_type,"F")){

        fprintf(fout, "\n#\n" );
        fprintf(fout, "loop_\n");
        fprintf(fout, " _refln.crystal_id \n");
        fprintf(fout, " _refln.wavelength_id \n");
        fprintf(fout, " _refln.scale_group_code\n");
        fprintf(fout, " _refln.index_h\n");
        fprintf(fout, " _refln.index_k\n");
        fprintf(fout, " _refln.index_l\n");
        fprintf(fout, " _refln.F_meas_au\n" );
        fprintf(fout, " _refln.F_meas_sigma_au \n" );
        
    }else if(!strcmp_case(I_F_type,"I")){  
        fprintf(fout, "\n#\n" );
        fprintf(fout, "loop_\n");
        fprintf(fout, " _refln.crystal_id \n");
        fprintf(fout, " _refln.wavelength_id \n");
        fprintf(fout, " _refln.scale_group_code\n");
        fprintf(fout, " _refln.index_h\n");
        fprintf(fout, " _refln.index_k\n");
        fprintf(fout, " _refln.index_l\n");
        fprintf(fout, " _refln.intensity_meas\n" );
        fprintf(fout, " _refln.intensity_sigma\n" );

    }
    else{
        printf("Data-type (%s) is wrong! (It should be either (F) or (I))\n",
               I_F_type );
        exit(0);
    }
}


void write_cif_data(FILE *fout, char *ncryst, char *nwave, char *iFile)
{
    char *diags=NULL, *blockId=NULL, *fnx=(char *)"cif2cif_from_cifparse";
//    char  **path,  **sint, **sym, **wave ;
    char **H=NULL,**K=NULL,**L=NULL, **status=NULL,**scale=NULL ;
    char **Fo=NULL, **sFo=NULL, **Fo_au=NULL, **sFo_au=NULL,**Io=NULL;
    char **sIo=NULL, **F2o=NULL, **sF2o=NULL;
    long  n=0, i;
    static int nset;
    FILE *fp;
    
    CifFileObj * fobjR = NULL;

    fp = fopen(iFile, "r");
    if(fp==NULL){
        open_file_error(iFile, "write_cif_data");
    }
    
    fobjR = new CifFileObj(fnx, WRITE_MODE, 80, "?", 1);
    

    fobjR->Read(iFile,diags);
    if (diags != NULL) fprintf(stderr, "Diags for file %s: %s\n",iFile,diags);
    fobjR->CloseFile();
    if (fobjR) delete fobjR;

    fobjR = new CifFileObj(fnx, READ_MODE);
    blockId = fobjR->GetBlockName(0);

     /*
    path = get_attribute_values(fobjR, blockId, "refln","mean_path_length_tbar", &n);
    sint = get_attribute_values(fobjR, blockId, "refln","sint_over_lambda", &n);
    sym = get_attribute_values(fobjR, blockId, "refln","symmetry_multiplicity", &n);
    wave = get_attribute_values(fobjR, blockId, "refln","wavelength", &n);
        */
    H = get_attribute_values(fobjR, blockId, "refln", "index_h", &n);
    K = get_attribute_values(fobjR, blockId, "refln", "index_k", &n);
    L = get_attribute_values(fobjR, blockId, "refln", "index_l", &n);
    
    status = get_attribute_values(fobjR, blockId, "refln", "status", &n);  
    scale = get_attribute_values(fobjR, blockId, "refln","scale_group_code", &n);
    
    
    Fo = get_attribute_values(fobjR, blockId, "refln", "F_meas", &n);
    sFo = get_attribute_values(fobjR, blockId, "refln", "F_meas_sigma", &n);
    Fo_au = get_attribute_values(fobjR, blockId, "refln", "F_meas_au", &n);
    sFo_au = get_attribute_values(fobjR, blockId, "refln", "F_meas_sigma_au", &n);

    Io = get_attribute_values(fobjR, blockId, "refln", "intensity_meas", &n);
    sIo = get_attribute_values(fobjR, blockId, "refln", "intensity_sigma", &n);
    F2o = get_attribute_values(fobjR, blockId, "refln", "F_squared_meas", &n);
    sF2o = get_attribute_values(fobjR, blockId, "refln", "F_squared_sigma", &n);
    
    if(n>50){
        if(Io || F2o || Fo_au || Fo) nset=nset+1;
        
        if(nset==1){
            fprintf(fout, "\n#reflection data from mmCIF to mmCIF \n\n");
            if(Io){
                ref_head(fout); 
                fprintf(fout, " _refln.intensity_meas\n");
                fprintf(fout, " _refln.intensity_sigma\n");
            }else if(F2o){
                ref_head(fout); 
                fprintf(fout, " _refln.F_squared_meas\n");
                fprintf(fout, " _refln.F_squared_sigma\n");
            }else if (Fo_au){
                ref_head(fout); 
                fprintf(fout, " _refln.F_meas_au\n");
                fprintf(fout, " _refln.F_meas_sigma_au\n");
            }else if (Fo){
                ref_head(fout); 
                fprintf(fout, " _refln.F_meas\n");
                fprintf(fout, " _refln.F_meas_sigma\n");
            }
        }
        if(nset==1){
            for(i=0; i<n; i++){
                fprintf(fout,"%s %s ", ncryst, nwave);
                (status) ? fprintf(fout,"'%s' ",status[i]) : fprintf(fout,"? ");
                (scale) ? fprintf(fout,"'%s' ",scale[i]) : fprintf(fout,"? ");
                    /*
                (path) ? fprintf(fout,"%s ",path[i]) : fprintf(fout,"? ");
                (sint) ? fprintf(fout,"%s ",sint[i]) : fprintf(fout,"? ");
                (sym) ? fprintf(fout,"%s ",sym[i]) : fprintf(fout,"? ");
                (wave) ? fprintf(fout,"%s ",wave[i]) : fprintf(fout,"? ");
                    */
                (H)? fprintf(fout,"%s ", H[i]) : fprintf(fout,"? ");
                (K)? fprintf(fout,"%s ", K[i]) : fprintf(fout,"? ");
                (L)? fprintf(fout,"%s ", L[i]) : fprintf(fout,"? ");
                if(Io){
                    fprintf(fout,"%s ", Io[i]);
                    (sIo)? fprintf(fout,"%s\n", sIo[i]) : fprintf(fout,"?\n");
                }else if(F2o){
                    fprintf(fout,"%s ", F2o[i]);
                    (sF2o)? fprintf(fout,"%s\n", sF2o[i]) : fprintf(fout,"?\n");
                }else if(Fo_au){
                    fprintf(fout,"%s ", Fo_au[i]);
                    (sFo_au)? fprintf(fout,"%s\n", sFo_au[i]) : fprintf(fout,"?\n");
                }else if(Fo){
                    fprintf(fout,"%s ", Fo[i]);
                    (sFo)? fprintf(fout,"%s\n", sFo[i]) : fprintf(fout,"?\n");
                }
            }
        }                    
    }
    if(H) free_memory_2d(H,n);
    if(K) free_memory_2d(K,n);
    if(L) free_memory_2d(L,n);
    if(Fo) free_memory_2d(Fo,n);
    if(sFo) free_memory_2d(sFo,n);
    if(Fo_au) free_memory_2d(Fo_au,n);
    if(sFo_au) free_memory_2d(sFo_au,n);
    if(Io) free_memory_2d(Io,n);
    if(sIo) free_memory_2d(sIo,n);
    if(sF2o) free_memory_2d(sF2o,n);
    if(status) free_memory_2d(status,n);
    
    if (fobjR) delete fobjR;
    delete_file("cif2cif_from_cifparse");
    
}

void ref_head( FILE *fout )
{
    fprintf(fout, "loop_\n");
    fprintf(fout, " _refln.crystal_id\n");
    fprintf(fout, " _refln.wavelength_id\n");
    fprintf(fout, " _refln.status\n" );
    
    fprintf(fout, " _refln.scale_group_code\n" );
    fprintf(fout, " _refln.index_h\n");
    fprintf(fout, " _refln.index_k\n");
    fprintf(fout, " _refln.index_l\n");
}



void write_data(FILE *fout, char *ncryst, char *nwave, 
                char *filename, char *prog, char *I_F_type)
/* write initial data from here */
{
    int format=0;
    
    
    if(!strcmp_case(prog, "HKL")){
//        printf("HKL/SCALEPACK data file = %s\n",filename);
        write_hkl(fout, filename, ncryst, nwave);
        
    }else if (!strcmp_case(prog, "3DSCALE")){
//        printf("3DSCALE data file = %s\n",filename);
        write_hkl(fout, filename, ncryst, nwave);
        
    }else if(!strcmp_case(prog, "DTREK")){
        format = data_format(filename, prog);
        
        if(format==1){
//            printf("D*TREK data file = %s :  (NO ANOMALOUS, with header)\n",filename);
            write_dtrek(fout, filename, ncryst, nwave);
        }else if(format==2){
//            printf("D*TREK data file = %s :  (NO ANOMALOUS, without header)\n",filename);
            write_dtrek(fout, filename, ncryst, nwave);
        }else if(format==3){
//            printf("D*TREK data file = %s :  (ANOMALOUS, with header)\n",filename);
            write_dtrek(fout, filename, ncryst, nwave);
        }else if(format==4){
//            printf("D*TREK data file = %s :  (ANOMALOUS, without header)\n",filename);
            write_dtrek(fout, filename, ncryst, nwave);
        }else{
            write_data_message(prog, filename);
            fprintf(fout, " ? ? ? ? ? ? ? ? \n");    
            return;
        }
        
        
    }else if(!strcmp_case(prog, "SAINT")){   /* a program for MAR CCD detector*/
        
        format = data_format(filename, prog);
        if(format == 1){
//            printf("SAINT data file = %s :  (the *.raw data)\n",filename);
            write_saint(fout, filename, ncryst, nwave);
        }else{
            write_data_message(prog, filename);
            fprintf(fout, " ? ? ? ? ? ? ? ? \n");    
            return;
        }
        
//    }else if(!strcmp_case(prog, "CNS")){
//        printf("data file = %s : (CNS format (convered) )\n",filename);
//        cns_reflection(fout,  filename,(char *)"INI", ncryst, nwave,I_F_type);
        
    }else if(!strcmp_case(prog, "other") || !strcmp_case(prog, "xscale")){
        format = write_other(fout, filename, ncryst, nwave);
        if(format<50)  fprintf(fout, " ? ? ? ? ? ? ? ? \n");
        return;
    }
    
}

long write_other(FILE *fout, char *filename, char *ncryst, char *nwave)
{
    char  str[MAXL];
    int H, K, L;
    float  F, sF;
    long n=0;
    FILE *fp;
    
    if((fp = fopen(filename, "r"))==NULL) {
        open_file_error(filename, "write_other");
    }

    while (fgets(str, sizeof str, fp) != NULL) {
        if(sscanf(str, " %d %d %d %f %f", &H, &K, &L, &F, &sF)==5){
            n++;
            fprintf(fout," %s  %s 1  %4d %4d %4d  %11.2f %10.2f \n",
                    ncryst, nwave, H, K, L, F, sF);
        }
    }
 
    fclose(fp);
    return n;
}

int data_format(char *filename, char *prog)
/* get various format from the program used */
{
    char str[512], sub_str[20], sub_str1[40], sub_str2[40];
    int len=0, n=0, f1=0, f2=0, f3=0, f4=0, i1, i, head=0;
    float a1;
    FILE *finp;

    
    if((finp = fopen(filename, "r"))==NULL) {
        open_file_error(filename, "data_format");
    }
    
    if(!strcmp_case(prog, "HKL")){
   
       n=0;
        while (fgets(str, sizeof str, finp) != NULL) {
            rid_of_end_space(str);
            n++;
            if(n<=20) continue;
            len = strlen(str);
            get_string(str, 0, 12, sub_str);
        
            if((len == 28|| len == 29  || len == 44 || len == 45 )&& 
               sscanf(sub_str, "%d%d%d", &i1,&i1,&i1)==3){ //format=1,2
                
                f1++;
                if(f1>50 && n<75){
                    fclose(finp);
                    return 1;
                }
            }else if ((len ==35 || len ==36) &&
                      sscanf(sub_str, "%d%d%d", &i1,&i1,&i1)==3){ //format= 3
                get_string(str, 12, 18, sub_str1);
                if(sscanf(sub_str, "%d%d", &i1,&i1)==2) f3++;
                
                if(f3>50 && n<75){
                    fclose(finp);
                    return 3;
                }
            }else if ((len ==53 || len ==54) &&
                      sscanf(sub_str, "%d%d%d", &i1,&i1,&i1)==3){ //format= 4
            
                get_string(str, 12, 24, sub_str1);
                get_string(str, 24, 37, sub_str2);

                if(sscanf(sub_str1, "%d%d%d", &i1,&i1,&i1)==3 &&
                   sscanf(sub_str2, "%d%d%d%d", &i1,&i1,&i1,&i1)==4) f4++;
            
                if(f4>50 && n<75){
                    fclose(finp);
                    return 4;
                }
            }
        }
        if(finp) fclose(finp);
        return 0;  
    }else if(!strcmp_case(prog, "dtrek")){
        
 /* there are several output free format for dtrek
1, NO ANOMALOUS flag ----- h, k, l, I, sigma(I)
2, NO ANOMALOUS flag, no head.
3, WITH ANOMALOUS flag --- h, k, l, I, sigma(I), I+, sigma(I+), I-, sigma(I-) ;
4, WITH ANOMALOUS flag,  1 but no head.
*/
        i=0;
        while (fgets(str, sizeof str, finp) != NULL) {
        
            n=sscanf(str, " %s %s", sub_str1,sub_str2);
            if(n==1 && !strcmp(sub_str1, "nH")) head=1;
        
            n=sscanf(str, "%d %d %d %f %f %f %f %f %f",
                     &i1,&i1,&i1, &a1,&a1,&a1,&a1,&a1,&a1);
            if(n==5) f1++;
            if(n==9) f2++;
            
            if(n==5 && f1 >= 50 ){
                if(head>0){
                    fclose(finp);
                    return 1;
                }
                else {
                    fclose(finp);
                    return 2;
                }
            }else if(n==9 && f2 >= 50){
                if(head>0){
                    fclose(finp);
                    return 3;
                }
                else {
                    fclose(finp);
                    return 4;
                }
            }
        }
        if(finp) fclose(finp);
        return 0;
    }else if(!strcmp_case(prog, "saint")){

/* For saint only use the raw data (integrated and scaled) format */
   
        i=0;
        while (fgets(str, sizeof str, finp) != NULL) {
            
            n=sscanf(str, "%d %d %d %f %f %f %f %f %f %f %f",
                     &i1,&i1,&i1, &a1,&a1,&a1,&a1,&a1,&a1,&a1,&a1);
            if(n>=10 && strlen(str)>200){
                if(i++>=100) break;
            }
        }
        if(i>99){
            fclose(finp);
            return 1;
        }else{
            fclose(finp);
            return 0;
        }
    }
    return 0;
}
    
///////////////////////////////////////////////

void write_hkl(FILE *fout, char *filename,  char* crystal,  char* n_wave)
/* get the right format for HKL2000/scalepack
    
1, NO ANOMALOUS flag ----- h, k, l, I, sigma(I)  (3I4, 2F8.1) length=28
2, WITH ANOMALOUS flag --- h, k, l, I+, sigma(I+), I-, sigma(I-) ;
   (3I4, 4F8.1) length=44
3, NO MERGE  --- h, k, l, asymmetric unit #, I, sigma(I) ; (4I4,2F8.1)  
   ANOMALOUS flag has no effect.  length=32
4, NO MERGE original index --- original hkl, unique hkl, batch (film)
   number, a flag (0 = centric, 1 = I+, 2 = I-), another flag (0 =
   hkl reflecting above the spindle, 1 = hkl reflecting below the spindle), 
   the asymmetric unit of the reflection, I (scaled, Lorentz and Polarization
   corrected), and the sigma of I. The format is (6i4, i6, 2i2, i3, 2f8.1).
   (RAW data!!)  length=53

*/
    
{
    char str[100], h[10],k[10],l[10], i[10], si[10];
    int hh, kk, ll, k1=0, k2=0, k3=0, k4=0, len=0, n=0;
    FILE  *finp;
    
    if((finp = fopen(filename, "r"))==NULL) {
        open_file_error(filename, "write_hkl");
    }
    
    while (fgets(str, sizeof str, finp) != NULL) {
        rid_of_end_space(str);
        len=strlen(str);
        if(sscanf(str, "%d%d%d", &n, &n, &n) != 3) continue;
        if(!strchr(str, '.'))continue;
        
        if(len > 27 && len <62 ){
            get_string(str, 0, 3, h);
            get_string(str, 4, 7, k);
            get_string(str, 8, 11, l);
        }

        if(len==28 || len==29 ){
            k1=1;
            get_string(str, 12, 19, i);
            get_string(str, 20, 27, si);
            fprintf(fout,"%s %s 1 %4s  %4s  %4s  %8s  %8s \n",
                    crystal,n_wave, h,k,l, i, si);
            
        }else if(len==35 || len==36){
            k2=1;
            get_string(str, 19, 26, i);
            get_string(str, 27, 34, si);
            fprintf(fout,"%s %s 1 %4s  %4s  %4s  %8s  %8s \n",
                    crystal,n_wave, h,k,l, i, si);
            
        }else if(len==44 || len==45){
            k3=1;
            get_string(str, 12, 19, i);
            get_string(str, 20, 27, si);
            fprintf(fout,"%s %s 1 %4s  %4s  %4s  %8s  %8s \n",
                    crystal,n_wave, h,k,l, i, si);

            hh =  -atoi(h);
            kk =  -atoi(k);
            ll =  -atoi(l);
            
            get_string(str, 28, 35, i);
            get_string(str, 36, 43, si);
            fprintf(fout,"%s %s 1 %4d  %4d  %4d  %8s  %8s \n",
                    crystal,n_wave, hh,kk,ll, i, si);
            
        }else if(len==53 || len==54){
            k4=1;
            get_string(str, 37, 44, i);
            get_string(str, 45, 52, si);
            fprintf(fout,"%s %s 1 %4s  %4s  %4s  %8s  %8s \n",
                    crystal,n_wave, h,k,l, i, si);
        }
        
    }
    if(k1==0 && k2==0 && k3==0 && k4==0){
        fprintf(fout, " ? ? ? ? ? ? ? ? \n");    
        printf("Warning! The HKL/SCALEPACK format is wrong!\n");
        printf("Please check the supported version by pdb_extract!\n");
    }
    
    fclose(finp);
    
}



void write_dtrek(FILE *fout, char *filename, char *ncryst, char *nwave)
/* write reflections from d*trek */
{
    char str[MAXL];
    int h=0, k=0, l=0, m;
    float i, sigmai, plus_i, plus_s, minus_i, minus_s;
    FILE *finp;

    if((finp = fopen(filename, "r"))==NULL) {        
        printf("Can not open the file:  %s\n",filename);
        exit(0);
    }

    while (fgets(str, sizeof str, finp) != NULL) {
        
        m=sscanf(str, " %d%d%d %f%f %f%f %f%f",
                 &h, &k, &l, &i, &sigmai, &plus_i, &plus_s, &minus_i, &minus_s);
        
        if(m==5){
            fprintf(fout,"%s %s 1 %5d %5d %5d %11.2f %11.2f \n",
                    ncryst, nwave, h, k, l, i, sigmai);
        }else if(m==9){
            fprintf(fout,"%s %s 1 %5d %5d %5d %11.2f %11.2f \n",
                    ncryst, nwave, h, k, l, plus_i, plus_s);
            fprintf(fout,"%s %s 1 %5d %5d %5d %11.2f %11.2f \n",
                    ncryst, nwave, -h, -k, -l, minus_i, minus_s);
        }
    }
    
}

void write_saint(FILE *fout, char *filename, char *ncryst, char *nwave)
/* write reflections from SAINT */
{
    char str[MAXL], substr[40];
    int h=0, k=0, l=0;
    float f=0, sf=0;
    FILE *finp;

    if((finp = fopen(filename, "r"))==NULL) {        
        printf("Can not open the file:  %s\n",filename);
        exit(0);
    }

    while (fgets(str, sizeof str, finp) != NULL) {
        if(strlen(str)>200){
            
            get_string(str, 0, 4, substr);
            h=atoi(substr);
            
            get_string(str, 4, 8, substr);
            k=atoi(substr);
            
            get_string(str, 8, 12, substr);
            l=atoi(substr);
            
            get_string(str, 12, 20, substr);
            f=atof(substr);
            
            get_string(str, 20, 28, substr);
            sf=atof(substr);
        }
        if(abs(h) >=0 && abs(k) >=0 &&abs(l) >=0 && fabs(f)>-1 && fabs(sf)>-1){
            fprintf(fout,"%s %s 1 %5d %5d %5d %11.2f %11.2f \n",
                    ncryst, nwave, h, k, l, f, sf);
        }
    }
    
}



void extract_log_CIF(FILE *fout, char *infile)
/* for CIF file take all the contents */
{
    FILE *fp;
    char str[MAXL];
    
    if((fp = fopen(infile, "r"))==NULL) {        
        printf("Can not open the file %s(routine: extract_log_CIF)\n",infile);
        return;
    }
    
    while (fgets(str, sizeof str, fp) != NULL) {
        fprintf(fout, "%s", str);
    }
    fclose(fp);
    
}


