/*
FILE:     sf-log.C
*/
/*
VERSION:  1.700
*/
/*
DATE:     7/13/2005
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2005 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
/* a program to gather all the reflection data and convert it to
   cif format.   March, 2002
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include "structure.h"
#include "util.h"
#include "harv.h"
const float DEG2RAD= 0.017453292;

REFLNS_SF reflns_sf,  diffrn_sf[30];
extern CELL cell ;
extern EXPTL_CRYSTAL exptl_crystal ;
extern SYMMETRY symmetry;

extern PDBX_CRYSTAL_ALIGNMENT pdbx_crystal_alignment;

float get_resolution(float h,float k, float l, float *rcell);
void calc_recip_cell(float *cell, float *rcell);
void write_diffrn_reflns_shell(FILE *fout, REFLNS_SF *log,int j, int m, const char *id);
void write_diffrn_reflns(FILE *fout, REFLNS_SF *log,int j,  const char *id);
void I_over_sigmaI(char *inpfile);
void extract_XSCALE_log(char *inpfile, int *key );
void extract_PROSCALE_log(char *inpfile);


void extract_scale(FILE *fout, int argc, char **argv, int start, char *prog)
{
    int i=0, key=0, dum;
    char infile[512];
    const char *id = "-i -p -e -d -m -r -s -sp";

    initial_reflns();
    
    for(i=start; i<argc-1; i++){
        if(strstr_case(id, argv[i])) break;
        if(!strcmp_case(argv[i],"-ILOG") ){
            strcpy(infile, argv[i+1]);
            
            if(!strcmp_case(prog, "HKL")|| !strcmp_case(prog,"SCALEPACK")||
               !strcmp_case(prog, "HKL2000")){
                
                printf("HKL/Scalepack output Log file: (%s)\n",infile);
                
                extract_HKL_log(infile);
                key=1;
                
                
            }else if (!strcmp_case(prog,"DTREK")){

                printf("D*TREK output Log file (%s)\n",infile);
                extract_DTREK_log(infile); 
                        
            }else if(!strcmp_case(prog,"SAINT")){

                printf("SAINT output Log file (%s)\n",infile);
                extract_SAINT_log(infile);
                        
            }else if(!strcmp_case(prog,"SCALA")){

                printf("SCALA output Log file (%s)\n",infile);
                extract_SCALA_log(infile);
                        
            }else if(!strcmp_case(prog,"3DSCALE")){

                printf("3DSCALE output Log file (%s)\n",infile);
                extract_3DSCALE_log(infile);

            }else if(!strcmp_case(prog,"XSCALE")){

                printf("XSCALE output Log file (%s)\n",infile);
                extract_XSCALE_log(infile, &dum); //one data set for refinement
                
            }else if(!strcmp_case(prog,"PROSCALE")){

                printf("PROSCALE output Log file (%s)\n",infile);
                extract_PROSCALE_log(infile); 

            }else{
                write_data_message(prog, infile);
            }
            
        }else if(!strcmp_case(argv[i],"-IDAT") ){
            
            strcpy(infile, argv[i+1]);
            if(!strcmp_case(prog, "HKL")|| !strcmp_case(prog,"SCALEPACK")||
               !strcmp_case(prog, "HKL2000")){
                
                printf("HKL/Scalepack output data file: (%s)\n",infile);
                if(key==0){
                    printf("Input was wrong! You should give the right order\n");
                    printf("pdb_extract -s HKL -ilog  log_file -idat data_file\n");
                    exit(0);
                }
                I_over_sigmaI(infile); //add I/SigmaI and with shell.
            } 
            
        }else if (!strcmp_case(argv[i],"-ICIF") ){
            strcpy(infile, argv[i+1]);
            write_cif(fout, infile, "");
        }
    }
    
    diffrn_sf[0]=reflns_sf;
    
    write_diffrn_reflns(fout, diffrn_sf, 0, "_reflns");
    for(i=0; i<diffrn_sf[0].nbin; i++)
        write_diffrn_reflns_shell(fout, diffrn_sf, 0, i, "_reflns_shell");
    
}

 

void extract_scale_phase(FILE *fout, int argc, char **argv, int start, char *prog)
// extract LOG files from many diffraction data set.
{
    char infile[512];
    //    const char *id = "-i -p -e -d -m -r -s -sp";
    int i=0, j=0, m=0, ns=0;

    initial_reflns();
    
    ns=0;
    if(!strcmp_case(argv[start],"-ILOG") ){
        
        
        for(i=start+1; i<argc; i++){
            strcpy(infile, argv[i]);
            
            if(argv[i][0] =='-') break;
            reflns_sf.nbin = 0;         
            if(!strcmp_case(prog, "HKL")|| !strcmp_case(prog,"SCALEPACK")||
               !strcmp_case(prog, "HKL2000")){
/*                        
                if(!strcmp_case(argv[i], "-idat")){
                    I_over_sigmaI(argv[i+1]); 
                    i = i+1;
                    continue;
                }
*/                
                printf("HKL/Scalepack output Log file: (%s)\n",infile);
                extract_HKL_log(infile);
                
                
                if(reflns_sf.nbin >0){
                    diffrn_sf[ns]=reflns_sf;
                    if(ns++>29) return;
                }
            }else if(!strcmp_case(prog,"DTREK")){
                printf("D*TREK output Log file (%s)\n",infile);
                extract_DTREK_log(infile); 
                if(reflns_sf.nbin >0){
                    diffrn_sf[ns]=reflns_sf;
                    if(ns++>29) return;
                }
            }else if(!strcmp_case(prog,"SCALA")){
                printf("SCALA output Log file (%s)\n",infile);
                extract_SCALA_log(infile);
                if(reflns_sf.nbin >0){
                    diffrn_sf[ns]=reflns_sf;
                    if(ns++>29) return;
                }
            }else if(!strcmp_case(prog,"3DSCALE")){
                printf("3DSCALE output Log file (%s)\n",infile);
                extract_3DSCALE_log(infile);
                if(reflns_sf.nbin >0){
                    diffrn_sf[ns]=reflns_sf;
                    if(ns++>29) return;
                   
                }
            }else if(!strcmp_case(prog,"XSCALE")){
                printf("XSCALE output Log file (%s)\n",infile);
                extract_XSCALE_log(infile,&ns); //multi-data
                
            }else if(!strcmp_case(prog,"PROSCALE")){
                printf("PROSCALE output Log file (%s)\n",infile);
                extract_PROSCALE_log(infile);
                if(reflns_sf.nbin >0){
                    diffrn_sf[ns]=reflns_sf;
                    if(ns++>29) return;
                   
                }
                   
                
            } 
        }
    }
    
        
    if (ns > 0){
        for(j=0; j<ns; j++){
            for(m=0; m<diffrn_sf[j].nbin; m++){
                write_diffrn_reflns_shell(fout, diffrn_sf, j, m, "_pdbx_diffrn_reflns_shell");
            }
        }
   
        for(j=0; j<ns; j++){
            write_diffrn_reflns(fout, diffrn_sf, j, "_diffrn_reflns");
        } 
    }
    
}

void write_diffrn_reflns_shell(FILE *fout, REFLNS_SF *log,int j, int m, const char *id)
// j, data set id;  m, shell (bin) id for each data set    
{
    if(j==0 && m==0){
        fprintf(fout, "\n# statistics from LOG files (_diffrn_reflns.shells)\n");

        if(!strcmp(id,"_reflns_shell")){
            
            fprintf(fout, "\nloop_\n");
            fprintf(fout, "_reflns_shell.d_res_low\n");
            fprintf(fout, "_reflns_shell.d_res_high\n");
            
            fprintf(fout, "_reflns_shell.number_measured_obs\n");
            fprintf(fout, "_reflns_shell.percent_possible_obs \n");
            fprintf(fout, "_reflns_shell.Rmerge_I_obs\n");
            fprintf(fout, "_reflns_shell.pdbx_chi_squared\n");
            
            fprintf(fout, "_reflns_shell.pdbx_redundancy\n");
            fprintf(fout, "_reflns_shell.pdbx_rejects \n");
            fprintf(fout, "_reflns_shell.number_unique_obs \n");
            fprintf(fout, "_reflns_shell.meanI_over_sigI_obs \n");
            
            fprintf(fout, "_reflns_shell.pdbx_Rsym_value \n");
            fprintf(fout, "_reflns_shell.pdbx_ano_meanI_over_sigI_obs \n");
            
        }else if(!strcmp(id,"_pdbx_diffrn_reflns_shell")){
            
            fprintf(fout, "\nloop_\n");
            fprintf(fout, "_pdbx_diffrn_reflns_shell.diffrn_id \n");
            fprintf(fout, "_pdbx_diffrn_reflns_shell.d_res_low \n");
            fprintf(fout, "_pdbx_diffrn_reflns_shell.d_res_high \n");
            
            fprintf(fout, "_pdbx_diffrn_reflns_shell.number_measured_obs \n");
            fprintf(fout, "_pdbx_diffrn_reflns_shell.percent_possible_obs \n");
            fprintf(fout, "_pdbx_diffrn_reflns_shell.Rmerge_I_obs \n");
            fprintf(fout, "_pdbx_diffrn_reflns_shell.chi_squared \n");
            fprintf(fout, "_pdbx_diffrn_reflns_shell.redundancy \n");
        
            fprintf(fout, "_pdbx_diffrn_reflns_shell.rejects \n");
            fprintf(fout, "_pdbx_diffrn_reflns_shell.number_unique_obs \n");
            fprintf(fout, "_pdbx_diffrn_reflns_shell.netI_over_av_sigmaI \n");
        
            fprintf(fout, "_pdbx_diffrn_reflns_shell.Rsym_value \n");
            fprintf(fout, "_pdbx_diffrn_reflns_shell.pdbx_ano_meanI_over_sigI_obs \n");
            
        }else{
            printf("Provided wrong category (%s)\n", id);
            return;
        }
    }
    
    if(!strcmp(id,"_pdbx_diffrn_reflns_shell")){
        fprintf(fout,"%d ", j+1);
    }
    
    (log[j].resol_L_shell[m]>-99998) ?
        fprintf(fout," %.2f ", log[j].resol_L_shell[m]) : fprintf(fout," ? ");
                
    (log[j].resol_H_shell[m]>-99998) ?
        fprintf(fout," %.2f ", log[j].resol_H_shell[m]) : fprintf(fout," ? ");
        
    (log[j].nrefl_shell[m]>-99998) ?
        fprintf(fout," %d ", log[j].nrefl_shell[m]): fprintf(fout," ? ");

    (log[j].comp_shell[m]>-99998) ?
        fprintf(fout," %.3f ", log[j].comp_shell[m]): fprintf(fout," ? ");

    (log[j].Rmerge_shell[m]>-99998) ?
        fprintf(fout," %.3f ",log[j].Rmerge_shell[m]): fprintf(fout," ? ");
        
    (log[j].chi2_shell[m]>-99998) ?
        fprintf(fout," %.3f ", log[j].chi2_shell[m]): fprintf(fout," ? ");

    (log[j].redundancy_shell[m]>-99998) ?
        fprintf(fout," %.3f ", log[j].redundancy_shell[m]): fprintf(fout," ? ");
    
    (log[j].reject_shell[m]>-99998) ?
        fprintf(fout," %d ", log[j].reject_shell[m]): fprintf(fout," ? ");
        
    (log[j].unique_nrefl_shell[m]>-99998) ?
        fprintf(fout," %d ",log[j].unique_nrefl_shell[m]): fprintf(fout," ? ");
        
    (log[j].I_over_sI_shell[m]>-99998) ?
        fprintf(fout," %.3f ", log[j].I_over_sI_shell[m]): fprintf(fout," ? ");

    (log[j].Rsym_shell[m]>-99998) ?
        fprintf(fout," %.3f \n", log[j].Rsym_shell[m]) : fprintf(fout," ? \n");


    (log[j].ano_I_over_sI_shell[m]>-99998) ?
        fprintf(fout," %.3f \n", log[j].ano_I_over_sI_shell[m]) : fprintf(fout," ? \n");
    
}

void write_diffrn_reflns(FILE *fout, REFLNS_SF *log, int j, const char *id)
{
    
    if(j==0){
        fprintf(fout, "\n# statistics from LOG files (overall data)\n");
        if(!strcmp(id,"_reflns")){
            
            fprintf(fout, "\nloop_\n");
            fprintf(fout, "_reflns.entry_id\n");
            fprintf(fout, "_reflns.d_resolution_low\n");
            fprintf(fout, "_reflns.d_resolution_high\n");
            fprintf(fout, "_reflns.number_obs\n");
            fprintf(fout, "_reflns.percent_possible_obs\n");
            fprintf(fout, "_reflns.pdbx_Rmerge_I_obs\n");
            fprintf(fout, "_reflns.pdbx_chi_squared\n");
            fprintf(fout, "_reflns.pdbx_redundancy\n");
            fprintf(fout, "_reflns.pdbx_scaling_rejects\n");
            fprintf(fout, "_reflns.number_unique_obs\n");
            fprintf(fout, "_reflns.pdbx_netI_over_av_sigmaI\n");
            fprintf(fout, "_reflns.pdbx_mosaicity\n");
            fprintf(fout, "_reflns.pdbx_Rsym_value\n");
            fprintf(fout, "_reflns.data_reduction_details\n");
            fprintf(fout, "_reflns.observed_criterion\n");
            fprintf(fout, "_reflns.observed_criterion_I_max\n");
            fprintf(fout, "_reflns.observed_criterion_I_min\n");
            fprintf(fout, "_reflns.ano_average_I_over_sI\n");
            
        }else if(!strcmp(id,"_diffrn_reflns")){
            fprintf(fout, "\nloop_\n");
            fprintf(fout, "_diffrn_reflns.diffrn_id\n");
            fprintf(fout, "_diffrn_reflns.pdbx_d_res_low\n");
            fprintf(fout, "_diffrn_reflns.pdbx_d_res_high\n");
            fprintf(fout, "_diffrn_reflns.number\n");
            fprintf(fout, "_diffrn_reflns.pdbx_percent_possible_obs\n");
            fprintf(fout, "_diffrn_reflns.pdbx_Rmerge_I_obs\n");
            fprintf(fout, "_diffrn_reflns.pdbx_chi_squared\n");
            fprintf(fout, "_diffrn_reflns.pdbx_redundancy \n");
            fprintf(fout, "_diffrn_reflns.pdbx_reject \n");
            fprintf(fout, "_diffrn_reflns.pdbx_number_unique_obs \n");
            fprintf(fout, "_diffrn_reflns.av_sigmaI_over_netI \n");        
            fprintf(fout, "_diffrn_reflns.pdbx_mosaicity\n");
            fprintf(fout, "_diffrn_reflns.pdbx_Rsym_value \n");
            fprintf(fout, "_diffrn_reflns.pdbx_data_reduction_details \n");
            
            fprintf(fout, "_diffrn_reflns.pdbx_observed_criterion\n");
            fprintf(fout, "_diffrn_reflns.pdbx_observed_criterion_I_max\n");
            fprintf(fout, "_diffrn_reflns.pdbx_observed_criterion_I_min\n");
            fprintf(fout, "_diffrn_reflns.pdbx_ano_average_I_over_sI\n");

            
        }else{
            printf("Provided wrong category (%s)\n", id);
            return;
        }
        
    }
    
    if(!strcmp(id,"_diffrn_reflns")){
        fprintf(fout," %d ", j+1);
    }else if(!strcmp(id,"_reflns")){
        fprintf(fout, "  '%s' ", DATA_BLOCK);
    }
    
    
    (log[j].resol_L>-99998) ?
        fprintf(fout," %.2f ", log[j].resol_L) : fprintf(fout," ? ");
                
    (log[j].resol_H>-99998) ?
        fprintf(fout," %.2f ", log[j].resol_H) : fprintf(fout," ? ");
                
    (log[j].nrefl>-99998) ?
        fprintf(fout," %d ", log[j].nrefl): fprintf(fout," ? ");

    (log[j].comp>-99998) ?
        fprintf(fout," %.3f ", log[j].comp): fprintf(fout," ? ");


    (log[j].Rmerge>-99998) ?
        fprintf(fout," %.3f ",log[j].Rmerge): fprintf(fout," ? ");

    (log[j].chi2>-99998) ?
        fprintf(fout," %.3f ", log[j].chi2): fprintf(fout," ? ");
            
    (log[j].redundancy>-99998) ?
        fprintf(fout," %.3f ", log[j].redundancy): fprintf(fout," ? ");
    
            
    (log[j].reject>-99998) ?
        fprintf(fout," %d ", log[j].reject): fprintf(fout," ? ");
        
    (log[j].unique_nrefl>-99998) ?
        fprintf(fout," %d ",log[j].unique_nrefl): fprintf(fout," ? ");
        
    (log[j].I_over_sI>-99998) ?
        fprintf(fout," %.3f ", log[j].I_over_sI): fprintf(fout," ? ");
            
    (log[j].mosaicity>-99998) ?
        fprintf(fout," %.3f ", log[j].mosaicity): fprintf(fout," ? ");

    (log[j].Rsym>-99998) ?
        fprintf(fout," %.3f \n",log[j].Rsym): fprintf(fout," ? \n");
    
    (strlen(log[j].details)>1) ?
        fprintf(fout," '%s' \n",log[j].details): fprintf(fout," ? \n");
    
    (log[j].obs_criterion> -99998) ?
        fprintf(fout," %.3f\n",log[j].obs_criterion): fprintf(fout," ? \n");
    
    (log[j].criterion_I_max>-99998) ?
        fprintf(fout," %.3f\n",log[j].criterion_I_max): fprintf(fout," ? \n");
    
    (log[j].criterion_I_min>-99998) ?
        fprintf(fout," %.3f\n",log[j].criterion_I_min): fprintf(fout," ? \n");
    
    (log[j].ano_I_over_sI>-99998) ?
        fprintf(fout," %.3f \n",log[j].ano_I_over_sI): fprintf(fout," ? \n");
    
    
}



void I_over_sigmaI(char *inpfile)
{
    char  str[100];
    int  m, h, k, l, hh=0, kk=0, ll=0, nrefl=0, len, nshell[NBIN];
    float i=1, si=1, ii=1, sii=1, i_si=1,sum_i_si=0, I_sigmaI_av[NBIN];
    float cel[6],rcell[6],ah, ak, al, resolution;
    FILE *fp=NULL;

    
    if((fp=fopen(inpfile, "r")) == NULL)
        open_file_error(inpfile, "I_over_sigmaI");
        
    for(m=0; m<6; m++) {
        cel[m]=INI;
    }
    
    if(reflns_sf.nbin<=0) return;
    
    for(m=0; m<reflns_sf.nbin; m++){
        I_sigmaI_av[m] = 0;
        nshell[m]  =   0;
    }
    
    while (fgets(str, sizeof str, fp) !=NULL){
        if(strlen(str)>61 && pattern5(str,".",".",".",".",".")){
            sscanf(str, "%f%f%f%f%f%f",
                   &cel[0], &cel[1], &cel[2],
                   &cel[3], &cel[4], &cel[5]);
            break;
        }  
    }
    if((cel[0]<=0 || cel[1]<=0) && cell.length_a>0){
        cel[0] = cell.length_a;
        cel[1] = cell.length_b;
        cel[2] = cell.length_c;
        cel[3] = cell.angle_alpha;
        cel[4] = cell.angle_beta;
        cel[5] = cell.angle_gamma;
    }
    
    if(cel[0]<=0 || cel[1]<=0 || cel[5]<=0) return;
    calc_recip_cell(cel, rcell);

    
    while (fgets(str, sizeof str, fp) !=NULL){
        rid_of_end_space(str);
        len=strlen(str);

        h = get_int_by_length(str, 0, 3);
        k = get_int_by_length(str, 4, 7);
        l = get_int_by_length(str, 8, 11);

        if(len==28 || len==29 ){
            i = get_float_by_length(str, 12, 19);
            si= get_float_by_length(str, 20, 27);
            
        }else if(len==35 || len==36){
            i = get_float_by_length(str, 19, 26);
            si= get_float_by_length(str, 27, 34);
            
        }else if(len==44 || len==45){
            
            i = get_float_by_length(str, 12, 19);
            si= get_float_by_length(str, 20, 27);

            hh =  -h;
            kk =  -k;
            ll =  -l;
            
            ii = get_float_by_length(str, 28, 35);
            sii= get_float_by_length(str, 36, 43);
            
        }else if(len==53 || len==54){
            i = get_float_by_length(str, 37, 44);
            si= get_float_by_length(str, 45, 52);
        }


        ah= float (h);
        ak= float (k);
        al= float (l);
        
        resolution = get_resolution(ah, ak, al, rcell);
        
        if (h!=0 || k!=0 || l!=0){
            if(si>0.0001) {
                i_si = i/si;
                sum_i_si = sum_i_si + i_si;
            }
            nrefl++;
        }
        if(hh!=0 || kk!=0 || ll!=0){
            if(sii>0.0001) {
                i_si = i/si;
                sum_i_si = sum_i_si + ii/sii;
            }
            nrefl++;
        }
        
        if(reflns_sf.nbin>0){
            for(m=0; m<reflns_sf.nbin; m++){
                if(resolution >=reflns_sf.resol_H_shell[m] &&
                   resolution <reflns_sf.resol_L_shell[m]){
                    I_sigmaI_av[m]  =  I_sigmaI_av[m] +  i_si;
                    nshell[m]++;
                    

                }
            }
        }
        
    }
    
    if(nrefl >0 && reflns_sf.nbin>0){
        for(m=0; m< reflns_sf.nbin; m++){
            reflns_sf.I_over_sI_shell[m] = I_sigmaI_av[m]/nshell[m] ;
//            printf("bin= %d   %.2f\n",m , reflns_sf.I_over_sI_shell[m]);
            
        }
    }
    if(nrefl >0)reflns_sf.I_over_sI = sum_i_si/float(nrefl);
 
}


float get_resolution(float h, float k, float l, float *rcell)
{

    float aa1, aa2, aa3, a2, b2, c2, resol=0, dist_sq;
    
    
    aa1 =  2 * rcell[0] * rcell[1] * cos(DEG2RAD*rcell[5]);
    aa2 =  2 * rcell[0] * rcell[2] * cos(DEG2RAD*rcell[4]);
    aa3 =  2 * rcell[1] * rcell[2] * cos(DEG2RAD*rcell[3]);

    a2 =  rcell[0]*rcell[0];
    b2 =  rcell[1]*rcell[1];
    c2 =  rcell[2]*rcell[2];

    dist_sq = h*h*a2 + k*k*b2 + l*l*c2 + h*k*aa1 + h*l*aa2 + k*l*aa3;
    if(dist_sq>0.0000001)
        resol = sqrt(1.0/dist_sq);

    return resol;
    
}
    
void calc_recip_cell(float *cell, float *rcell)
{
    float cosa,cosb, cosc,sina,sinb,sinc, cosast,cosbst,coscst,v;
    
    
    cosa = cos(DEG2RAD*cell[3]);
    cosb = cos(DEG2RAD*cell[4]);
    cosc = cos(DEG2RAD*cell[5]);
    sina = sin(DEG2RAD*cell[3]);
    sinb = sin(DEG2RAD*cell[4]);
    sinc = sin(DEG2RAD*cell[5]);
    
    v = cell[0]* cell[1] *cell[2]*
        sqrt(1. - cosa*cosa - cosb*cosb - cosc*cosc + 2.*cosa*cosb*cosc );
    
    rcell[0] =  cell[1] * cell[2]* sina / v;
    rcell[1] =  cell[0] * cell[2]* sinb / v;
    rcell[2] =  cell[0] * cell[1]* sinc / v;
    
    cosast   =  (cosb*cosc-cosa) / (sinb*sinc);
    cosbst   =  (cosa*cosc-cosb) / (sina*sinc);
    coscst   =  (cosa*cosb-cosc) / (sina*sinb);
    
    rcell[3] =  acos(cosast)/DEG2RAD;
    rcell[4] =  acos(cosbst)/DEG2RAD;
    rcell[5] =  acos(coscst)/DEG2RAD;
    
}


void extract_HKL_log( char *inpfile )
// Extracting statistics from LOG files of HKL or SCALEPACK 
{
    char str[512], tmp[512];
    int  m=0, k=0, n=0;
    float a1, a2, a3, a4;
    FILE *fp;
    static int nset;
    

    if((fp = fopen(inpfile, "r"))==NULL) {
        printf("Can not open the file (%s)\n", inpfile);
        return ;
    }
    
    while (fgets(str, sizeof str, fp) != NULL) {
        if (strstr_space(str, "Lower Upper  No. of reflections with I / Sigma less than")){
            n=0;
            while (fgets(str, sizeof str, fp) != NULL){
                if(n>=NBIN){
                    n=0;
                    break;
                }
                if(strstr_space(str,"limit limit") && strstr_case(str, "total"))
                   continue;
                if(strstr_space(str, "ALL HKL")){
                    get_last_string(str, 7, tmp);
                    reflns_sf.nrefl=atoi(tmp);
                    break;
                }
                
                if(sscanf(str, "%f%f", &a1, &a2)==2){
                    reflns_sf.resol_L_shell[n]=a1;
                    reflns_sf.resol_H_shell[n]=a2;
                    get_last_string(str, 7, tmp);
                    reflns_sf.nrefl_shell[n]=atoi(tmp);
                    n++;
                }  
            }
        }else if(strstr_space(str, "Lower Upper % ") &&
                 strstr_space(str, "of reflections with I / Sigma less than")){
            
            k=0;
            while (fgets(str, sizeof str, fp) != NULL){
                if(k>=NBIN){
                    k=0;
                    break;
                }
                if(strstr_space(str,"limit limit") && strstr_case(str, "total"))
                   continue;
                if(strstr_space(str, "ALL HKL")){
                    get_last_string(str, 7, tmp);
                    reflns_sf.comp=atof(tmp);
                    break;
                }
                
                if(sscanf(str, "%f%f", &a1, &a2)==2){
                    reflns_sf.resol_L_shell[k]=a1;
                    reflns_sf.resol_H_shell[k]=a2;
                    get_last_string(str, 7, tmp);
                    reflns_sf.comp_shell[k]=atof(tmp);
                    
                    k++;
                }
            }
        }else if(strstr_space(str,"limit  Angstrom  I  error stat. Chi**2  R-fac R-fac")){
            
            m=0;
            while (fgets(str, sizeof str, fp) != NULL){
                if(m>=NBIN){
                    m=0;
                    break;
                }
                
                if(strstr_space(str, "All reflections")){
                    if(sscanf(str, "%f%f%*s%*s%*s%f%f%*s", &a1, &a2, &a3, &a4)==4){
                        reflns_sf.chi2=a3;
                        reflns_sf.Rmerge=a4;
                    }else{
                        get_string(str, 42, 48,tmp);
                        reflns_sf.chi2=atof(tmp);
                        get_string(str, 49, 55,tmp);
                        reflns_sf.Rmerge=atof(tmp);
                    }
                    break;
                }
                
                if(sscanf(str, "%f%f%*s%*s%*s%f%f%*s", &a1, &a2, &a3, &a4)==4){
//                    printf("heloos %.2f %.2f %.2f %.2f\n", a1, a2, a3,a4);
                    
                    reflns_sf.resol_L_shell[m]=a1;
                    reflns_sf.resol_H_shell[m]=a2;
                    reflns_sf.chi2_shell[m]=a3;
                    reflns_sf.Rmerge_shell[m]=a4;
                    m++;
                }else{
                    get_string(str, 4, 10,tmp);
                    reflns_sf.resol_L_shell[m]=atof(tmp);
                    get_string(str, 11, 17,tmp);
                    reflns_sf.resol_H_shell[m]=atof(tmp);
                    get_string(str, 42, 48,tmp);
                    reflns_sf.chi2_shell[m]=atof(tmp);
                    get_string(str, 49, 55,tmp);
                    reflns_sf.Rmerge_shell[m]=atof(tmp);
                    m++;
                }
            }
        }else if(strstr_space(str,"Shell       Average Redundancy Per Shell")){
            rid_of_end_space(str);

            if(strlen(str)<48){
                m=0;
                while (fgets(str, sizeof str, fp) != NULL){
                    if(m>=NBIN){
                        m=0;
                        break;
                    }
                    
                    if(strstr_space(str, "All hkl")){
                        if(sscanf(str, "%*s%*s%f", &a1)==1){
                            reflns_sf.redundancy=a1;
                        }
                        break;
                    }
                
                    if(sscanf(str, "%f%f%f", &a1, &a2, &a3)==3){
                    
                        reflns_sf.resol_L_shell[m]=a1;
                        reflns_sf.resol_H_shell[m]=a2;
                        reflns_sf.redundancy_shell[m]=a3;
//                        printf("hello %.2f %.2f %.2f\n", a1, a2, reflns_sf.redundancy_shell[m]);
                        
                        m++;
                    }
                } 
            }
            
        }
    }
    
    if(n!=0 ){
        nset=nset+1;
        reflns_sf.nset=nset;
        reflns_sf.nbin=n;
    }else if(m!=0){
        nset=nset+1;
        reflns_sf.nset=nset;
        reflns_sf.nbin=m;
    }else if(k!=0){
        nset=nset+1;
        reflns_sf.nset=nset;
        reflns_sf.nbin=k;
    }

    
    if(reflns_sf.nbin>0){
        reflns_sf.resol_L = reflns_sf.resol_L_shell[0];
        reflns_sf.resol_H = reflns_sf.resol_H_shell[ reflns_sf.nbin-1 ];
        return ;
    }else{
        write_data_message("HKL log file", inpfile);
        return ;
    }
    
}


void extract_DTREK_log(char *inpfile )
// Extracting statistics from LOG files of D*trek 
{
    char str[512], tmp[512], **lines=NULL;
    long i=0,m1=0, m2=0, k=0, n=0, in, i1, i2, nline;
    float a1, a2, a3, a4, a5;
    FILE *fp;
    static int nset;
    

    if((fp=fopen(inpfile, "r"))==NULL){
        open_file_error(inpfile, "extract_DTREK_log");
    }
    
    n=num_of_line(inpfile);
    lines=new char *[n];

    i=0;
    while (fgets(str, sizeof str, fp) != NULL) {
        if(is_space_line(str)<2) continue;
        lines[i]= new char[strlen(str)+1];
        strcpy(lines[i], str);
        i++;
    }
    n=i;
    nline=i;
    
    for(i=1; i<n-3; i++){
        if (strstr_space(lines[i], "Unit cell lengths:")){
            strcpy(tmp, strstr_case(lines[i], "lengths:")+8);
            if(sscanf(tmp, "%f%f%f", &a1, &a2, &a3)==3){
                cell.length_a = a1;
                cell.length_b = a2;
                cell.length_c = a3;
            }
        }else if(strstr_space(lines[i], "Unit cell  angles:")){
            strcpy(tmp, strstr_case(lines[i], "angles:")+7);
            if(sscanf(tmp, "%f%f%f", &a1, &a2, &a3)==3){
                cell.angle_alpha = a1;
                cell.angle_beta = a2;
                cell.angle_gamma = a3;
            }
        }else if(strstr_space(lines[i], " Mosaicity:")){
            strcpy(tmp, strstr_case(lines[i], "Mosaicity:")+10);
            if(sscanf(tmp, "%f", &a1)==1){
                reflns_sf.mosaicity = a1;
            }
        }else if(strstr_space(lines[i], "Spacegroup number:")){
            strcpy(tmp, strstr_case(lines[i], "number:")+7);
            if(sscanf(tmp, "%ld", &in)==1){
                symmetry.Int_Tables_number = in;
            }
        }else if(strstr_space(lines[i], " name:") &&
                 strstr_space(lines[i-1], "Spacegroup number:")){
            get_data_set_id(lines[i], "name:", "\n", symmetry.space_group_name_H_M);
            
            rid_of_front_end_space(symmetry.space_group_name_H_M);
            
        }else if(strstr_space(lines[i], "range  unique  obs  rejs  mults single unique  mult  shell  cumul") ){
// Completeness vs Resolution
            m1=0;

            for(k=i+2; k<n-3; k++){
                if(sscanf(lines[k], "%f %*s %f %*s %*s %ld %*s %ld  %*s %*s  %f %*s",
                          &a1,&a2,&i1,&i2, &a3)==5){
                    reflns_sf.resol_L_shell[m1]=a1;
                    reflns_sf.resol_H_shell[m1]=a2;
                    reflns_sf.reject_shell[m1]=i1;
                    reflns_sf.nrefl_shell[m1]=i2;
                    reflns_sf.comp_shell[m1]=a3;
                    m1++;
                }else if(strstr(lines[k], "--------------")){
                    if(sscanf(lines[k+1], "%f %*s %f %*s %*s %ld %*s %ld  %*s %*s  %f %*s",
                              &a1,&a2,&i1,&i2, &a3)==5){
                        reflns_sf.resol_L = a1;
                        reflns_sf.resol_H = a2;
                        reflns_sf.nrefl = i2;
                        reflns_sf.reject = i1;
                        reflns_sf.comp = a3;
                    }
                    i=k+2;
                    break;
                }
            }
            
        }else if(strstr_space(lines[i], "range   counts  obs   rejs   ovlps   mults <sig>>   norm  shell  cumul") ){
//Rmerge vs Resolution
            m2=0;

            for(k=i+2; k<n-3; k++){
                if(sscanf(lines[k], "%f%*s%f %*s%ld%ld  %*s%*s %f%f%f",
                          &a1,&a2, &i1, &i2, &a3, &a4, &a5)==7){
                    
                    reflns_sf.resol_L_shell[m2]=a1;
                    reflns_sf.resol_H_shell[m2]=a2;

//                    reflns_sf.nrefl_shell[m1]=i1;
//                    reflns_sf.reject_shell[m1]=i2;
                    
                    reflns_sf.I_over_sI_shell[m2]=a3;
                    reflns_sf.chi2_shell[m2]=a4;
                    reflns_sf.Rmerge_shell[m2]=a5;
                    m2++;
                }else if(strstr(lines[k], "--------------")){
                    if(sscanf(lines[k+1], "%f%*s%f %*s%ld%ld  %*s%*s %f%f%f",
                              &a1,&a2, &i1, &i2, &a3, &a4, &a5)==7){
                        
                        reflns_sf.resol_L=a1;
                        reflns_sf.resol_H=a2;

//                        reflns_sf.nrefl=i1;
//                        reflns_sf.reject=i2;
                    
                        reflns_sf.I_over_sI=a3;
                        reflns_sf.chi2=a4;
                        reflns_sf.Rmerge=a5;
                    }
                    i=k+2;
                    break;
                }
            }
        }else if(strstr_space(lines[i], "range  counts  rejs  mults  unavg  avg  ChiSq  Eadd*  shell  cumul") ){
//Rmerge vs Resolution
            m2=0;
            for(k=i+2; k<n-3; k++){
                if(sscanf(lines[k], "%f %*s %f %*s %*s %*s %*s %f%f %*s %f",
                          &a1,&a2,&a3,&a4,&a5)==5){
                    reflns_sf.resol_L_shell[m2]=a1;
                    reflns_sf.resol_H_shell[m2]=a2;
                    reflns_sf.I_over_sI_shell[m2]=a3;
                    reflns_sf.chi2_shell[m2]=a4;
                    reflns_sf.Rmerge_shell[m2]=a5;
                    m2++;

                }else if(strstr(lines[k], "--------------")){
                    if(sscanf(lines[k+1], "%f%*s%f %*s%*s%*s%*s %f%f %*s%f",
                              &a1,&a2,&a3,&a4,&a5)==5){
                        reflns_sf.resol_L=a1;
                        reflns_sf.resol_H=a2;
                        reflns_sf.I_over_sI=a3;
                        reflns_sf.chi2=a4;
                        reflns_sf.Rmerge=a5;
                    }
                    i=k+2;
                    break;
                }
            }
                
        }else if(strstr_space(lines[i], "Summary of data collection statistics") ){
            
           for(k=i+2; k<n-3; k++){
                if(strstr_space(lines[k], "Spacegroup ")){
                   strcpy(str, strstr_case(lines[k], "Spacegroup")+10);
                   get_data_set_id(lines[k], "Spacegroup", "\n", symmetry.space_group_name_H_M);
                   
                }else if(strstr_space(lines[k], "Resolution range")){
                   strcpy(str, strstr_case(lines[k], "range")+5); 
                   if(sscanf(str, "%f%*s%f", &a1, &a2) ==2){
                       reflns_sf.resol_L = a1;
                       reflns_sf.resol_H = a2;
                   }
                   
                }else if(strstr_space(lines[k], "Number of unique reflections")){                    
                   strcpy(str, strstr_case(lines[k], "reflections")+11); 
                   if(sscanf(str, "%ld", &i1) ==1) reflns_sf.unique_nrefl=i1;
                   
                }else if(strstr_space(lines[k], "Average redundancy")){
                    strcpy(str, strstr_case(lines[k],"redundancy")+10);
                    if(sscanf(str, "%f", &a1) ==1) reflns_sf.redundancy = a1;
                    
                }else if(strstr_space(lines[k], "% completeness")){   
                    strcpy(str, strstr_case(lines[k],"completeness")+12);
                    if(sscanf(str, "%f", &a1) ==1)  reflns_sf.comp = a1;
                    
                }else if(strstr_space(lines[k], "Rmerge ")){
                    strcpy(str, strstr_case(lines[k],"Rmerge ")+7);
                    if(sscanf(str, "%f", &a1) ==1) reflns_sf.Rmerge = a1;
                    
                }else if(strstr_space(lines[k], "Reduced ChiSquared ")){
                    strcpy(str, strstr_case(lines[k],"ChiSquared")+10);
                    if( sscanf(str, "%f", &a1) ==1) reflns_sf.chi2 = a1;
                    
                }else if(strstr_space(lines[k], "Output <I/sigI>")){
                    strcpy(str, strstr_case(lines[k]," <I/sigI>")+8);
                    if(sscanf(str, "%f", &a1) ==1) reflns_sf.I_over_sI = a1;
                    
                }else if(strstr(lines[k], "--------------")){
                    i=k+2;
                    break;
                }
            }
           
        }
                
    }
        
    
    if(m1!=0 ){
        nset=nset+1;
        reflns_sf.nset=nset;
        reflns_sf.nbin=m1;
    }else if(m2!=0){
        nset=nset+1;
        reflns_sf.nset=nset;
        reflns_sf.nbin=m2;
    }
    if(lines) free_memory_2d(lines, nline);
    
}


void extract_SAINT_log(char *inpfile )
// Extracting statistics from LOG files of HKL or SCALEPACK 
{
    char str[512], tmp[512];
    long k=0, n=0, i1,i2;
    float a1, a2, a3, a4, a5;
    FILE *fp;
    static int nset;
    
    if((fp=fopen(inpfile, "r"))==NULL)
       open_file_error(inpfile, "extract_log_SAINT");
    
    while (fgets(str, sizeof str, fp) != NULL) {
        k=0;
        if (strstr_space(str, "Overall    #  Pairs   Uniq   Merg %<2s   <I> <#Sig>   <Bg>  Rsym ")){
            while (fgets(str, sizeof str, fp) != NULL){
                rid_of_front_space(str);
                if(strlen(str)<20) continue;  
                k=sscanf(str,"%*s %ld %*s %ld  %*s%*s  %f%f %*s %f",
                         &i1, &i2, &a1, &a2, &a3);
                if( k==5 ){
                    reflns_sf.nrefl = i1;
                    reflns_sf.unique_nrefl = i2;
                    reflns_sf.I_over_sI = a1/a2;
                    reflns_sf.Rsym=a3;
               
                }else{
                    break;
                }
            }
            
        }
        if(k==5)break;
    }
    
    rewind(fp);
    while (fgets(str, sizeof str, fp) != NULL) {
        if (strstr_space(str, "Angstrms   #Obs Theory %Compl Redund   Rsym Pairs %Pairs")){
            n=0;
            while (fgets(str, sizeof str, fp) != NULL){
                rid_of_front_space(str);
                if(n>=NBIN){
                    n=0;
                    break;
                }
                if(strlen(str)<20) continue;
                
                k=sscanf(str,"%s %f%ld%*s %f%f%f%*s%*s%f",
                         tmp, &a1, &i1, &a2, &a3, &a4, &a5);
                
                if( k==7 && !strcmp_case(tmp,"to")){
                    reflns_sf.resol_H=a1;
                    reflns_sf.resol_H_shell[n]=a1;
                    if(n==0) reflns_sf.resol_L_shell[0]=-99999;
                    if(n>0) reflns_sf.resol_L_shell[n] = reflns_sf.resol_H_shell[n-1];
//                    reflns_sf.nrefl=i1;
                    reflns_sf.comp=a2;
                    reflns_sf.redundancy=a3;
                    reflns_sf.Rsym=a4;
                    reflns_sf.Rsym_shell[n]=a5;
                    n++;
                }else {
                    break;
                }
            }
        }


        
    }
//    printf("EsssEEEEE =%d %d %7.2f %7.2f %7.2f\n",n ,
//    reflns_sf.nrefl, reflns_sf.comp,reflns_sf.redundancy,reflns_sf.Rsym);
    
    
    if(n>0 ){
        nset=nset+1;
        reflns_sf.nset=nset;
        reflns_sf.nbin=n;
    }
    if(reflns_sf.nbin<=0){
        write_data_message("SAINT log ", inpfile);
    }
    
}


void extract_SCALA_log(char *inpfile )
/* Extracting statistics from LOG files of SCALA
   Things extracted are :I/sigmaI, completeness, Nrefl, redundancy,Rsym,
   any with resolution shells.
 */  
{
    char str[512], tmp[512];
    int k=0, n=0, nset1=0, nset2=0;
    float a1, a2, a3, a4, a5, a6;
    FILE *fp;
    static int nset;
    
    if((fp=fopen(inpfile, "r"))==NULL)
       open_file_error(inpfile, "extract_log_SCALA");
    
    while (fgets(str, sizeof str, fp) != NULL) {
      
        if (strstr_space(str, " * Cell Dimensions :")){
            k=0;
            while (fgets(str, sizeof str, fp) != NULL){
                rid_of_front_space(str);
                if(strlen(str)<2) continue;  
                n=sscanf(str,"%f%f%f%f%f%f", &a1, &a2, &a3, &a4, &a5, &a6);
                if( n==6 ){

                    cell.length_a = a1;
                    cell.length_b = a2;
                    cell.length_c = a3;
                    cell.angle_alpha = a4;
                    cell.angle_beta = a5;
                    cell.angle_gamma = a6;
                    
                    break;
                }
                if(k++>=1) break;
            }
        }else if(strstr_space(str, "*  Resolution Range :")){
            k=0;
            while (fgets(str, sizeof str, fp) != NULL){
                rid_of_front_space(str);
                if(strlen(str)<2) continue;                
                if(pattern5(str," ( ", " - ", "A", ")", "")){
                    n=sscanf(str,"%*s %*s %*s %f %*s %f", &a1, &a2);
                    if( n==2 ){
                        reflns_sf.resol_L = a1;
                        reflns_sf.resol_H = a2;
                        break;
                    }
                }
                if(k++>=1) break;
            }
        }else if(pattern5(str, "Space group =", "(number", ")", "", "") ){
            strcpy(tmp, "");
            strcpy(tmp, get_substr(str,"Space group =", "(number"));
            char2space(tmp, '\'');
            if(strlen(tmp)>0) strcpy(symmetry.space_group_name_H_M, tmp);
            strcpy(tmp, "");
            strcpy(tmp, get_substr(str,"number", ")"));
            if(strlen(tmp)>0)symmetry.Int_Tables_number = atoi(tmp);
            
        }else if(strstr_space(str, " N 1/d^2 Dmin(A) Rfac  Rfull   Rcum  Ranom  Nanom    Av_I   SIGMA I/sigma") ||
// version before CCP4 5.0
                 strstr_space(str, " N 1/d^2 Dmin(A) Rmrg  Rfull   Rcum  Ranom  Nanom    Av_I   SIGMA I/sigma") ){
// version after CCP4 5.0
            n=0;
            while (fgets(str, sizeof str, fp) != NULL){
                rid_of_end_space(str);
                if(n>=NBIN){
                    n=0;
                    break;
                }
                
                if(pattern5(str,"Overall", ".", ".",".",".")){
                    reflns_sf.I_over_sI = get_float_by_length(str, 67, 72) ;
                    reflns_sf.Rmerge = get_float_by_length(str, 16, 21) ;
                    break;
                }
                if(pattern5(str,"name=", "intensi", "by", "", "")||
                   pattern5(str,"ranges","", "","", "")) break;
                
                
                if(strlen(str)<20 || !pattern5(str, ".",".",".", ".",".") )continue;
                
                reflns_sf.resol_H_shell[n] = get_float_by_length(str, 10, 15) ;
                if(n==0) reflns_sf.resol_L_shell[0] = reflns_sf.resol_L;
                if(n>0) reflns_sf.resol_L_shell[n] = reflns_sf.resol_H_shell[n-1];
                reflns_sf.I_over_sI_shell[n] = get_float_by_length(str, 67, 72) ;
                reflns_sf.Rmerge_shell[n] = get_float_by_length(str, 16, 21) ;

                n++;
            }
            nset1=n;
           
        }else if(strstr_space(str,"N 1/resol^2 Dmin    Nmeas    Nref  Ncent   %poss Cm%poss Mlplcty")){
// version before CCP4 5.0                 
            
            n=0;
            while (fgets(str, sizeof str, fp) != NULL){
                rid_of_end_space(str);
                if(n>=NBIN){
                    n=0;
                    break;
                }
                
                if(pattern5(str,"Overall", ".", ".",".",".")){
                    reflns_sf.nrefl =  get_int_by_length(str, 28, 35) ;
                    reflns_sf.comp = get_float_by_length(str, 43, 50);
                    reflns_sf.redundancy = get_float_by_length(str, 59, 66);
                    reflns_sf.Rsym = get_float_by_length(str, 99, 106);
//    printf("EsssEEEEE = %s%d %d %7.2f %7.2f %7.2f\n",str, n , reflns_sf.nrefl, reflns_sf.comp,reflns_sf.redundancy,reflns_sf.Rsym);
                    break;
                }
                if(strlen(str)<20 || !pattern5(str, ".",".",".", ".",".") )continue;
                
                reflns_sf.resol_H_shell[n] = get_float_by_length(str, 11, 18) ;
                if(n==0) reflns_sf.resol_L_shell[0] = reflns_sf.resol_L;
                if(n>0) reflns_sf.resol_L_shell[n] = reflns_sf.resol_H_shell[n-1];
                reflns_sf.nrefl_shell[n] = get_int_by_length(str, 28, 35) ;
                reflns_sf.comp_shell[n] = get_float_by_length(str, 43, 50);
                reflns_sf.redundancy_shell[n] = get_float_by_length(str, 59, 66);
                reflns_sf.Rsym_shell[n] = get_float_by_length(str, 99, 106);

                n++;
            }
            nset2=n;  
        }else if(strstr_space(str," N 1/resol^2 Dmin   Nmeas    Nref  Ncent  %poss C%poss") &&
                 strstr_space(str,"C%poss Mlplct AnoCmpl AnoFrc AnoMlt Rmeas Rmeas0  (Rsym)")){
// version after CCP4 5.0
            
            n=0;
            while (fgets(str, sizeof str, fp) != NULL){
                rid_of_end_space(str);
                if(n>=NBIN){
                    n=0;
                    break;
                }
                
                if(pattern5(str,"Overall", ".", ".",".",".")){
                    reflns_sf.nrefl =  get_int_by_length(str, 27, 34) ;
                    reflns_sf.comp = get_float_by_length(str, 42, 48);
                    reflns_sf.redundancy = get_float_by_length(str, 56, 62);
                    reflns_sf.Rsym = get_float_by_length(str, 100, 107);
                    break;
                }
                if(strlen(str)<20 || !pattern5(str, ".",".",".", ".",".") )continue;
                
                reflns_sf.resol_H_shell[n] = get_float_by_length(str, 11, 17) ;
                if(n==0) reflns_sf.resol_L_shell[0] = reflns_sf.resol_L;
                if(n>0) reflns_sf.resol_L_shell[n] = reflns_sf.resol_H_shell[n-1];
                reflns_sf.nrefl_shell[n] = get_int_by_length(str, 27, 34) ;
                reflns_sf.comp_shell[n] = get_float_by_length(str, 42, 48);
                reflns_sf.redundancy_shell[n] = get_float_by_length(str, 56, 62);
                reflns_sf.Rsym_shell[n] = get_float_by_length(str, 100, 107);

                n++;
            }
            nset2=n;  
        }else if(strstr_space(str," N 1/resol^2 Dmin   Nmeas    Nref  Ncent  %poss C%poss") &&
                  strstr_space(str,"C%poss Mlplct AnoCmp AnoFrc AnoMlt Rmeas Rmeas0  (Rsym)")){
// version after CCP4 5.99
            
            n=0;
            while (fgets(str, sizeof str, fp) != NULL){
                rid_of_end_space(str);
                if(n>=NBIN){
                    n=0;
                    break;
                }
                
                if(pattern5(str,"Overall", ".", ".",".",".")){
                    reflns_sf.nrefl =  get_int_by_length(str, 16, 25) ;
                    reflns_sf.comp = get_float_by_length(str, 40, 46);
                    reflns_sf.redundancy = get_float_by_length(str, 54, 59);
                    reflns_sf.Rsym = get_float_by_length(str, 95, 101);
                    break;
                }
                if(strlen(str)<20 || !pattern5(str, ".",".",".", ".",".") )continue;
                
                reflns_sf.resol_H_shell[n] = get_float_by_length(str, 9, 15) ;
                if(n==0) reflns_sf.resol_L_shell[0] = reflns_sf.resol_L;
                if(n>0) reflns_sf.resol_L_shell[n] = reflns_sf.resol_H_shell[n-1];
                reflns_sf.nrefl_shell[n] = get_int_by_length(str, 25, 32) ;
                reflns_sf.comp_shell[n] = get_float_by_length(str, 40, 46);
                reflns_sf.redundancy_shell[n] = get_float_by_length(str, 54, 59);
                reflns_sf.Rsym_shell[n] = get_float_by_length(str, 95, 101);

                n++;
            }
            nset2=n;  
        }

        
    }
    
    if(nset1 >0 && nset2 >0){
        nset=nset+1;
        reflns_sf.nset=nset;
        reflns_sf.nbin=nset2;
    }
    if(reflns_sf.nbin<=0){
        printf("No information for resolution shells was extracted!\n");
    }
    
}




void extract_3DSCALE_log(char *inpfile )
// Extracting statistics from LOG files of 3DSCALE
{
    char str[512], tmp[512];
    int k=0, n=0, i1,i2, i3,i4;
    float a1, a2, a3, a4, a5, a6, a7, a8;
    FILE *fp;
    static int nset;
    
    if((fp=fopen(inpfile, "r"))==NULL)
       open_file_error(inpfile, "extract_log_3DSCALE");
    
    while (fgets(str, sizeof str, fp) != NULL) {
        k=0;
        if (pattern5(str, "Unit cell",": ","","","") ){
            strcpy(tmp, strstr(str,":")+1);
            k=sscanf(tmp,"%f%f%f%f%f%f", &a1, &a2, &a3, &a4, &a5, &a6);
            if(k==6){

                cell.length_a = a1;
                cell.length_b = a2;
                cell.length_c = a3;
                cell.angle_alpha = a4;
                cell.angle_beta = a5;
                cell.angle_gamma = a6;
            }
        }else if(pattern5(str, "Space Group", ": ","","","") ){
            
            strcpy(tmp, strstr(str,":")+1);
            k=sscanf(tmp,"%d%s", &n, str);
            if(k==2){
                symmetry.Int_Tables_number = n;
                strcpy(symmetry.space_group_name_H_M, strstr(tmp, str));
                rid_of_front_end_space(symmetry.space_group_name_H_M);
            }
        }else if(pattern5(str, " Overall Resolution Cutoff ", ": ","","","") ){
            strcpy(tmp, strstr(str,":")+1);
            k=sscanf(tmp,"%f%f", &a1, &a2);
            if(k==2){
                reflns_sf.resol_L= a1;
                reflns_sf.resol_H= a2;
            }
        }else if(strstr_space(str, " rejected as outliers") ){
            
            k=sscanf(str,"%d %d", &i1, &i2);
            if(k==2){
                reflns_sf.reject=i2;
            }
        }else if(pattern5(str, " Observed  ", " Unique  "," Observed "," Unique ","") ){
            while (fgets(str, sizeof str, fp) != NULL)
                if(is_space_line(str)>20) break;
            k=sscanf(str,"%d %d %d %d", &i1, &i2, &i3, &i4);
            if(k==4){
                reflns_sf.nrefl = i3;
                reflns_sf.unique_nrefl = i4;
            }
        }else if(strstr_space(str,"Shell nRefObs nRefExp Compl% Redund  Rsym---Shell Rfree nRfree")
                 && strstr_space(str,"<i/sigi>--Shell <I/sigI>--Shell <Chi^2>    N(+)    N(-)")){
            n=0;
            while (fgets(str, sizeof str, fp) != NULL){
                rid_of_front_space(str);
                k=sscanf(str,"%s %f %*s%*s %f%f%f%f %*s%*s%*s%*s %f%f%f",
                          tmp,&a1, &a2, &a3, &a4, &a5, &a6, &a7, &a8);
                if(n>1 && k!=9 && strcmp_case(tmp,"to")) break;
                if( k==9 && !strcmp_case(tmp,"to")){
                    reflns_sf.resol_H_shell[n]=a1;
                    if(n>0) reflns_sf.resol_L_shell[n] = reflns_sf.resol_H_shell[n-1];
                    reflns_sf.comp=a2;
                    reflns_sf.redundancy=a3;
                    reflns_sf.Rsym=a4;
                    reflns_sf.Rsym_shell[n]=a5;
                    reflns_sf.I_over_sI=a6;
                    reflns_sf.I_over_sI_shell[n]=a7;
                    reflns_sf.chi2=a8;
                    n++;
                }
            }
            
        }else if(strstr_space(str,"Shell nRefObs nRefExp nRefCen Compl% Redund  Rsym---Shell Rfree nRfree")
                 && strstr_space(str,"<i/sigi>--Shell <I/sigI>--Shell <Chi^2> <AnoI/SigI>")){
            n=0;
            while (fgets(str, sizeof str, fp) != NULL){
                rid_of_front_space(str);
                k=sscanf(str,"%s %f %*s%*s%*s %f%f%f%f %*s%*s%*s%*s %f%f%f",
                          tmp,&a1, &a2, &a3, &a4, &a5, &a6, &a7, &a8);
                if(n>1 && k!=9 && strcmp_case(tmp,"to")) break;
                if( k==9 && !strcmp_case(tmp,"to")){
                    reflns_sf.resol_H_shell[n]=a1;
                    if(n>0) reflns_sf.resol_L_shell[n] = reflns_sf.resol_H_shell[n-1];
                    reflns_sf.comp=a2;
                    reflns_sf.redundancy=a3;
                    reflns_sf.Rsym=a4;
                    reflns_sf.Rsym_shell[n]=a5;
                    reflns_sf.I_over_sI=a6;
                    reflns_sf.I_over_sI_shell[n]=a7;
                    reflns_sf.chi2=a8;
                    n++;
                }
            }
            
        }
       
         
    }
    reflns_sf.resol_L_shell[0]=reflns_sf.resol_L;
//    printf("EsssEEEEE =%d %d %7.2f %7.2f %7.2f\n",n , reflns_sf.nrefl, reflns_sf.comp,reflns_sf.redundancy,reflns_sf.Rsym);
    
    
    if(n>0 ){
        nset=nset+1;
        reflns_sf.nset=nset;
        reflns_sf.nbin=n;
    }
    if(reflns_sf.nbin<=0){
        write_data_message("3DSCALE log ", inpfile);
    }
   
    
}




void extract_XSCALE_log(char *inpfile, int *key )
// Extracting statistics from LOG files of 3DSCALE
{
    char str[512], tmp[512], rmean[20], comp[20];
    int k=0, n=0, nset=0, nfile=0, nf, nf_u;
    float a1, a2, a3, a4, a5, a6;
    FILE *fp;


                    
    if((fp=fopen(inpfile, "r"))==NULL)
       open_file_error(inpfile, "extract_log_XSCALE");
    
    while (fgets(str, sizeof str, fp) != NULL) {
        k=0;
        if (pattern5(str, "UNIT_CELL_CONSTANTS=",".",".",".",".") ){
            strcpy(tmp, strstr(str,"=")+1);
            k=sscanf(tmp,"%f%f%f%f%f%f", &a1, &a2, &a3, &a4, &a5, &a6);
            if(k==6){

                cell.length_a = a1;
                cell.length_b = a2;
                cell.length_c = a3;
                cell.angle_alpha = a4;
                cell.angle_beta = a5;
                cell.angle_gamma = a6;
            }
        }else if(pattern5(str, "SPACE_GROUP_NUMBER=", "","","","") ){
            strcpy(tmp, strstr(str,"=")+1);
            k=sscanf(tmp,"%d", &n);
            if(k==1){
                symmetry.Int_Tables_number = n;
            }
        }else if(strstr_space(str, "SUBSET OF INTENSITY DATA WITH SIGNAL/NOISE >=  0.0 AS FUNCTION OF RESOLUTION") ){
            nfile++;
            n=0;
            while (fgets(str, sizeof str, fp) != NULL){
                k=sscanf(str,"%f %d %d %*s %s  %*s%*s%*s %f %s %*s%*s",
                          &a1, &nf, &nf_u,  comp, &a2, rmean);
                
                if(pattern5(str,"total ", ".", "%", "%", "%"))break;
                
                
//                if(n>1 && k!=6 && strcmp_case(tmp,"to")) break;
                if( k==6){
                    reflns_sf.resol_H_shell[n]=a1;
                    if(n>0) reflns_sf.resol_L_shell[n] = reflns_sf.resol_H_shell[n-1];
                    reflns_sf.nrefl_shell[n]=nf;
                    reflns_sf.unique_nrefl_shell[n]=nf_u;
                    
                    char2space(comp, '%');
                    reflns_sf.comp_shell[n]=atof(comp);
                    
                    reflns_sf.I_over_sI_shell[n]=a2;

                    char2space(rmean, '%');
                    reflns_sf.Rmerge_shell[n]=atof(rmean);
//                    printf("shells = %6.2f %8d %8d  %6.2f %6.2f %6.2f\n", a1, nf, nf_u, atof(comp), a2, atof(rmean));
                    n++;
                }
            }
            
            if(pattern5(str,"total ", ".", "%", "%", "%")){
//            printf("here str=%s", str);
                reflns_sf.resol_L_shell[0]=-999999;
                strcpy(reflns_sf.details, "SIGNAL/NOISE >=  0.0");
                
                k=sscanf(str,"%*s %d %d %*s %s  %*s%*s%*s %f %s %*s%*s",
                          &nf, &nf_u,  comp, &a2, rmean);
                if( k==5){
                    reflns_sf.resol_H=reflns_sf.resol_H_shell[n-1];
                    reflns_sf.resol_L = -999999;
                    reflns_sf.nrefl=nf;
                    reflns_sf.unique_nrefl=nf_u;
                    
                    char2space(comp, '%');
                    reflns_sf.comp=atof(comp);
                    reflns_sf.I_over_sI=a2;

                    char2space(rmean, '%');
                    reflns_sf.Rmerge=atof(rmean);

                    if(n>0 ){
                        nset=nset+1;
                        reflns_sf.nset=nset;
                        reflns_sf.nbin=n;
                    }
                    if(reflns_sf.nbin<=0){
                        write_data_message("XSCALE log ", inpfile);
                    }
                        
    
                    if(reflns_sf.nbin >0){
                        if(nset-1 >=0) diffrn_sf[nset-1]=reflns_sf;
                        if(nset>29) return;
                    }
                        
//                    printf("all = %6.2f %8d %8d  %6.2f %6.2f %6.2f\n", a1, nf, nf_u, atof(comp), a2, atof(rmean));
                    
                }     
                    
            }
        }
    }
    *key=nset;
//    printf("nfile= %d  %d\n", nfile,nset);
    
    fclose(fp);
}


void extract_PROSCALE_log(char *inpfile)
// Extracting statistics from LOG files of PROSCALE
{
    char tmp[512], **lines;
    int i,ii,k=0,j=0, n=0, nset=0, nline=0;
    int n1,n2,n3,n4; 
    float a1, a2, a3, a4, a5, a6, b[20];

    lines=get_lines_from_file(inpfile, &nline);

    for(i=0; i<nline; i++){
        if(strstr_space(lines[i], "Space Group:")){
            n=get_int_after_id(lines[i]," Group:");
            if(n>0) symmetry.Int_Tables_number = n;
            get_string_with_length(lines[i],18, 35, tmp);
            rid_of_front_end_space(tmp);
            if(strlen(tmp)>0) strcpy(symmetry.space_group_name_H_M, tmp);
            
        }else if(strstr_space(lines[i], "<<< Unit cell >>>:")){
            strcpy(tmp, strstr(lines[i],">>>:")+5);
            k=sscanf(tmp,"%f%f%f%f%f%f", &a1, &a2, &a3, &a4, &a5, &a6);
            if(k==6){
                cell.length_a = a1;
                cell.length_b = a2;
                cell.length_c = a3;
                cell.angle_alpha = a4;
                cell.angle_beta = a5;
                cell.angle_gamma = a6;
            }
            
        }else if(strstr_space(lines[i], "<<< Overall Resolution Cutoff >>>:")){
            strcpy(tmp, strstr(lines[i],">>>:")+5);
            k=sscanf(tmp,"%f%f", &a1, &a2);
            if(k==2){
                reflns_sf.resol_H = a2;
                reflns_sf.resol_L = a1;
            }
            
        }else if(strstr_space(lines[i], "<<< Overall I/SigI Cutoff >>>:")){
            strcpy(tmp, strstr(lines[i],">>>:")+5);
            k=sscanf(tmp,"%f%f", &a1, &a2);
            if(k==2){
                reflns_sf.obs_criterion = a1;
                reflns_sf.criterion_I_min = a1;
                reflns_sf.criterion_I_max = a2;
//                printf("hello=%.2f %.2f\n", a1, a2);
                
            }
            
        }else if(strstr_space(lines[i],"Observed      Unique    Observed      Unique ")){
            if(i<nline-2 && strstr_space(lines[i+1],"total reflections")){
                if(sscanf(lines[i+1],"%d%d%d%d", &n1, &n2, &n3, &n4)==4){
                    reflns_sf.nrefl  = n3;
                    reflns_sf.unique_nrefl  = n4;
                }
            }
            
        }else if(strstr_space(lines[i],"    rejected as outliers")){
            n1 = get_int_by_length(lines[i], 4, 14);
            n2 = get_int_by_length(lines[i], 28, 37);
            if(n1>=0 && n2>=0){
                reflns_sf.reject = n2;
            }
        }else if(strstr_space(lines[i],"Res.Shell nRefObs nRefExp Compl% Redund    Rsym---Shell")){
            n=0;
            for(j=i; j<nline;j++){
                k=sscanf(lines[j], "%s%f %*s%*s %f%f%f%f %*s%*s %f%f%f%f%f",
                         tmp, &b[0],&b[1],&b[2],&b[3],&b[4],&b[5],&b[6],&b[7],&b[8],&b[9]);
                
                
                if( k==11 && !strcmp_case(tmp, "to") ){
                    
                    reflns_sf.resol_H_shell[n]=b[0];
                    reflns_sf.comp = b[1];
                    reflns_sf.redundancy = b[2];
                    reflns_sf.Rsym =  b[3];
                    reflns_sf.Rsym_shell[n] =  b[4];
                    reflns_sf.I_over_sI = b[5];
                    reflns_sf.I_over_sI_shell[n] = b[6];
                    reflns_sf.chi2  = b[7];
                    reflns_sf.ano_I_over_sI  = b[8];
                    reflns_sf.ano_I_over_sI_shell[n]  = b[9];

                    n++;
                }
                if(n>1 && k !=11){
                    reflns_sf.resol_L_shell[0]=reflns_sf.resol_L;
                    for(ii=0; ii<n-1; ii++){
                        reflns_sf.resol_L_shell[ii+1] = reflns_sf.resol_H_shell[ii];
                    }
                    i=j;
                    
                    break;
                }
            }
            
        }
    }
    
    if(n>0 ){
        nset=nset+1;
        reflns_sf.nset=nset;
        reflns_sf.nbin=n;
    }
    if(reflns_sf.nbin<=0){
        write_data_message("PROSCALE LOG ", inpfile);
    }
    
                
//    printf("nfile= %d  %d\n", nfile,nset);
 }




void initial_reflns(void)
{
    int i;

    strcpy(reflns_sf.space_gp, "?");
    strcpy(reflns_sf.id, "? ?");

    reflns_sf.resol_H=-99998.1;
    reflns_sf.resol_L=-99998.1;
    reflns_sf.comp=-99998.1;
    reflns_sf.Rmerge=-99998.1;
    reflns_sf.Rsym=-99998.1;
    reflns_sf.chi2=-99998.1;
    reflns_sf.I_over_sI=-99998.1;
    reflns_sf.redundancy=-99998.1;
    reflns_sf.mosaicity=-99998.1;
    
    reflns_sf.nrefl=-99998;
    reflns_sf.unique_nrefl=-99998;
    reflns_sf.nbin=-99998;
    reflns_sf.nset=-99998;
    reflns_sf.space_gp_num=-99998;
    reflns_sf.reject=-99998;
    reflns_sf.obs_criterion=-99998;
    reflns_sf.criterion_I_max=-99998;
    reflns_sf.criterion_I_min=-99998;
    reflns_sf.ano_I_over_sI=-99998;
    
    for(i=0; i<NBIN; i++){
        reflns_sf.resol_H_shell[i]=-99998.1;
        reflns_sf.resol_L_shell[i]=-99998.1;
        reflns_sf.comp_shell[i]=-99998.1;
        reflns_sf.Rmerge_shell[i]=-99998.1;
        reflns_sf.Rsym_shell[i]=-99998.1;
        reflns_sf.chi2_shell[i]=-99998.1;
        reflns_sf.I_over_sI_shell[i]=-99998.1;
        reflns_sf.ano_I_over_sI_shell[i]=-99998.1;
        reflns_sf.redundancy_shell[i]=-99998.1;
    
        reflns_sf.nrefl_shell[i]=-99998;
        reflns_sf.unique_nrefl_shell[i]=-99998;
        reflns_sf.reject_shell[i]=-99998;
    }

   
    reflns_sf.a=-99998.1;
    reflns_sf.b=-99998.1;
    reflns_sf.c=-99998.1;
    reflns_sf.alpha=-99998.1;
    reflns_sf.beta=-99998.1;
    reflns_sf.gamma=-99998.1;

}

///////////////////////////////////////// for index /////////////////////

void extract_HKL_log_index( char *inpfile )
// Extracting index information  from LOG files of HKL or SCALEPACK 
{
    char str[256], tmp1[80], tmp2[80];
    int  n=0;
    float a1, a2, a3;
    FILE *fp;
    

    if((fp = fopen(inpfile, "r"))==NULL) {
        printf("Can not open the file (%s)\n", inpfile);
        return ;
    }
    
    while (fgets(str, sizeof str, fp) != NULL) {
        n = sscanf(str,"%s%s%f%f%f", tmp1, tmp2, &a1,&a2,&a3);
        if(n==5 && !strcmp_case(tmp1, "FIT")){
            
            if(!strcmp_case(tmp2, "CRYSX")){
                pdbx_crystal_alignment.crysx_spindle = a1;
                pdbx_crystal_alignment.crysx_spindle_esd = a3;
                
            }else if( !strcmp_case(tmp2, "CRYSY")){
                pdbx_crystal_alignment.crysy_vertical = a1;
                pdbx_crystal_alignment.crysy_vertical_esd = a3;
                
            }else if( !strcmp_case(tmp2, "CRYSZ")){
                pdbx_crystal_alignment.crysz_beam = a1;
                pdbx_crystal_alignment.crysz_beam_esd = a3;
                
            }else if( !strcmp_case(tmp2, "XBEAM")){
                pdbx_crystal_alignment.xbeam = a1;
                pdbx_crystal_alignment.xbeam_esd = a3;
                
            }else if( !strcmp_case(tmp2, "YBEAM")){
                pdbx_crystal_alignment.ybeam = a1;
                pdbx_crystal_alignment.ybeam_esd = a3;
                
            }else if( !strcmp_case(tmp2, "CROSX")){
                pdbx_crystal_alignment.crossfire_x = a1;
                pdbx_crystal_alignment.crossfire_x_esd = a3;
                
            }else if( !strcmp_case(tmp2, "CROSY")){
                pdbx_crystal_alignment.crossfire_y = a1;
                pdbx_crystal_alignment.crossfire_y_esd = a3;
                
            }else if( !strcmp_case(tmp2, "CROSXY")){
                pdbx_crystal_alignment.crossfire_xy = a1;
                pdbx_crystal_alignment.crossfire_xy_esd = a3;
                
            }else if( !strcmp_case(tmp2, "DISTANCE")){
                pdbx_crystal_alignment.crystal_to_detector_distance = a1;
                pdbx_crystal_alignment.crystal_to_detector_distance_esd = a3;
                 
            }else if( !strcmp_case(tmp2, "MOSAICITY")){
                exptl_crystal.pdbx_mosaicity = a1;
                exptl_crystal.pdbx_mosaicity_esd = a3;
            }
            
        }else if(!strcmp_case(tmp1, "CrysX") &&
                 pattern5(str, "(spindle)", ".", "shift", "error", ".")){
            pdbx_crystal_alignment.crysx_spindle = get_float(str,")", "shift");
            pdbx_crystal_alignment.crysx_spindle_esd = get_float(str, "error","\n");
            
        }else if(!strcmp_case(tmp1, "CrysY") &&
                 pattern5(str, "(vertical)", ".", "shift", "error", ".")){
            pdbx_crystal_alignment.crysy_vertical = get_float(str,")", "shift");
            pdbx_crystal_alignment.crysy_vertical_esd = get_float(str, "error","\n");
            
        }else if(!strcmp_case(tmp1, "CrysZ") &&
                 pattern5(str, "(beam)", ".", "shift", "error", ".")){
            pdbx_crystal_alignment.crysz_beam = get_float(str,")", "shift");
            pdbx_crystal_alignment.crysz_beam_esd = get_float(str, "error","\n");
            
        }else if(!strcmp_case(tmp1, "X") &&
                 pattern5(str, "beam", ".", "shift", "error", ".")){
            pdbx_crystal_alignment.xbeam = get_float(str,"beam", "shift");
            pdbx_crystal_alignment.xbeam_esd = get_float(str, "error","\n");
            
        }else if(!strcmp_case(tmp1, "Y") &&
                 pattern5(str, "beam", ".", "shift", "error", ".")){
            pdbx_crystal_alignment.ybeam = get_float(str,"beam", "shift");
            pdbx_crystal_alignment.ybeam_esd = get_float(str, "error","\n");

            
        }else if(!strcmp_case(tmp1, "Crossfire") &&
                 pattern5(str, " x ", ".", "shift", "error", ".")){
            pdbx_crystal_alignment.crossfire_x = get_float(str," x ", "shift");
            pdbx_crystal_alignment.crossfire_x_esd = get_float(str, "error","\n");
            
        }else if(!strcmp_case(tmp1, "Crossfire") &&
                 pattern5(str, " y ", ".", "shift", "error", ".")){
            pdbx_crystal_alignment.crossfire_y = get_float(str," y ", "shift");
            pdbx_crystal_alignment.crossfire_y_esd = get_float(str, "error","\n");

        }else if(!strcmp_case(tmp1, "Crossfire") &&
                 pattern5(str, " xy ", ".", "shift", "error", ".")){
            pdbx_crystal_alignment.crossfire_xy = get_float(str," xy ", "shift");
            pdbx_crystal_alignment.crossfire_xy_esd = get_float(str, "error","\n");

            
        }else if(!strcmp_case(tmp1, "distance") &&
                 pattern5(str, "distance", ".", "shift", "error", ".")){
            pdbx_crystal_alignment.crystal_to_detector_distance = get_float(str,"distance", "shift");
            pdbx_crystal_alignment.crystal_to_detector_distance_esd = get_float(str, "error","\n");

        }else if(!strcmp_case(tmp1, "Mosaicity") &&
                 pattern5(str, "Mosaicity", ".", "", "", "")){
            exptl_crystal.pdbx_mosaicity= get_float(str, "Mosaicity","\n");
            
        }
        
        
    }
    
               
    fclose(fp);
    
}

void extract_DTREK_log_index( char *inpfile )
// Extracting index information  from LOG files of D*trek 
{
    char str[256], tmp1[80], tmp2[80];
    int  n=0;
    float a1, a2, a3;
    FILE *fp;
    

    if((fp = fopen(inpfile, "r"))==NULL) {
        printf("Can not open the file (%s)\n", inpfile);
        return ;
    }
    
    while (fgets(str, sizeof str, fp) != NULL) {
        n = sscanf(str,"%s%s%f%*s%f%*s%f", tmp1, tmp2, &a1,&a2,&a3);
        if(n==5){
             if(!strcmp_case(tmp1, "CrysX") && !strcmp_case(tmp2,"(spindle)")){
                 pdbx_crystal_alignment.crysx_spindle = a1;
                 pdbx_crystal_alignment.crysx_spindle_esd = a3;
                
             }else if(!strcmp_case(tmp1, "CrysY")&& !strcmp_case(tmp2, "(vertical)")){
                pdbx_crystal_alignment.crysy_vertical = a1;
                pdbx_crystal_alignment.crysy_vertical_esd = a3;
                
            }else if(!strcmp_case(tmp1, "CRYSZ") &&!strcmp_case(tmp2, "(beam)")){
                pdbx_crystal_alignment.crysz_beam = a1;
                pdbx_crystal_alignment.crysz_beam_esd = a3;
                
            }else if( !strcmp_case(tmp1, "X")&& !strcmp_case(tmp2, "BEAM")){
                pdbx_crystal_alignment.xbeam = a1;
                pdbx_crystal_alignment.xbeam_esd = a3;
                
            }else if( !strcmp_case(tmp1, "Y")&& !strcmp_case(tmp2, "BEAM")){
                pdbx_crystal_alignment.ybeam = a1;
                pdbx_crystal_alignment.ybeam_esd = a3;
                
            }else if( !strcmp_case(tmp1, "Crossfire")&& !strcmp_case(tmp2, "X")){
                pdbx_crystal_alignment.crossfire_x = a1;
                pdbx_crystal_alignment.crossfire_x_esd = a3;
                
            }else if( !strcmp_case(tmp1, "Crossfire")&&!strcmp_case(tmp2, "Y")){
                pdbx_crystal_alignment.crossfire_y = a1;
                pdbx_crystal_alignment.crossfire_y_esd = a3;
                
            }else if( !strcmp_case(tmp1, "Crossfire")&& !strcmp_case(tmp2, "XY")){
                pdbx_crystal_alignment.crossfire_xy = a1;
                pdbx_crystal_alignment.crossfire_xy_esd = a3;
            }
        }else if(!strcmp_case(tmp1, "DISTANCE")){
            n=sscanf(str,"%s%f%s%f%*s%f", tmp1, &a1, tmp2,&a2,&a3);
            if(n==5 && !strcmp_case(tmp2, "shift")){
                pdbx_crystal_alignment.crystal_to_detector_distance = a1;
                pdbx_crystal_alignment.crystal_to_detector_distance_esd = a3;
                 
            }
        }else if( !strcmp_case(tmp1, "MOSAICITY")){
            n=sscanf(str,"%s%f%s%f%*s%f", tmp1, &a1, tmp2,&a2,&a3);
            if(n==5 && !strcmp_case(tmp2, "shift")){
                exptl_crystal.pdbx_mosaicity = a1;
                exptl_crystal.pdbx_mosaicity_esd = a3;
            }
        }
    }
    
               
    fclose(fp);
    
}

void extract_MOSFLM_log_index(char *inpfile )
// Extracting index information  from LOG files of D*trek 
{
    char str[256], tmp1[80];
    float a1, a2;
    FILE *fp;
    

    if((fp = fopen(inpfile, "r"))==NULL) {
        printf("Can not open the file (%s)\n", inpfile);
        return ;
    }
    
    while (fgets(str, sizeof str, fp) != NULL) {
        if(pattern5(str,"Mosaic spread (MOSAIC)", ".","degrees", "","")){
            exptl_crystal.pdbx_mosaicity = get_float(str,"(MOSAIC)","degrees");
            
        }else if(pattern5(str,"Minimum and maximum X coordinate (XMIN,XMAX)", ".",".","mm","")){
            get_data_set_id(str, ")", "mm", tmp1);
            
            if(sscanf(tmp1, "%f%f", &a1, &a2)==2){
                pdbx_crystal_alignment.xbeam = a2;
            }
            
         }else if(pattern5(str,"Minimum and maximum Y coordinate (YMIN,YMAX)", ".",".","mm","")){
            get_data_set_id(str, ")", "mm", tmp1);
            
            if(sscanf(tmp1, "%f%f", &a1, &a2)==2){
                pdbx_crystal_alignment.ybeam = a2;
            }
            
         }else if(pattern5(str,"Crystal to detector distance (DIST)", ".","mm","","")){
             pdbx_crystal_alignment.crystal_to_detector_distance = get_float(str,")","mm");
             
         }
    }
    
               
    fclose(fp);
    
}

