/*
FILE:     sf-refine.C
*/
/*
VERSION:  1.700
*/
/*
DATE:     7/13/2005
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2005 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
/* a program to gather all the reflection data and convert it to
   cif format.   March, 2002
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <sys/types.h>
#include <unistd.h>
#include "sf.h"
#include "util.h"

void  sf_cif2mmcif(FILE *fout, char *infile);
void get_item_index(int n, char **item, int index[]);  
int sf_cif_or_mmcif(char *inpfile); //n=1 CIF; 2 mmCIF; 0 not CIF or mmCIF
void write_new_mmcif(FILE *fout, int n, char **item, int *index, char **line);

void print_labin(FILE *finp,char *sffile);
void mtz_refl(FILE *fout, char *filename);
void reformat_mtz_output(char *inpfile);
void write_loop(FILE *ftmp, FILE *fout);

void cns_refl(FILE *fout,  char *inpfile);
void sf_data_header(FILE *fout, int I_F_type, int status );


void shelx_refl(FILE *fout,  char *inpfile, char *type);
void tnt_refl(FILE *fout,  char *inpfile);
void mtz_refl(FILE *fout,  char *inpfile);
void print_labin(FILE *finp,char *sffile);
void hkl_refl(FILE *fout,  char *inpfile);
void epmr_refl(FILE *fout,  char *inpfile, char *type);
void dtrek_refl(FILE *fout,  char *inpfile);
void other_refl(FILE *fout,  char *inpfile);


int NITEM;


/***************** structure factors for final refinement ****************/ 
void write_refl_refine(FILE *fout,int argc,char **argv)
/* convert the reflection data used for final refinement to mmCIF */
{
    char ref_prog[40], inpfile[512], I_F_type[40], empty[1];
    int i=0, n=0;
    
    for(i=1; i<argc-5; i++){
        
        if(!strcmp_case(argv[i],"-RT") && !strcmp_case(argv[i+2],"-RP") &&
           (!strcmp_case(argv[i+4],"-idat")||!strcmp_case(argv[i+4],"-icif"))){
            
            strcpy(I_F_type, argv[i+1]);
            strcpy(ref_prog, argv[i+3]);
            strcpy(inpfile, argv[i+5]);
            
        }else if(!strcmp_case(argv[i],"-RP")&&!strcmp_case(argv[i+2],"-Rt") &&
           (!strcmp_case(argv[i+4],"-idat")||!strcmp_case(argv[i+4],"-icif"))){
            
            strcpy(ref_prog, argv[i+1]);
            strcpy(I_F_type, argv[i+3]);
            strcpy(inpfile, argv[i+5]);
            
        }
        
    }
    
    n = sf_cif_or_mmcif(inpfile);
    
    if(strcmp_case(ref_prog, "MTZ") && n!=2){
        fprintf(fout,"data_set1_for_refinement\n"); 
        fprintf(fout,"#\n%s\n%s\n%s\n#\n",
                "_audit.revision_id      1_0 ",
                "_audit.creation_date  ?",
                "_audit.update_record    'Initial release' "
                );
    }
    
        
    if(n==2){ //mmCIF file
        printf("\nReflection Data File Name = %s : (mmCIF format)\n",inpfile);
        extract_log_CIF(fout, inpfile);
        fprintf(fout, "# END OF REFLECTIONS\n\n");
        return;
    }else if(n==1){  //CIF
        printf("\nReflection Data File Name = %s : (CIF format)\n",inpfile);   
        sf_cif2mmcif(fout, inpfile);
        fprintf(fout, "# END OF REFLECTIONS\n\n");
        return;
    }
    
    
    if(!strcmp_case(ref_prog, "MTZ")){
        printf("Reflection Data File Name = %s : (MTZ format)\n",inpfile);
        mtz_refl(fout,inpfile);
        return;        
    }

// all other cases
    

    printf("Reflection Data File Name = %s : (%s format)\n",inpfile, ref_prog);


    if(!strcmp_case(ref_prog, "CNS") || !strcmp_case(ref_prog, "CNX")||
       !strcmp_case(ref_prog, "XPLOR")){
        cns_refl(fout,  inpfile);
        
    }else if (!strcmp_case(ref_prog, "SHELX") ){
        
        shelx_refl(fout,inpfile,I_F_type );
        
    }else if (!strcmp_case(ref_prog, "XPREP")||!strcmp_case(ref_prog, "SAINT") ){
        strcpy(empty,"");
        
        shelx_refl(fout,inpfile, empty);
        
    }else if(!strcmp_case(ref_prog, "HKL")|| !strcmp_case(ref_prog,"scalepack") ||
            !strcmp_case(ref_prog, "3DSCALE") ) {
        hkl_refl(fout,inpfile);
        
    }else if(!strcmp_case(ref_prog, "EPMR") || !strcmp_case(ref_prog, "OTHER")) {
        epmr_refl(fout,inpfile, I_F_type);
        
    }else if (!strcmp_case(ref_prog, "TNT")){
        tnt_refl(fout,inpfile);

    }else if(!strcmp_case(ref_prog, "DTREK") ) {
        dtrek_refl(fout,inpfile);
        
        
    }else {
        printf("Sorry, the input format (%s) is wrong!\n",ref_prog );
        usage();
    }
    fprintf(fout, "#END OF REFLECTIONS\n");


}



void cns_refl(FILE *fout,  char *inpfile)
/* Convert the CNS reflection data to mmCIF */
{
    char str[256],  tmp[256],  *flag_cif=NULL ;
    long  i, in=0,n=0, fn=0,  nref=0, H, K, L, nfg=0;
    float  F, sF, I, sI, pa,pb, pc, pd;
    int fg=0;
    

    FILE *finp, *ftmp;
    
    if((finp = fopen(inpfile, "r"))==NULL) {
        open_file_error(inpfile, "cns_refl");
    }
    
    ftmp = tmpfile();
    
    while (fgets(str, sizeof str, finp) != NULL) {
        sscanf(str,"%s",tmp);
        if(strstr_case(tmp, "DECLare")){
            if(pattern5(str,"DECLare", "NAME=IOBS", "DOM", "", "")){
                in=1;
            }else if(pattern5(str,"DECLare", "NAME=FOBS", "DOM", "", "")){
                fn=1;
            }
        }else{
            if(strstr_case(str, " IOBS=")){
                in=1;
            }
            if(strstr_case(str, " FOBS=")){
                fn=1;
            }
            
            
            
            if(strstr_case(tmp, "INDE")){
                fprintf(ftmp, "\n");
                nref++;
            }
            n=strlen(str);
            for(i=0; i<n; i++){
                if(isspace(str[i])) str[i]=' '; 
                fprintf(ftmp, "%c", str[i]);
            }
        }
    }
    
    if(nref < 50  || (in ==0 && fn ==0) ){
        printf("Can not find IOBS or FOBS in your file (%s). Or too few reflections.\n", inpfile);
        return;
    }
    
    flag_cif = new char[nref+10];
    
    rewind(ftmp);
    nfg=0;
    while (fgets(str, sizeof str, ftmp) != NULL) { 
        if(strstr_case(str,"INDE")){
            
            if(strstr_case(str, "TEST=") ){
                strcpy(tmp, strstr_case(str, "TEST=")+5);
                if (sscanf(tmp,"%d", &fg)==1){
                    (fg>0) ? flag_cif[nfg] = 'f' : flag_cif[nfg] = 'o';
                    nfg++;
                }
            }else if (strstr_case(str, "FREE=") ) {
                strcpy(tmp, strstr_case(str, "FREE=")+5);
                if (sscanf(tmp,"%d", &fg)==1){
                    (fg>0) ? flag_cif[nfg] = 'f' : flag_cif[nfg] = 'o';
                    nfg++;
                }
            }
        }
    }
    
    if(in>0 &&  fn>0 ){ //both exist   
        if(nfg>0)
            sf_data_header(fout, 0, 1);
        else
            sf_data_header(fout, 0, 0);
    }else if(in>0 &&  fn==0 ){ //only intensity exists        
        if(nfg>0)
            sf_data_header(fout, 2, 1);
        else
            sf_data_header(fout, 2, 0);
    }else if(fn>0 &&  in==0 ){ //only amplitude exists        
        if(nfg>0)
            sf_data_header(fout, 1, 1);
        else
            sf_data_header(fout, 1, 0);

    }        
    
    i=0;
    rewind(ftmp);
    while (fgets(str, sizeof str, ftmp) != NULL) { 
        if(strstr_case(str,"INDE")){
            F=0;
            sF=0;
            I=0;
            sI=0;
            sscanf(str,"%*s %ld%ld%ld",&H,&K,&L);

            
            if(strstr_case(str, "PA_MOD=") && strstr_case(str, "PB_MOD=") &&
               strstr_case(str, "PC_MOD=") && strstr_case(str, "PD_MOD=")){
                if(i==0){
                    fprintf(fout,"_refln.pdbx_HLA\n");
                    fprintf(fout,"_refln.pdbx_HLB\n");
                    fprintf(fout,"_refln.pdbx_HLC\n");
                    fprintf(fout,"_refln.pdbx_HLD\n");
                }
            }
            
            
            
            if(strstr_case(str, "FOBS=") && strstr_case(str, "IOBS=")){//both I&F
                
                strcpy(tmp, strstr_case(str, "FOBS=")+5);
                if(strlen(tmp)>0) sscanf(tmp,"%f", &F);

                if(!strstr(tmp, "SIGMA=")){
                    printf("Sorry! the Sigma for FOBS item is not SIGMA\n");
                    printf("Please change it to SIGMA and try again.\n");
                    return;
                }
                    
                strcpy(tmp, strstr_case(str, "SIGMA=")+6);
                if(strlen(tmp)>0) sscanf(tmp,"%f", &sF);
                
                strcpy(tmp, strstr_case(str, "IOBS=")+5);
                if(strlen(tmp)>0) sscanf(tmp,"%f", &I);
                
                if(strstr(tmp, "SIGI=")){
                    strcpy(tmp, strstr_case(str, "SIGI=")+5);
                    sscanf(tmp,"%f", &sI);
                }else if(strstr(tmp, "ISIGMA=")){
                    strcpy(tmp, strstr_case(str, "ISIGMA=")+7);
                    sscanf(tmp,"%f", &sI);
                }else{
                    printf("Sorry! the Sigma data item is not SIGI or ISIGMA.\n");
                    printf("Please change it to either of them, and try again.\n");
                    return;
                }
                
              
                
                if(nfg>0){
                    fprintf(fout,"1 1 1 %4ld %4ld %4ld %10.2f %10.2f %10.2f %10.2f %c ", 
                            H,K,L, F, sF, I, sI, flag_cif[i]);
                }else
                    fprintf(fout,"1 1 1 %4ld %4ld %4ld %10.2f %10.2f %10.2f %10.2f ", 
                            H,K,L, F, sF, I, sI);
                i++;
                
            }else if(!strstr_case(str, "FOBS=") && strstr_case(str, "IOBS=")){ //only I
                
                strcpy(tmp, strstr_case(str, "IOBS=")+5);
                sscanf(tmp,"%f", &I);
                if(strstr_case(str, "SIGI=")){
                    strcpy(tmp, strstr_case(str, "SIGI=")+5);
                    sscanf(tmp,"%f", &sI);
                }else 
                    sI=0;
                
                 if(nfg>0){
                    fprintf(fout,"1 1 1 %4ld %4ld %4ld %10.2f %10.2f %c ", 
                            H,K,L, I, sI, flag_cif[i]);
                }else
                    fprintf(fout,"1 1 1 %4ld %4ld %4ld %10.2f %10.2f ", 
                            H,K,L, I, sI);
               
                i++;
                
            }else if(strstr_case(str, "FOBS=") && !strstr_case(str, "IOBS=")){//only F
                
                strcpy(tmp, strstr_case(str, "FOBS=")+5);
                sscanf(tmp,"%f", &F);
                
                if(strstr_case(str, "SIGMA=")){
                    strcpy(tmp, strstr_case(str, "SIGMA=")+6);
                    sscanf(tmp,"%f", &sF);
                }else 
                    sF=0;

                 if(nfg>0){
                    fprintf(fout,"1 1 1 %4ld %4ld %4ld %10.2f %10.2f  %c ", 
                            H,K,L, F, sF, flag_cif[i]);
                }else
                    fprintf(fout,"1 1 1 %4ld %4ld %4ld %10.2f %10.2f ", 
                            H,K,L, F, sF);
                i++;
            }
            
            if(strstr_case(str, "PA_MOD=") && strstr_case(str, "PB_MOD=") &&
               strstr_case(str, "PC_MOD=") && strstr_case(str, "PD_MOD=")){
            
                strcpy(tmp, strstr_case(str, "PA_MOD=")+7);
                sscanf(tmp,"%f", &pa);
                strcpy(tmp, strstr_case(str, "PB_MOD=")+7);
                sscanf(tmp,"%f", &pb);
                strcpy(tmp, strstr_case(str, "PC_MOD=")+7);
                sscanf(tmp,"%f", &pc);
                strcpy(tmp, strstr_case(str, "PD_MOD=")+7);
                sscanf(tmp,"%f", &pd);
                fprintf(fout," %8.3f  %8.3f  %8.3f  %8.3f \n", pa, pb, pc, pd);
                
            }else{
                fprintf(fout,"\n");
            }
            
                
            
                
        }
        
    }
    if(nref>0) delete [] flag_cif;
    if(finp) fclose(finp);
    if(ftmp) fclose(ftmp);
    
}

void check_flag_num(float *flag, long nref, const char *id, char *flag_cif)
{
    long i, nf=0, no=0, yes=0;

    for(i=0; i<nref; i++){
        if(!strcmp_case(id,"CNS")){
            if(flag[i] > 0.5 )
                nf++;
            else 
                no++;
        }else if(!strcmp_case(id,"SHELX")){
            if(flag[i] < -0.5 )
                nf++;
            else 
                no++;
        }
    }

    if(nf>10 && no >50){
//            printf("%7ld, %7ld, flag=%.3lf\n",nf, no, float(nf)/float(no));
        
        if(float(nf)/float(no) > 0.03){
            yes = 1;
        }else{
            yes = 0;
        }
    }else{
        yes = 0;
    }

    if(yes==1){ // use flag in the file
        for(i=0; i<nref; i++){
            flag_cif[i]='o';
            if(!strcmp_case(id,"CNS")){
                if(flag[i] > 0.5 )
                    flag_cif[i] = 'f';
                else 
                    flag_cif[i] = 'o';
            }else if(!strcmp_case(id,"SHELX")){
                
                if(flag[i] < -0.5 )
                    flag_cif[i] = 'f';
                else
                    flag_cif[i] = 'o';
            }
        }
        
    }else{ // generate 10% 
        

        for(i=0; i<nref; i++){
            flag_cif[i]='o';
                /*
           if(rand()%10 == 1){
                flag_cif[i]='f';
            }else{
                flag_cif[i]='o';
            }
                */
        }

    }
}
    

void shelx_refl(FILE *fout,  char *inpfile, char *type)
/*convert reflection file (3I4,2F8.2,I4 for SHELX ) to CIF format
*/
{
    char  str[256],  tmp[10];
    int  H, K, L,n1=0,n2=0,n3=0,n4=0, n, i, flag=0;
    float sI , I;
    
    
    FILE *fp;


    if((fp = fopen(inpfile, "r"))==NULL) {
        open_file_error(inpfile, "shelx_refl");
    }
    
    i=0;
    flag=0;
    while (fgets(str, sizeof str, fp) != NULL) { // find Rfree flag
        sscanf(str + 28, "%d", &n);
        if(n==1 || n== -1) flag=1;
        if(i++>90) break;
    }

    if(!strcmp_case(type,"F")){
        if(flag==1)
            sf_data_header(fout, 1, 1);
        else
            sf_data_header(fout, 1, 0);
    }else if(!strcmp_case(type,"I")){
        if(flag==1)
            sf_data_header(fout, 2, 1);
        else
            sf_data_header(fout, 2, 0);
    }else{
        sf_data_header(fout, 2, 0);
    }

    
        //check_flag_num(flag,nref,"SHELX", flag_cif);
    
    n=0;
    rewind(fp);
    while (fgets(str, sizeof str, fp) != NULL) {
        n1=0;  n2=0;  n3=0;  n4=0;
        sI = 0;
        if(strlen(str)<20)continue;

        strncpy(tmp, str+0, 4);
        tmp[4] = '\0';
        n1 = sscanf(tmp, "%d", &H);
        
        strncpy(tmp, str+4, 4);
        tmp[4] = '\0';
        n2 = sscanf(tmp, "%d", &K);

        strncpy(tmp, str+8, 4);
        tmp[4] = '\0';
        n3 = sscanf(tmp, "%d", &L);

        strncpy(tmp, str+12, 8);
        tmp[8] = '\0';
        n4 = sscanf(tmp, "%f", &I);
        
        strncpy(tmp, str+20, 8);
        tmp[8] = '\0';
        sscanf(tmp, "%f", &sI);
        
        strncpy(tmp, str+28, 4);
        tmp[4] = '\0';
        sscanf(tmp, "%d", &flag);
        
        if(n1==0 ||  n2==0 ||  n3==0 || n4==0) {
            continue;
        }
        

        if(!strcmp_case(type,"I") || !strcmp_case(type,"F")){
            
            if(flag>0)
                fprintf(fout,"1 1 1 %4d %4d %4d %10.2f %10.2f o\n",  H, K, L, I, sI);
            else{
                fprintf(fout,"1 1 1 %4d %4d %4d %10.2f %10.2f f\n",  H, K, L, I, sI);
            }
        }else
            fprintf(fout,"1 1 1 %4d %4d %4d %10.2f %10.2f \n",  H, K, L, I, sI);
        
        
            
    }
    
    fclose(fp);
    
    
}

void tnt_refl(FILE *fout,  char *inpfile)
/*convert TNT reflection file (A4, 4I4,2F8.2, F8.2,F8.4 ) to CIF format
  HKL, H, K, L,  F, sigmaF, phase, FOM in each row
*/
{

    float  F, sF;
    char status='o', str[256], data_type[10], tmp[10];
    int H, K, L,n1=0,n2=0,n3=0,n4=0;
    
    FILE *fp;


    if((fp = fopen(inpfile, "r"))==NULL) {
        open_file_error(inpfile, "tnt_refl");
    }

    
    strcpy(data_type, "F");
    printf("\nThe reflection data type is assumed to be amplitude (F)!\n");
    write_data_type_head(fout, data_type);

    while (fgets(str, sizeof str, fp) != NULL){
        sF = 0;
        upperstr(str);
        if(strncmp(str, "HKL ",4))continue;
        if(strlen(str)<24)continue;
        
        strncpy(tmp, str+4, 4);
        tmp[4] = '\0';
        n1 = sscanf(tmp, "%d", &H);
        
        strncpy(tmp, str+8, 4);
        tmp[4] = '\0';
        n2 = sscanf(tmp, "%d", &K);

        strncpy(tmp, str+12, 4);
        tmp[4] = '\0';
        n3 = sscanf(tmp, "%d", &L);

        strncpy(tmp, str+16, 8);
        tmp[8] = '\0';
        n4 = sscanf(tmp, "%f", &F);
        
        strncpy(tmp, str+24, 8);
        tmp[8] = '\0';
        sscanf(tmp, "%f", &sF);

        if(n1>0 && n2>0 && n3>0 && n4>0 ){
            fprintf(fout,"1 1 1 %4d %4d %4d  %10.1f %8.1f %c\n",
                    H, K, L, F, sF, status);
        }
    }

    fclose(fp);
    
}

void epmr_refl(FILE *fout,  char *inpfile,char *type)
/*convert EPMR reflection file (free format ) to CIF format
   H, K, L,  Fo,  in each row
*/
{

    float  F, sF=0, status;
    char  str[256], ch;
    int H, K, L, n, nref=0;
    FILE *fp;


    if((fp = fopen(inpfile, "r"))==NULL) {
        open_file_error(inpfile, "epmr_refl");
    }

     
                   
    while (fgets(str, sizeof str, fp) != NULL){
        
        if(strlen(str)<20)continue;
        nref++;
        n=sscanf(str,"%d%d%d%f%f%f", &H, &K, &L, &F, &sF ,&status);
        if(nref==1 && (n==4 || n==5)){
            if(!strcmp_case(type, "F")){
                
                printf("\nThe reflection data type is  amplitude (F)!\n");
                sf_data_header(fout, 1, 0);
            }else if(!strcmp_case(type, "I")){
                
                printf("\nThe reflection data type is intensity (I)!\n");
                sf_data_header(fout, 2, 0);
            }else
                sf_data_header(fout, 1, 0);
        }else if(nref==1 &&  n==6){
            if(!strcmp_case(type, "F")){
                printf("\nThe reflection data type is amplitude (F)!\n");
                sf_data_header(fout, 1, 1);
            }else if(!strcmp_case(type, "I")){
                printf("\nThe reflection data type is intensity (I)!\n");
                
                sf_data_header(fout, 2, 1);
            }else
                sf_data_header(fout, 1, 1);
        }
        
        
        if(n==4){
            fprintf(fout,"1 1 1 %4d %4d %4d  %8.2f 0.0 \n", H, K, L, F );
        }else if (n==5){
            fprintf(fout,"1 1 1 %4d %4d %4d  %8.2f  %6.2f  \n", H, K, L, F, sF );
        }else if (n==6){
            if(status<1)
                ch='f';
            else
                ch='o';
                
            fprintf(fout,"1 1 1 %4d %4d %4d  %8.2f  %6.2f  %c \n", H, K, L, F, sF, ch );
        }else
            continue;
    }

    fclose(fp);
}
void cryst_infor(FILE *fout, float *a, char *sym,int num)
{
    char symmetry[20];
    
    fprintf(fout, "#\n");
    if(num>0)fprintf(fout, "_symmetry.Int_Tables_number  %d\n", num);
    space_group_convertor(sym,symmetry);
    
    fprintf(fout, "_symmetry.space_group_name_H-M  '%s'\n",symmetry );
    
    fprintf(fout, "#\n");
    fprintf(fout, "_cell.length_a  %.3f\n", a[0]);
    fprintf(fout, "_cell.length_b  %.3f\n", a[1]);
    fprintf(fout, "_cell.length_c  %.3f\n", a[2]);
    fprintf(fout, "_cell.angle_alpha  %.3f\n", a[3]);
    fprintf(fout, "_cell.angle_beta  %.3f\n", a[4]);
    fprintf(fout, "_cell.angle_gamma  %.3f\n", a[5]);
    
}


void hkl_refl(FILE *fout, char *filename)
/* get the right format for HKL2000/scalepack
    
1, NO ANOMALOUS flag ----- h, k, l, I, sigma(I)  (3I4, 2F8.1) length=28
2, WITH ANOMALOUS flag --- h, k, l, I+, sigma(I+), I-, sigma(I-) ;
   (3I4, 4F8.1) length=44
3, NO MERGE  --- h, k, l, asymmetric unit #, I, sigma(I) ; (4I4,2F8.1)  
   ANOMALOUS flag has no effect.  length=32
4, NO MERGE original index --- original hkl, unique hkl, batch (film)
   number, a flag (0 = centric, 1 = I+, 2 = I-), another flag (0 =
   hkl reflecting above the spindle, 1 = hkl reflecting below the spindle), 
   the asymmetric unit of the reflection, I (scaled, Lorentz and Polarization
   corrected), and the sigma of I. The format is (6i4, i6, 2i2, i3, 2f8.1).
   (RAW data!!)  length=53

*/
    
{
    char str[100],symmetry[30];
    int h, k, l, hh=0, kk=0, ll=0, k1=0, k2=0, k3=0, k4=0, len=0, n, j;
    float a[10], i=0, si=0, ii=0, sii=0 ;
    FILE  *finp;
    
    if((finp = fopen(filename, "r"))==NULL) {
        open_file_error(filename, "hkl_refl");
    }

    j=0;
    while (fgets(str, sizeof str, finp) != NULL) {
        if(j++>20) break;
        n=sscanf(str,"%f%f%f%f%f%f%s",
                 &a[0],&a[1],&a[2],&a[3],&a[4],&a[5],symmetry);
                   
        if(n==7){
            get_string(str, 60, 70, symmetry);
            cryst_infor(fout, a,symmetry,-1);
            break;
        }
                   
    }
    
    printf("The input reflection data type is assumed to be intensity (I)!\n");
    sf_data_header(fout,2, 0);
    
    while (fgets(str, sizeof str, finp) != NULL) {
        k1=0;
        k2=0;
        k3=0;
        k4=0;
        
        rid_of_end_space(str);
        len=strlen(str);

        if(len > 27 && len <62 ){
/*            
            if(rand()%10 == 1){
                flag='f';
            }else{
                flag='o';
            }
*/            
            h=get_int_by_length(str, 0, 3);
            k=get_int_by_length(str, 4, 7);
            l=get_int_by_length(str, 8, 11);
        }else{
            continue;
        }
        

        if(len==28 || len==29 ){
            k1=1;
            i=get_float_by_length(str, 12, 19);
            si=get_float_by_length(str, 20, 27);
            
            
        }else if(len==35 || len==36){
            k2=1;
            i=get_float_by_length(str, 19, 26);
            si=get_float_by_length(str, 27, 34);
            
        }else if(len==44 || len==45){
            k3=1;
            i=get_float_by_length(str, 12, 19);
            si=get_float_by_length(str, 20, 27);

            hh =  -h;
            kk =  -k;
            ll =  -l;
            
            ii=get_float_by_length(str, 28, 35);
            sii=get_float_by_length(str, 36, 43);
            
        }else if(len==53 || len==54){
            k4=1;
            i=get_float_by_length(str, 37, 44);
            si=get_float_by_length(str, 45, 52);
        }
        
        if(k3>0){
//            i_to_f(i, si, &f, &sf);
            fprintf(fout,"1 1 1 %4d %4d %4d %9.2f %9.2f\n", h, k, l,  i, si);
            fprintf(fout,"1 1 1 %4d %4d %4d %9.2f %9.2f\n", hh, kk, ll,  ii, sii);
            
//            i_to_f(ii, sii, &f, &sf);
            
        }else if((k1>0 || k2>0 || k4>0 ) && k3==0){
            
//            i_to_f(i, si, &f, &sf);
            fprintf(fout,"1 1 1 %4d %4d %4d  %9.2f %9.2f\n", h, k, l,  i, si);
        }
        
    }
    
    if(k1==0 && k2==0 && k3==0  && k4==0 ){
        fprintf(fout, "  ? ? ? ? ? ? ? ? \n");    
        printf("Warning! The HKL/SCALEPACK format is wrong!\n");
    }
    
    fclose(finp);
    
}
void i_to_f(float I, float sI, float *F, float *sF)
{
    if (I>0){
        *F=sqrt(I);
        *sF = sI/(2*(*F));
    }else{
        *F=0;
        *sF=0;
    }
    
}
void f_to_i(float F, float sF, float *I, float *sI)
{
    *I = F*F;
    *sI = 2*F*sF;
}



void dtrek_refl(FILE *fout, char *filename)
/* write reflections from d*trek */
{
    char str[512];
    int h=0, k=0, l=0, m,  sg_num=0;
    float i, j, sigmai, plus_i, plus_s, minus_i, minus_s, a[10];
    FILE *finp;

    if((finp = fopen(filename, "r"))==NULL) {
        open_file_error(filename, "dtrek_refl");
    }

    j=0;
    while (fgets(str, sizeof str, finp) != NULL) {
        if(j++>20) break;
        if(pattern5(str,"CRYSTAL_SPACEGROUP=", ";", "", "","")){
            sg_num=get_int(str, "=", ";");
        }else if(pattern5(str,"CRYSTAL_UNIT_CELL=", ";", "", "","")){
            sscanf(get_substr(str, "=", ";"), "%f %f %f %f %f %f",
                     &a[0],&a[1],&a[2],&a[3],&a[4],&a[5]);
        }
        if(a[0]>0 && a[1]>0 && a[5]>0) {
            cryst_infor(fout, a,(char *)"?",sg_num);
            break;
        }
    }
    sf_data_header(fout, 2, 0);
    printf("The reflection data type is assumed to be intensity (I)!\n");

    rewind(finp);
    
    while (fgets(str, sizeof str, finp) != NULL) {
        
        m=sscanf(str, " %d%d%d %f%f %f%f %f%f",
                 &h, &k, &l, &i, &sigmai, &plus_i, &plus_s, &minus_i, &minus_s);
        
        if(m==5 && sigmai >=0){
            fprintf(fout,"1 1 1 %4d %4d %4d %12.2f %8.2f \n", h, k, l, i, sigmai);
        }else if(m==9){
            if(plus_s >=0)
                fprintf(fout,"1 1 1 %4d %4d %4d %12.2f %8.2f \n", h, k, l, plus_i, plus_s);
            if(minus_s >=0)
                fprintf(fout,"1 1 1 %4d %4d %4d %12.2f %8.2f \n", -h, -k, -l, minus_i, minus_s);
        }
    }
    
    fclose(finp);
    
}



int sf_cif_or_mmcif(char *inpfile)
// 1 CIF; 2 mmCIF; 0 not CIF or mmCIF
{
    int nline=0, h=0, k=0, l=0, hh=0, kk=0, ll=0, n=0;
    char str[256],tmp[100],tmp1[100];
    
    FILE   *finp;

    
    if((finp=fopen(inpfile, "r")) == NULL){
        open_file_error(inpfile,"sf_cif_or_mmcif");
    }
    
    while(fgets(str, sizeof str, finp) != NULL){
        n=sscanf(str, "%s %s", tmp, tmp1);
        if(!strcmp_case(tmp,"_refln_index_h") && n==1 ){
            h=1;
        }else if(!strcmp_case(tmp,"_refln_index_k") && n==1 ){
            k=1;
        }else if(!strcmp_case(tmp,"_refln_index_l") && n==1 ){
            l=1;
        }else if(!strcmp_case(tmp,"_refln.index_h") && n==1 ){
            hh=1;
        }else if(!strcmp_case(tmp,"_refln.index_k") && n==1 ){
            kk=1;
        }else if(!strcmp_case(tmp,"_refln.index_l") && n==1 ){
            ll=1;
            
        }
        
        if(nline++ >400) break;
    }
    fclose(finp);
    
    
    if(h==1 && k==1 && l==1 ) {
        return 1;
    }else if(hh==1 && kk==1 && ll==1 ) {
        return 2;
    }else
        return 0;

}

void  sf_cif2mmcif(FILE *fout, char *inpfile) 
{

    char str[512], tmp[512], inpf_tmp[512];
    char **line=NULL, **item=NULL, **lines=NULL ;
    int  index[80], i, j,n, nt, *line_index, nstr=0, nitem=0, nline=0,nline_tmp=0, start_hkl=0;
     
    FILE   *finp;

    
    if((finp=fopen(inpfile, "r")) == NULL){
        open_file_error(inpfile,"sf_cif2mmcif");
    }

    for(i=0; i<80; i++){
        index[i]=-10;
    }
    
//get # of lines    
    nline_tmp=0;
    while(fgets(str, sizeof str, finp) != NULL){ 
        nline_tmp++;
    }

    lines = new char *[nline_tmp];
    line_index = new int[nline_tmp];
   
    rewind(finp);
    nline=0;
    nt=0;
    while(fgets(str, sizeof str, finp) != NULL){
        nt++;
        rid_of_front_end_space(str);
        if(strlen(str)<1 || str[0]=='#') continue;
        if(nline>10 && !strncmp(str,"data_", 5))break; //next block
        lines[nline] = new char [strlen(str)+1];
        strcpy(lines[nline],str);
        line_index[nline] = nt;
        nline++;
    }
//    printf("nline, nline_tmp= %s %d %d\n", inpfile, nline,nline_tmp);

    

    nitem=0;
    for(i=0; i<nline-5; i++){  //get cif items
        if(!strncmp(lines[i+0],"_refln_",7) &&
           !strncmp(lines[i+1],"_refln_",7) &&
           !strncmp(lines[i+2],"_refln_",7) &&
           !strncmp(lines[i+3],"_refln_",7)){
            
            nitem=0;
            item = new char *[80];
            for(j=i; j<nline-5 ; j++){
                if(strncmp(lines[j], "_refln_", 7)) {
                    start_hkl=j;
                    break;
                }
                item[nitem] = new char [strlen(lines[j])+1];
                sscanf(lines[j], "%s", item[nitem]);
                nitem++;
            }
            if(strncmp(lines[j], "_refln_", 7)) break; 
        }
    }
    
    if(nitem<=0) {
        printf("The input file (%s) has no correct tokens\n", inpfile);
        if(lines && nline>0) free_memory_2d(lines, nline);
        fclose(finp);
        return;
    }
    
    get_item_index(nitem, item, index);

    n=0;
    strcpy(inpf_tmp,"");    
    for(i=start_hkl; i<nline; i++){
        strcpy(tmp,lines[i]);
        line = string_token(tmp, " " , &nstr);
        
        if(nstr != nitem ){
            printf("Error at line = %d\n", line_index[i]);
            continue;
        }
        n++;
        write_new_mmcif(fout, n, item, index, line);
        if(nstr>0) free_memory_2d(line, nstr);
    }
    if(item && nitem) free_memory_2d(item, nitem);
    if(lines && nline) free_memory_2d(lines, nline);
    delete [] line_index;
    
    
    fclose(finp);
}

                      
void write_new_mmcif(FILE *fout, int n, char **item, int *index, char **line)
{
    char i;
    
    if(n==1){
        fprintf(fout,"loop_\n");
        for(i=0; i<NITEM; i++){
            if(index[i] >=0)fprintf(fout,"%s\n", item[index[i]]);
        }
    }
    
    for(i=0; i<NITEM; i++){
        if(index[i] >=0)fprintf(fout," %s", line[index[i]]);
    }
    
    fprintf(fout,"\n");
    
}

void get_item_index(int n, char **item, int index[])  

{
    int i;
    
    for(i=0; i<n; i++){
        if(!strcmp_case(item[i], "_refln_index_h")){
            strcpy(item[i],  "_refln.index_h");
            index[0]=i;
        }else if(!strcmp_case(item[i], "_refln_index_k")){
            strcpy(item[i],  "_refln.index_k");
            index[1]=i;
        }else if(!strcmp_case(item[i], "_refln_index_l")){
            strcpy(item[i],  "_refln.index_l");
            index[2]=i;
        }else if(!strcmp_case(item[i], "_refln_F_meas")){
            strcpy(item[i],  "_refln.F_meas_au");
            index[3]=i;
        }else if(!strcmp_case(item[i], "_refln_F_sigma")){
            strcpy(item[i],  "_refln.F_meas_sigma_au");
            index[4]=i;
        }else if(!strcmp_case(item[i], "_refln_F_squared_meas")){
            strcpy(item[i],  "_refln.intensity_meas");
            
            index[5]=i;
        }else if(!strcmp_case(item[i], "_refln_F_squared_sigma")){
            strcpy(item[i],  "_refln.intensity_sigma");
            index[6]=i;

        }else if(!strcmp_case(item[i], "_refln_F_calc")){
            strcpy(item[i],  "_refln.F_calc_au");
            index[7]=i;
        }else if(!strcmp_case(item[i], "_refln_F_squared_calc")){
            strcpy(item[i],  "_refln.F_squared_calc");
            index[8]=i;
            
        }else if(!strcmp_case(item[i], "_refln_observed_status")){
            strcpy(item[i],  "_refln.status");
            index[9]=i;

        }else if(!strcmp_case(item[i], "_refln_intensity_meas")){
            strcpy(item[i],  "_refln.intensity_meas");
            index[10]=i;
        }else if(!strcmp_case(item[i], "_refln_intensity_sigma")){
            strcpy(item[i],  "_refln.intensity_sigma");
            index[11]=i;
            
        }else if(!strcmp_case(item[i], "_refln_fom")){
            strcpy(item[i],  "_refln.fom");
            index[12]=i;
            
        }else if(!strcmp_case(item[i], "_refln_phase_calc")){
            strcpy(item[i],  "_refln.phase_calc");
            index[13]=i;
        }
        
    }
    NITEM=14;
        /*
    for(i=0; i<nitem; i++){
        if(index[i]>=0)printf("cif-items %d  %d (%d) %s\n",n, i, index[i],item[index[i]]);
        printf("cif-items %d  %d (%d)\n",n, i, index[i]);
    }
        */    
}
    

void  shelx_cif2mmcif(FILE *fout, char *infile) //disabled at the moment
{
    char item[40], str[256], tmp[256];
    float a;
    int n;
    FILE *fp;
    
    if((fp = fopen(infile, "r"))==NULL)
        open_file_error(infile, "shelx_cif2mmcif");

    
    while (fgets(tmp, sizeof tmp, fp) != NULL) {
        strcpy(str,tmp);
        rid_of_front_space(str);
        if(sscanf(str,"%s", item) !=1) continue;
        if(!strcmp_case(item, "_shelx_title")){
            replace_first_str(str,"_shelx_title","_shelx.title",str);
        }else if(!strcmp_case(item,"_shelx_refln_list_code")){
            replace_first_str(str,"_shelx_refln_list_code","_shelx.refln_list_code",str);
        }else if(!strcmp_case(item,"_shelx_F_calc_maximum")){
            replace_first_str(str,"_shelx_F_calc_maximum","_shelx.F_calc_maximum",str);
        }else if(!strcmp_case(item,"_exptl_crystal_F_000")){
            replace_first_str(str,"_exptl_crystal_F_000","_exptl_crystal.F_000",str);
        }else if(!strcmp_case(item,"_reflns_d_resolution_high")){
            replace_first_str(str,"_reflns_d_resolution_high","_reflns.d_resolution_high",str);
            
        }else if(!strcmp_case(item,"_symmetry_equiv_pos_as_xyz")){
            replace_first_str(str,"_symmetry_equiv_pos_as_xyz","_symmetry_equiv.pos_as_xyz",str);
            
        }else if(!strcmp_case(item,"_cell_length_a")){
            replace_first_str(str,"_cell_length_a","_cell.length_a",str);
        }else if(!strcmp_case(item,"_cell_length_b")){
            replace_first_str(str,"_cell_length_b","_cell.length_b",str);
        }else if(!strcmp_case(item,"_cell_length_c")){
            replace_first_str(str,"_cell_length_c","_cell.length_c",str);
        }else if(!strcmp_case(item,"_cell_angle_alpha")){
            replace_first_str(str,"_cell_angle_alpha","_cell.angle_alpha",str);
        }else if(!strcmp_case(item,"_cell_angle_beta")){
            replace_first_str(str,"_cell_angle_beta","_cell.angle_beta",str);
        }else if(!strcmp_case(item,"_cell_angle_gamma")){
            replace_first_str(str,"_cell_angle_gamma","_cell.angle_gamma",str);
            
        }else if(!strcmp_case(item,"_shelx_F_squared_multiplier")){
            replace_first_str(str,"_shelx_F_squared_multiplier","_shelx.F_squared_multiplier",str);
            
        }else if(!strcmp_case(item,"_refln_index_h")){
            replace_first_str(str,"_refln_index_h","_refln.index_h",str);
        }else if(!strcmp_case(item,"_refln_index_k")){
            replace_first_str(str,"_refln_index_k","_refln.index_k",str);
        }else if(!strcmp_case(item,"_refln_index_l")){
            replace_first_str(str,"_refln_index_l","_refln.index_l",str);
        }else if(!strcmp_case(item,"_refln_F_squared_calc")){
            replace_first_str(str,"_refln_F_squared_calc","_refln.F_squared_calc",str);
        }else if(!strcmp_case(item,"_refln_F_squared_meas")){
            replace_first_str(str,"_refln_F_squared_meas","_refln.F_squared_meas",str);
        }else if(!strcmp_case(item,"_refln_F_squared_sigma")){
            replace_first_str(str,"_refln_F_squared_sigma","_refln.F_squared_sigma",str);
        }else if(!strcmp_case(item,"_refln_observed_status")){
            replace_first_str(str,"_refln_observed_status","_refln.status",str);
        }
        n=sscanf(str, "%f%f%f%f%f%f", &a,&a,&a,&a,&a,&a);
        
        if(!strncmp_case(str, "_refln.index_h", 14) && n!=6){
            fprintf(fout, "_refln.wavelength_id\n");
            fprintf(fout, "_refln.crystal_id\n");
            fprintf(fout, "%s", str);   
        }else {
            if(n!=6){
                fprintf(fout, "%s", str);
            }else
                fprintf(fout, "1 1 %s", str);
        }
    }
}

void mtz_refl(FILE *fout, char *filename) 
{
    
    char script[512], sffile_out[512], command[256] , str[256];
    int proc_id;
    
    FILE *fp=NULL;

    sprintf(sffile_out, "%s.mmcif",filename);
    proc_id=  getpid();
    sprintf(script,"/tmp/mtz2cif_tmp.scr.%d", proc_id);
    

    if((fp=fopen(script, "w"))==NULL){
        printf("Error, disk written permission was denied!\n");
        exit(0);
    }

    fprintf(fp,"#!/bin/csh \n");
    fprintf(fp,"$CCP4/bin/mtz2various HKLIN %s HKLOUT %s << EOF > cif2mtz.log \n", filename,sffile_out);
    fprintf(fp,"OUTPUT CIF data_mtz2cif \n");
    print_labin(fp, filename);
    
    fprintf(fp,"END\n");
    fprintf(fp,"EOF\n");
    fprintf(fp,"#\n");

    fclose(fp);
    sprintf(command, "/bin/csh -c \"chmod +x %s\"", script);
    system(command);
    sprintf(command, "/bin/csh -c \"source $CCP4/include/ccp4.setup; %s\"", script);
    system(command);
    
    reformat_mtz_output(sffile_out);
    if((fp=fopen(sffile_out, "r"))==NULL){
        printf("Error! Disk written permission was denied!\n");
        exit(0);
    }

    while(fgets(str, sizeof str, fp)!=NULL){
        fprintf(fout,"%s", str);
    }
    
    fclose(fp);
    delete_file("cif2mtz.log");
    delete_file("sffile_out");
//    delete_file(script);

}
void reformat_mtz_output(char *inpfile)
{
    char str[512];
    FILE *ftmp=NULL, *fout=NULL, *finp=NULL;
    
    ftmp = tmpfile();

    if((finp = fopen(inpfile, "r"))==NULL) {
        return;
    }
    
    while (fgets(str, sizeof str, finp) != NULL) {
        if(strlen(str)<6) continue;
        fprintf(ftmp, "%s", str);
//        printf( "%s", str);
    }
    fclose(finp);
    
    rewind(ftmp);
    
    fout = fopen(inpfile,"w");
    
    
    while (fgets(str, sizeof str, ftmp) != NULL) {
        if(!strncmp(str,"data_", 5)){
            fprintf(fout, "%s", str);
            
            fprintf(fout,"#\n%s\n%s\n%s\n#\n",
                    "_audit.revision_id      1_0 ",
                    "_audit.creation_date  ?",
                    "_audit.update_record    'Initial release' "
                    );
            break;
        }
    }

    while (fgets(str, sizeof str, ftmp) != NULL) {
        if(strstr_case(str,"#  ENTRY  #")){
            write_loop(ftmp, fout);
            
        }else if(strstr_case(str,"#  CELL  #")){
            write_loop(ftmp, fout);
            
        }else if(strstr_case(str,"#  SYMMETRY  #")){
            write_loop(ftmp, fout);
            
        }else if(strstr_case(str,"#  SYMMETRY_EQUIV  #")){
            write_loop(ftmp, fout);
            
        }else if(strstr_case(str,"#  REFLNS  #")){
            write_loop(ftmp, fout);
            
        }else if(strstr_case(str,"#  DIFFRN_RADIATION_WAVELENGTH  #")){
            write_loop(ftmp, fout);
            
        }else if(strstr_case(str,"#  EXPTL_CRYSTAL  #")){
            write_loop(ftmp, fout);
            
        }else if(strstr_case(str,"#  REFLNS_SCALE  #")){
            write_loop(ftmp, fout);
            
        }else if(strstr_case(str,"#  REFLN  #")){
            write_loop(ftmp, fout);
            
        }else if(strstr_case(str,"")){
            write_loop(ftmp, fout);
        }
       
    }
    fprintf(fout,"#END OF REFLECTIONS\n");
    fclose(fout);
    fclose(ftmp);
    
}
void write_loop(FILE *ftmp, FILE *fout)
{
    int n=0, k=0;
    char str[512], str1[512];
    
    
    while (fgets(str, sizeof str, ftmp) != NULL) {
        if(strchr(str,'#')){
            continue;
        }else {
            n=0;
            fprintf(fout, "%s", str);
            while (fgets(str1, sizeof str1, ftmp) != NULL) {
                n++;
                if(strchr(str1,'#')){
                    k=1;
                    if(n>0) fprintf(fout, "#\n");
                    break;
                }
                
                fprintf(fout, "%s", str1);
            }
            
            
        }
        if(n>0 && k==1) break;
    }
}



void print_labin(FILE *finp,char *sffile)
{
    char  str[2000], command[512], log[256];
    char label[2000], type[256], **label_ptr=NULL, **type_ptr=NULL;
    char fp[40], sigma_fp[40],ip[40], sigma_ip[40], free[40];
    
    int nlabel=0, ntype=0, i, nf=0, nfp=0, ni=0;
   
    FILE *flog=NULL;
    
//    pid = getpid(); not the process pid
           
    strcpy(log, "/tmp/mtzdmp.log");
//    sprintf(command, "/bin/csh -c \"source /home/program/ccp4-5.0.2/include/ccp4.setup;/home/program/ccp4-5.0.2/etc/mtzdmp  %s  -50 >%s \"",sffile, log);
    sprintf(command, "/bin/csh -c \"source $CCP4/include/ccp4.setup;$CCP4/etc/mtzdmp  %s  -50 >%s \"",sffile, log);
    system(command);
    
    if((flog=fopen(log, "r"))==NULL){
        printf("Sorry, can not open the LOGfile (%s)\n",log);
        exit(0);
    }

    while(fgets(str, sizeof str, flog)!=NULL){
        if (strlen(str)<20 && strstr(str,"* Column Labels :")){
            while(fgets(str, sizeof str, flog)!=NULL){
                
                rid_of_front_end_space(str);
                if(strlen(str)>2){
                    strcpy(label,str);
                    break;
                }
            }
        }else if(strlen(str)<20 && strstr(str,"* Column Types :")){
            while(fgets(str, sizeof str, flog)!=NULL){
                rid_of_front_end_space(str);
                if(strlen(str)>2){
                    strcpy(type,str);
                    break;
                }
            }
        }        
    }
    fclose(flog);
//:wq    delete_file(log);
    
    label_ptr = string_token(label," ", &nlabel);
    type_ptr = string_token(type," ", &ntype);

    if(nlabel == ntype && ntype>3){
        for(i=0; i<ntype; i++){
            if(type_ptr[i][0] == 'I'){
                if(strstr_case(label_ptr[i], "free") || strstr_case(label_ptr[i], "flag") ){
                    strcpy(free, label_ptr[i]);
                    nf=1;
                    break;
                }
            }
        }
        
        for(i=0; i<ntype-1; i++){
            if(type_ptr[i][0] == 'F' &&( type_ptr[i+1][0] == 'Q'||type_ptr[i+1][0] == 'R')){
                
                if(label_ptr[i][0]== 'F' && strstr_case(label_ptr[i+1], "SIGF") ){
                    strcpy(fp, label_ptr[i]);
                    strcpy(sigma_fp, label_ptr[i+1]);
                    nfp = 1;
                    break;
                }
            }else if(type_ptr[i][0] == 'Q' && type_ptr[i+1][0] == 'F'){
                
                if(label_ptr[i+1][0]== 'F' && strstr_case(label_ptr[i], "SIGF") ){
                    strcpy(fp, label_ptr[i+1]);
                    strcpy(sigma_fp, label_ptr[i]);
                    nfp=1;
                    break;
                }
            }
            
        }
        for(i=0; i<ntype-1; i++){
            if(type_ptr[i][0] == 'J' && type_ptr[i+1][0] == 'Q'){
                
                if(label_ptr[i][0]== 'I' &&  strstr_case(label_ptr[i+1], "SIGI")){
                    strcpy(ip, label_ptr[i]);
                    strcpy(sigma_ip, label_ptr[i+1]);
                    ni=1;
                    break;
                }
            }else if(type_ptr[i][0] == 'Q' && type_ptr[i+1][0] == 'J'){
                
                if(label_ptr[i+1][0]== 'I' &&  strstr_case(label_ptr[i], "SIGI")){
                    strcpy(ip, label_ptr[i+1]);
                    strcpy(sigma_ip, label_ptr[i]);
                    ni=1;
                    break;
                }
            }
            
        }
    }
    if(nf==0){
        if(nfp != 0){
            fprintf(finp,"LABIN FP=%s  SIGFP=%s\n",fp, sigma_fp);
        }else if(ni != 0){
            fprintf(finp,"LABIN I=%s  SIGI=%s\n",ip, sigma_ip);
        }
    }else{
        
        if(nfp != 0){
            fprintf(finp,"LABIN FP=%s  SIGFP=%s FREE=%s\n",fp, sigma_fp,free);
        }else if(ni != 0){
            fprintf(finp,"LABIN I=%s  SIGI=%s FREE=%s\n",ip, sigma_ip,free);
        }
        
    }
    
   printf("number of labels in MTZ = %d\n",nlabel);
    
    
}
 
void sf_data_header(FILE *fout, int I_F_type, int status )
// status>0 Rfree exist
{
    fprintf(fout, "#\n");

    fprintf(fout, "loop_\n");
    fprintf(fout, "_refln.crystal_id \n");
    fprintf(fout, "_refln.wavelength_id \n");
    fprintf(fout, "_refln.scale_group_code\n");
    fprintf(fout, "_refln.index_h\n");
    fprintf(fout, "_refln.index_k\n");
    fprintf(fout, "_refln.index_l\n");
    
    
    if(I_F_type ==0 ){
        fprintf(fout, "_refln.F_meas_au\n" );
        fprintf(fout, "_refln.F_meas_sigma_au \n" );
        fprintf(fout, "_refln.intensity_meas\n" );
        fprintf(fout, "_refln.intensity_sigma\n" );
        if(status >0 )fprintf(fout, "_refln.status\n" );
    }else if(I_F_type ==1){  
        fprintf(fout, "_refln.F_meas_au\n" );
        fprintf(fout, "_refln.F_meas_sigma_au \n" );
        if(status >0 )fprintf(fout, "_refln.status\n" );
    }else if(I_F_type ==2){  
        fprintf(fout, "_refln.intensity_meas\n" );
        fprintf(fout, "_refln.intensity_sigma\n" );
        if(status >0 )fprintf(fout, "_refln.status\n" );
    } else{
        printf("Data-type is wrong! (It should be either (F) or (I))\n");
        exit(0);
    }
}

