/*
FILE:     sharp.C
*/
/*
VERSION:  1.700
*/
/*
DATE:     7/13/2005
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2005 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
/*  a program to extract information form the CNS program */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "harv.h"
#include "util.h"
#include "nrutil.h"

#define LEN 100
#define NBIN 200
#define NW  100
#define NBA 100

void get_data_new_v2(FILE *fp, char *rc, double **res_L, double **res_H, 
                     double **rc_ai, double **rc_ci, long **nrc_ai, long **nrc_ci, 
                     double **rc_aa, double **rc_ca, long **nrc_aa, long **nrc_ca, 
                     double *rc_ai_all, double *rc_ci_all, long *nrc_ai_all, long *nrc_ci_all,
                     double *rc_aa_all, double *rc_ca_all, long *nrc_aa_all, long *nrc_ca_all,
                     long nba, long *nb);

void SHARP_phasing_new_v2(FILE *fout, char *inpfile, char *method);

void SHARP_phase(FILE *fout, char *inpfile, char *format, char *method)
/* extract the information from sharp.
   wavelegth, f', f", resolution, and statistics
*/
{
    
    FILE *fp;
    
    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s (routine:SHARP_phase)\n",inpfile);
        return;
    }
    
    if(!strcmp_case(format, "LOG")){        
//        SHARP_phasing_wave(fout, inpfile, method);
        SHARP_phasing_stat(fout, inpfile, method);
        SHARP_phasing_new_v2(fout, inpfile, method);
        
    }else if(!strcmp_case(format, "PDB") ){
        heavy_coord_pdb(fout, inpfile, method);
    }else if(!strcmp_case(format, "CIF")){
        write_cif(fout,  inpfile, method);
    }else{
        printf("The input format (%s) is wrong!\n", format);
        printf("Please give the correct format (-iLOG,-iCIF,-iPDB).\n");
        usage();
    }
    fclose(fp);
}

void SHARP_phasing_DM(FILE *fout, char *inpfile, char *format,char *method)
/* extract the information .
   FOM after density modification. The same as DM
*/
{
    FILE *fp;

    int i=0, n=0,nref=0;
    char str[512], fom[NBIN][LEN], juck[LEN];
    char resol_L[LEN], resol_H[LEN],  fm[LEN], phi[LEN];
    float nf;
    
    
    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s (:SHARP_phasing_DM)\n",inpfile);
        return;
    }
    
    if(!strcmp_case(format, "CIF") || !strcmp_case(format, "PDB")){
        write_cif_or_pdb(fout,  inpfile, format,method);
        return;
    }
   
    while (fgets(str, sizeof str, fp) != NULL) {
        upperstr(str);
        if (strstr_space(str, " RMIN  - RMAX")>0 &&
            strstr_space(str, " MEAN FOM  MEAN FOM  MEAN FOM")>0){
            
            n=0;
            while (fgets(str, sizeof str, fp) != NULL){
                upperstr(str);
                if(strstr(str, "------") ||strstr(str, "CYCLE") )break;
                if(strlen(str)<20||strstr(str, "(") || strstr(str, "CLAC"))continue;
                if(sscanf(str, "%s %s %s %f   %s %s %s %s %s %s %s",
                          resol_L, resol_H, juck, &nf , juck, juck,juck,
                          fm, juck,juck,phi)==11){
                    nref=(int) nf;
                    sprintf(fom[n], "%s %s %d %s %s", resol_L, resol_H, nref, fm, phi);
                    n++;
                }
            }
        }
    }
        
    if(n>1){
        fprintf(fout,"\n\n##### Density modification #####\n");
        fprintf(fout,"loop_\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.d_res_low\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.d_res_high\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.reflns\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.fom\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.delta_phi_final\n");
        for(i=0; i<n; i++)
            fprintf(fout, "%s\n", fom[i]);
            
    }
     fclose(fp);  
    
}



void SHARP_phasing_wave(FILE *fout, char *inpfile, char *method)
/* to extract wavelength density_modification program
   maxmum 30 wavelength
*/

{
    FILE *finp;

    long i=0;
    int n=0;
    char str[512], juck[LEN];
    char res_L[NW][LEN], res_H[NW][LEN], fp[NW][LEN], fdp[NW][LEN];
    char rfp[NW][LEN], rfdp[NW][LEN], a1[LEN],a2[LEN];

    if((finp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s(SHARP_phasing_wave)\n",inpfile);
        return;
    }

    for(n=0; n<10; n++){
        strcpy(res_L[n], "?");
        strcpy(res_H[n], "?");
        strcpy(fp[n], "?");
        strcpy(fdp[n], "?");
        strcpy(rfp[n], "?");
        strcpy(rfdp[n], "?");
    }

    
    while (fgets(str, sizeof str, finp) != NULL) {
        upperstr(str);
        if (strstr_space(str, "   WAVELENGTH-TEXT {")>0){/*experimental */
            
            while (fgets(str, sizeof str, finp) != NULL){
                upperstr(str);
                if(strstr_space(str, "   WAVELENGTH {")>0 ) break;
                if(strstr(str, "  RESOLUTION  ")){
                    if(sscanf(str, "%s  %s %s", juck, a1 ,a2)==3 ){
                        strcpy(res_L[i], a1);
                        strcpy(res_H[i], a2);
                       
                    }
                } else if(strstr(str, " ATOM_F' ") && strstr(str, " ATOM_F\" ")){
                    if(sscanf(str, "%*s %*s %s %*s %*s %s %*s",  a1 ,a2)==2 ){
                        strcpy(fp[i], a1);
                        strcpy(fdp[i], a2);
                        i++;

                    }
                    
                }
            }
        }
    }

    
    if(i>0){
        fprintf(fout,"\n\n#++++++ SHARP MAD wavelegth+++++++++++++\n" );
        fprintf(fout,"loop_\n");
        if(!strcmp_case(method,"MAD")){ 
            fprintf(fout,"_phasing_%s_set.expt_id\n",method);
            fprintf(fout,"_phasing_%s_set.clust_id\n",method);
            fprintf(fout,"_phasing_%s_set.set_id\n",method);
            fprintf(fout,"_phasing_%s_set.d_res_low\n",method);
            fprintf(fout,"_phasing_%s_set.d_res_high\n",method);
            fprintf(fout,"_phasing_%s_set.f_prime\n",method);
            fprintf(fout,"_phasing_%s_set.f_double_prime\n",method);
            for(n=0; n<i; n++){
                fprintf(fout, "1 '%ld wavelength' %4d  %s %s %s %s\n",
                       i, n+1, res_L[n],res_H[n], fp[n], fdp[n]);
            }
        }
    }
    fclose(finp);
    
  
}


void SHARP_phasing_stat(FILE *fout, char *inpfile, char *method)
/* extract phasing statistics like FOM, R_Cullis, R_Kraut, Phasing power*/
{
    int i=0, j=0;
    int nshell_rc=0,nshell_kr=0,nshell_pw=0,nitem_rc=0,nitem_kr=0,nitem_pw=0;

    char **head, deriv_id[20];
    float rc_c[NBIN][30],rc_a[NBIN][30], kr_a[NBIN][30], kr_c[NBIN][30];
    float pw_a[NBIN][30], pw_c[NBIN][30], rc_all_a[30],rc_all_c[30];
    float kr_all_a[30],kr_all_c[30], pw_all_a[30],pw_all_c[30];
    
    SHARP_stat_fom(fout, inpfile, method);
    
    head = cmatrix(0,80, 0, 30);
    SHARP_stat(inpfile,(char *) "CULLIS ",rc_c, rc_a, head, rc_all_a, rc_all_c,
               &nshell_rc, &nitem_rc);
    SHARP_stat(inpfile,(char *)"KRAUT ", kr_c, kr_a, head, kr_all_a, kr_all_c,
               &nshell_kr, &nitem_kr);
    SHARP_stat(inpfile,(char *)"POWER ", pw_c, pw_a, head, pw_all_a, pw_all_c,
               &nshell_pw, &nitem_pw);
/*       
    printf("%3d %3d  %3d %3d  %3d %3d\n", nshell_rc, nshell_kr, nshell_pw,
           nitem_rc, nitem_kr, nitem_pw ); 

    if(!(nshell_rc == nshell_kr && nshell_kr==nshell_pw && nshell_kr>=1)||
       !(nitem_rc==nitem_kr && nitem_pw==nitem_kr && nitem_kr>=1)){
        return;
    }
*/
    if(!(nshell_rc == nshell_kr && nshell_kr==nshell_pw && nshell_kr>=1)||
       !(nitem_rc>1 && nitem_kr>1 && nitem_pw>1 )){
        return;
    }
    
    fprintf(fout,"\n\n#++++++  SHARP %s phasing statistics +++++++++\n",method);
    
    fprintf(fout,"\nloop_\n");
    
    if(!strcmp_case(method,"MIR")){    
        fprintf(fout,"_phasing_%s_der.der_id  \n",method);
        fprintf(fout,"_phasing_%s_der.d_res_low \n",method);
        fprintf(fout,"_phasing_%s_der.d_res_high \n",method);
        fprintf(fout,"_phasing_%s_der.R_cullis_centric \n",method);
        fprintf(fout,"_phasing_%s_der.R_cullis_acentric \n",method);
        fprintf(fout,"_phasing_%s_der.pdbx_R_kraut_centric \n",method);
        fprintf(fout,"_phasing_%s_der.pdbx_R_kraut_acentric \n",method);
        fprintf(fout,"_phasing_%s_der.power_centric \n",method);
        fprintf(fout,"_phasing_%s_der.power_acentric \n",method);
    }
    else if(!strcmp_case(method,"MAD")){
        fprintf(fout,"_pdbx_phasing_%s_set.id  \n",method);
        fprintf(fout,"_pdbx_phasing_%s_set.d_res_low \n",method);
        fprintf(fout,"_pdbx_phasing_%s_set.d_res_high \n",method);
        fprintf(fout,"_pdbx_phasing_%s_set.R_cullis_centric \n",method);
        fprintf(fout,"_pdbx_phasing_%s_set.R_cullis_acentric \n",method);
        fprintf(fout,"_pdbx_phasing_%s_set.R_kraut_centric \n",method);
        fprintf(fout,"_pdbx_phasing_%s_set.R_kraut_acentric \n",method);
        fprintf(fout,"_pdbx_phasing_%s_set.power_centric \n",method);
        fprintf(fout,"_pdbx_phasing_%s_set.power_acentric \n",method);
    }
    
    
    for(i=0; i<nitem_pw-3; i++){ /*overall*/
        strcpy(deriv_id,head[i+3]+5);
        fprintf(fout,"%s  ? %7.2f %7.3f %7.3f  %7.3f %7.3f  %7.3f %7.3f\n",
                deriv_id, rc_c[nshell_pw-1][2], rc_all_c[i], 
                rc_all_a[i], kr_all_c[i], kr_all_a[i], pw_all_c[i], pw_all_a[i]);
        
    }
    
    fprintf(fout,"\n#\n");
    
    fprintf(fout,"\nloop_\n");
    
    if(!strcmp_case(method,"MIR")){    
        fprintf(fout,"_phasing_%s_der_shell.der_id  \n",method);
        fprintf(fout,"_phasing_%s_der_shell.d_res_low \n",method);
        fprintf(fout,"_phasing_%s_der_shell.d_res_high \n",method);
        fprintf(fout,"_phasing_%s_der_shell.pdbx_R_cullis_centric \n",method);
        fprintf(fout,"_phasing_%s_der_shell.pdbx_R_cullis_acentric \n",method);
        fprintf(fout,"_phasing_%s_der_shell.pdbx_R_kraut_centric \n",method);
        fprintf(fout,"_phasing_%s_der_shell.pdbx_R_kraut_acentric \n",method);
        fprintf(fout,"_phasing_%s_der_shell.pdbx_power_centric \n",method);
        fprintf(fout,"_phasing_%s_der_shell.pdbx_power_acentric \n",method);
    }else if(!strcmp_case(method,"MAD")){
    
        fprintf(fout,"_pdbx_phasing_%s_set_shell.id  \n",method);
        fprintf(fout,"_pdbx_phasing_%s_set_shell.d_res_low \n",method);
        fprintf(fout,"_pdbx_phasing_%s_set_shell.d_res_high \n",method);
        fprintf(fout,"_pdbx_phasing_%s_set_shell.R_cullis_centric \n",method);
        fprintf(fout,"_pdbx_phasing_%s_set_shell.R_cullis_acentric \n",method);
        fprintf(fout,"_pdbx_phasing_%s_set_shell.R_kraut_centric \n",method);
        fprintf(fout,"_pdbx_phasing_%s_set_shell.R_kraut_acentric \n",method);
        fprintf(fout,"_pdbx_phasing_%s_set_shell.power_centric \n",method);
        fprintf(fout,"_pdbx_phasing_%s_set_shell.power_acentric \n",method);
    }
    
    
    for(i=3; i<nitem_pw; i++){ /*each shell*/
        strcpy(deriv_id,head[i]+5);
        
        for(j=0; j<nshell_pw; j++){
            if(j==0){
                fprintf(fout,"%s       ? %7.3f %7.3f %7.3f  %7.3f %7.3f  %7.3f %7.3f\n",
                       deriv_id, rc_c[j][2],    rc_c[j][i], rc_a[j][i],
                       kr_c[j][i], kr_a[j][i], pw_c[j][i], pw_a[j][i]);
            }else if(j>0){
                fprintf(fout,"%s %7.3f %7.3f %7.3f %7.3f  %7.3f %7.3f  %7.3f %7.3f\n",
                       deriv_id, rc_c[j-1][2],rc_c[j][2],   rc_c[j][i], rc_a[j][i],
                        kr_c[j][i], kr_a[j][i], pw_c[j][i], pw_a[j][i]);
            }
        }
        fprintf(fout,"\n");
        
    }

}



void SHARP_stat(char *inpfile, char *id,  float rc_c[80][30], float rc_a[80][30],
                char **head,float *all_a, float *all_c, int *nshell, int *nitem)
/* extract R_Cullis, R_Kraut, Phasing power*/
{
    FILE *fp;

    long  ia=0, na=0, ic=0, nc=0, j=0, k=0, m=0, nstr1=0, ns1=0, nh1=0;
    char  **line, str[512];

    *nshell = 0;
    *nitem =0;

    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s (routine:SHARP_stat)\n",inpfile);
        return;
    }
    
    line = cmatrix(0,300, 0, 100);
    
    
    ic=0;
    nc=0;
    while (fgets(str, sizeof str, fp) != NULL) {
        upperstr(str);
        if(strstr(str, id) && strstr(str, "STATISTICS")){
            while (fgets(str, sizeof str, fp) != NULL){
                upperstr(str);
                
                if(strstr(str, "STATISTICS"))break;
                if(strstr(str, "   CENTRICS") ){
                    
                    k=0;
                    while (fgets(str, sizeof str, fp) != NULL){
                        if(strlen(str)<30)continue;
                        if(strstr(str, "CENTRICS") || strstr(str, "-------"))break;
                        upperstr(str);
                        
                         if(strstr(str, "BINS") && strstr(str, "SPACING") ){
                            token_str(str+k, " ", &nh1, line);
                            for(j=0; j<nh1; j++)
                                strcpy(head[j+ic], line[j]);
                            m=0;
                            
                            while (fgets(str, sizeof str, fp) != NULL){
                                upperstr(str);
                                if(strlen(str)<10)continue;
                                
                                if(strstr(str, "OVERALL  ")){
                                    token_str(str+24, " ", &ns1, line);
                                    for(j=0; j<ns1; j++)
                                        all_c[j+nc] = atof(line[j]);
                                    nc=ns1+nc;
                                        /*
                                    printf("???? %d  %d  %d \n", ic, k, n);
                                        */
                                    break;
                                    
                                }
                                token_str(str+k, " ", &nstr1, line);
                                for(j=0; j<nstr1; j++){
                                    rc_c[m][j+ic]=atof(line[j]);
                                        /*
                                    strcpy(item[j+ic], line[j]);
                                    rc_c[m][j+i]=atof(item[j+i]);
                                    printf( "%3d %3d %s ", m, i+j, item[j+i]); 
                                        */
                                }
                                m++;
                                /*
                                printf( "\n");
                                */
                            }
                            ic=ic+nstr1;
                            k=24;
                            
                         }
                             
                    }
                }
            }
        }
    }
    fclose(fp);

    ia=0;
    na=0;    
    fp = fopen(inpfile, "r");
    while (fgets(str, sizeof str, fp) != NULL) {
        upperstr(str);
        if(strstr(str, id) && strstr(str, "STATISTICS")){
            while (fgets(str, sizeof str, fp) != NULL){
                upperstr(str);
                
                if(strstr(str, "STATISTICS"))break;

                else if(strstr(str, "   ACENTRICS") ){
                    
                    k=0;
                    while (fgets(str, sizeof str, fp) != NULL){
                        if(strlen(str)<30)continue;
                        if(strstr(str, "CENTRICS") || strstr(str, "-------"))break;
                        upperstr(str);
                        
                         if(strstr(str, "BINS") && strstr(str, "SPACING") ){
                            token_str(str+k, " ", &nh1, line);
                            for(j=0; j<nh1; j++)
                                strcpy(head[j+ia], line[j]);
                            m=0;
                            
                            while (fgets(str, sizeof str, fp) != NULL){
                                upperstr(str);
                                if(strlen(str)<10)continue;
                                
                                if(strstr(str, "OVERALL  ")){
                                    token_str(str+24, " ", &ns1, line);
                                    for(j=0; j<ns1; j++)
                                        all_a[j+na] = atof(line[j]);
                                    na=ns1+na;
                                        /*
                                    printf("???? %d  %d  %d \n", ia, k, na);
                                        */
                                    break;
                                    
                                }
                                token_str(str+k, " ", &nstr1, line);
                                for(j=0; j<nstr1; j++){
                                    rc_a[m][j+ia]=atof(line[j]);
                                    
                                     /*
                                    strcpy(item[j+i], line[j]);
                                    rc_a[m][j+i]=atof(item[j+i]);
                                    printf( "%3d %3d %s ", m, i+j, item[j+i]); 
                                     
                                     printf( "%3d %3d %8.3f ", m, ia+j, rc_a[m][j+ia]);
                                     */
                                }
                                m++;
                                /*
                                printf( "\n");
                                */
                            }
                            ia=ia+nstr1;
                            k=24;
                            
                         }
                             
                    }
                }
                
                
            }
        }
    }
    *nshell=m;
    *nitem=ia;
                         
    fclose(fp);
    
}

void SHARP_stat_fom(FILE *fout, char *inpfile, char *method)
/* extract FOM from SHARP output*/
{
    FILE *fp;
    int na[NBIN],nc[NBIN],n=0, na_a=0, nc_a=0, i=0;
    char str[512];
    float foma[NBIN], fomc[NBIN], resL[NBIN], resH[NBIN], foma_a, fomc_a;
    

    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s (:SHARP_stat_fom)\n",inpfile);
        return;
    }
       
    while (fgets(str, sizeof str, fp) != NULL) {
        if(strstr_space(str,"BINS  Dmin  Dmax  Nacen  FOMacen  Ncen  FOMcen")>0 ){
            
            while (fgets(str, sizeof str, fp) != NULL) {
                upperstr(str);
                if(strlen(str)<30) continue;
                
                if(strstr(str, " OVERALL ")){
                    if(strlen(str)>30)
                        sscanf(str,"%*s %d %f %d %f", &na_a, &foma_a, &nc_a, &fomc_a);
                    
                    break;
                }
                if(sscanf(str,"%*s %f %f %d %f %d %f",
                          &resL[n], &resH[n], &na[n], &foma[n], &nc[n], &fomc[n]) == 6){
                    n++;
                    if(n>299) printf("Too many bins, please increase the memory\n");
                }
            }
        }
    }
    fclose(fp);
    if(n>0){

        fprintf(fout, "###########SHARP FOM ########\n");
        
        fprintf(fout,"\nloop_\n");
        if(!strcmp_case(method,"MIR")){
            fprintf(fout,"_phasing_MIR_shell.d_res_low \n");
            fprintf(fout,"_phasing_MIR_shell.d_res_high \n");
            fprintf(fout,"_phasing_MIR_shell.reflns_acentric\n");
            fprintf(fout,"_phasing_MIR_shell.FOM_acentric \n");
            fprintf(fout,"_phasing_MIR_shell.reflns_centric\n");
            fprintf(fout,"_phasing_MIR_shell.FOM_centric \n");
        }else if (!strcmp_case(method,"MAD")){
            fprintf(fout,"_pdbx_phasing_MAD_shell.d_res_low \n");
            fprintf(fout,"_pdbx_phasing_MAD_shell.d_res_high \n");
            fprintf(fout,"_pdbx_phasing_MAD_shell.reflns_acentric\n");
            fprintf(fout,"_pdbx_phasing_MAD_shell.fom_acentric \n");
            fprintf(fout,"_pdbx_phasing_MAD_shell.reflns_centric\n");
            fprintf(fout,"_pdbx_phasing_MAD_shell.fom_centric \n");
        }
        for(i=0; i<n; i++){
            fprintf(fout,"%6.2f %6.2f %6d %6.3f %6d %6.3f\n",
                    resL[i], resH[i], na[i], foma[i], nc[i], fomc[i]);
        }
    }
    fprintf(fout,"\n\n");
//    printf("\nhello = %d  %d\n", na_a, nc_a);
    
    if((na_a>0 || nc_a>0) && n>0 ){        
        if(!strcmp_case(method,"MIR")){
            fprintf(fout, "_phasing_%s.d_res_low   %8.3f\n",method,resL[0] );
            fprintf(fout, "_phasing_%s.d_res_high   %8.3f\n",method,  resH[n-1]);
            fprintf(fout, "_phasing_%s.reflns_acentric  %d\n",method, na_a);
            fprintf(fout, "_phasing_%s.FOM_acentric  %.3f\n",method,foma_a);
            fprintf(fout, "_phasing_%s.reflns_centric  %d\n",method, nc_a);
            fprintf(fout, "_phasing_%s.FOM_centric  %.3f\n",method, fomc_a);
        }else if (!strcmp_case(method,"MAD")){
            fprintf(fout, "_phasing_%s.pdbx_d_res_low   %8.3f\n",method, resL[0]);
            fprintf(fout, "_phasing_%s.pdbx_d_res_high   %8.3f\n",method, resH[n-1]);
            fprintf(fout, "_phasing_%s.pdbx_reflns_acentric  %d\n",method, na_a);
            fprintf(fout, "_phasing_%s.pdbx_fom_acentric  %.3f\n",method,foma_a);
            fprintf(fout, "_phasing_%s.pdbx_reflns_centric  %d\n",method, nc_a);
            fprintf(fout, "_phasing_%s.pdbx_fom_centric  %.3f\n",method, fomc_a);
        }
    }
    
}


void SHARP_phasing_new_v2(FILE *fout, char *inpfile, char *method)
/* for version 2.0 */
{
    long i=0, j=0;
    long   nba_rc=0, nbin_rc=0,  nba_pp=0, nbin_pp=0, nba=100, nbin=200;
    double **res_H, **res_L;
    double **rc_ai, **rc_ci, **rc_aa, **rc_ca;
    long   **nrc_ai, **nrc_ci, **nrc_aa, **nrc_ca;
    double *rc_ai_all ,*rc_ci_all, *rc_aa_all,*rc_ca_all;
    long   *nrc_ai_all ,*nrc_ci_all, *nrc_aa_all, *nrc_ca_all;
    
    double **pp_ai, **pp_ci, **pp_aa, **pp_ca;
    long   **npp_ai, **npp_ci, **npp_aa, **npp_ca;
    double *pp_ai_all, *pp_ci_all, *pp_aa_all, *pp_ca_all;
    long   *npp_ai_all, *npp_ci_all, *npp_aa_all, *npp_ca_all;
    long  *nbach_rc, *nbach_pp;
    
    char *rc=(char *)"Dmin Dmax Nacen Ncen RC_acen RC_cen Nacen Ncen RC_acen RC_cen";
    char *pp=(char *)"Dmin Dmax Nacen Ncen PP_acen PP_cen Nacen Ncen PP_acen PP_cen";
    char str[512];
    FILE *fp;
    
           
    res_L=dmatrix(0, nba, 0, nbin);
    res_H=dmatrix(0, nba, 0, nbin);
    rc_ai=dmatrix(0, nba, 0, nbin);
    rc_ci=dmatrix(0, nba, 0, nbin);
    rc_aa=dmatrix(0, nba, 0, nbin);
    rc_ca=dmatrix(0, nba, 0, nbin);
    
    nrc_ai=lmatrix(0, nba, 0, nbin);
    nrc_ci=lmatrix(0, nba, 0, nbin);
    nrc_aa=lmatrix(0, nba, 0, nbin);
    nrc_ca=lmatrix(0, nba, 0, nbin);

    rc_ai_all=dvector(0, nba);
    rc_ci_all=dvector(0, nba);
    rc_aa_all=dvector(0, nba);
    rc_ca_all=dvector(0, nba);

    nrc_ai_all=lvector(0, nba);
    nrc_ci_all=lvector(0, nba);
    nrc_aa_all=lvector(0, nba);
    nrc_ca_all=lvector(0, nba);

    pp_ai=dmatrix(0, nba, 0, nbin);
    pp_ci=dmatrix(0, nba, 0, nbin);
    pp_aa=dmatrix(0, nba, 0, nbin);
    pp_ca=dmatrix(0, nba, 0, nbin);
    
    npp_ai=lmatrix(0, nba, 0, nbin);
    npp_ci=lmatrix(0, nba, 0, nbin);
    npp_aa=lmatrix(0, nba, 0, nbin);
    npp_ca=lmatrix(0, nba, 0, nbin);
    
    pp_ai_all=dvector(0, nba);
    pp_ci_all=dvector(0, nba);
    pp_aa_all=dvector(0, nba);
    pp_ca_all=dvector(0, nba);

    npp_ai_all=lvector(0, nba);
    npp_ci_all=lvector(0, nba);
    npp_aa_all=lvector(0, nba);
    npp_ca_all=lvector(0, nba);

    nbach_rc = lvector(0, nba);
    nbach_pp = lvector(0, nba);

        

    
    if((fp = fopen(inpfile, "r"))==NULL) {        
        printf("Can not open the file %s(SHARP_phasing_stat_v2)\n",inpfile);
        return;
    }
    
    while (fgets(str, sizeof str, fp) != NULL) { /* for R-Cullis */
        if(strstr_space(str,"RC_acen  : R-Cullis for acentric reflexions in this")>0 )
            break;
    }
    nba_rc=0;
    while (fgets(str, sizeof str, fp) != NULL) {
        if(strstr_space(str,"Phasing Power")>0  || 
           strstr_space(str,"Dmin : lowest resolution of the" )>0) break;
        if(pattern5(str,"BATCH", " number", ": " ,"", "")>0 ){
             nba_rc++;
             get_data_new_v2(fp,rc,res_L,res_H,
                             rc_ai, rc_ci, nrc_ai, nrc_ci,
                             rc_aa, rc_ca, nrc_aa, nrc_ca,
                             rc_ai_all, rc_ci_all, nrc_ai_all, nrc_ci_all,
                             rc_aa_all, rc_ca_all, nrc_aa_all, nrc_ca_all,
                             nba_rc, &nbin_rc);
             nbach_rc[nba_rc]=nbin_rc;
        }
    }

    rewind(fp);
    while (fgets(str, sizeof str, fp) != NULL) { /* for phasing power*/
        if(strstr_space(str,"PP_acen  : phasing power for acentric reflexions in this")>0 )
            break;
    }
    nba_pp=0;
    while (fgets(str, sizeof str, fp) != NULL) {
        if(strstr_space(str,"Cullis R-factor")>0 ||
           strstr_space(str, "BINS : resolution bin number")>0 )break;
        if(pattern5(str,"BATCH", " number", ": " ,"", "")>0 ){
            nba_pp++;
            get_data_new_v2(fp,pp,res_L,res_H,
                            pp_ai, pp_ci, npp_ai, npp_ci,
                            pp_aa, pp_ca, npp_aa, npp_ca,
                            pp_ai_all, pp_ci_all, npp_ai_all, npp_ci_all,
                            pp_aa_all, pp_ca_all, npp_aa_all, npp_ca_all,
                            nba_pp, &nbin_pp);
            nbach_pp[nba_pp]=nbin_pp;
        }
    }

    if(nba_rc<=0  && nba_pp<=0) return;
    

    fprintf(fout,"\nloop_\n");
    if(!strcmp_case(method,"MIR")){    
        fprintf(fout,"_phasing_MIR_der_shell.der_id  \n");
        fprintf(fout,"_phasing_MIR_der_shell.d_res_low \n");
        fprintf(fout,"_phasing_MIR_der_shell.d_res_high \n");
        fprintf(fout,"_phasing_MIR_der_shell.pdbx_reflns_acentric\n");
        fprintf(fout,"_phasing_MIR_der_shell.pdbx_reflns_centric \n");
        
        if(nba_rc>0 && nbin_rc>0){
            fprintf(fout,"_phasing_MIR_der_shell.pdbx_R_cullis_acentric\n");
            fprintf(fout,"_phasing_MIR_der_shell.pdbx_R_cullis_centric\n");
        }
        
        if(nba_pp>0 && nbin_pp>0){
            fprintf(fout,"_phasing_MIR_der_shell.pdbx_power_acentric \n");
            fprintf(fout,"_phasing_MIR_der_shell.pdbx_power_centric\n");
        }
        
    }
    else if(!strcmp_case(method,"MAD")){
        fprintf(fout,"_pdbx_phasing_MAD_set_shell.id  \n");
        fprintf(fout,"_pdbx_phasing_MAD_set_shell.d_res_low \n");
        fprintf(fout,"_pdbx_phasing_MAD_set_shell.d_res_high \n");
        fprintf(fout,"_pdbx_phasing_MAD_set_shell.reflns_acentric\n");
        fprintf(fout,"_pdbx_phasing_MAD_set_shell.reflns_centric\n");

        if(nba_rc>0 && nbin_rc>0){
            fprintf(fout,"_pdbx_phasing_MAD_set_shell.R_cullis_acentric \n");
            fprintf(fout,"_pdbx_phasing_MAD_set_shell.R_cullis_centric\n");
        }
        if(nba_pp>0 && nbin_pp>0){
            fprintf(fout,"_pdbx_phasing_MAD_set_shell.power_acentric\n");
            fprintf(fout,"_pdbx_phasing_MAD_set_shell.power_centric\n");
        }
        
    }
    
    if(nba_rc>0  && nba_pp<=0){ /* only Rc */    
        for(i=1; i<=nba_rc; i++){ /*each set (batch)*/
            for(j=1; j<=nbach_rc[i]; j++){ 
                fprintf(fout,"ISO_%ld %.2f %.2f   %ld  %ld  %.3f %.3f\n",
                        i,res_L[i][j], res_H[i][j], nrc_ai[i][j], nrc_ci[i][j],
                        rc_ai[i][j], rc_ci[i][j]);
            }
            
            if(!strcmp_case(method,"MAD")){ 
                for(j=1; j<=nbach_rc[i]; j++){ 
                    fprintf(fout,"ANO_%ld %.2f %.2f   %ld  %ld   %.3f %.3f\n",
                            i,res_L[i][j], res_H[i][j],  nrc_aa[i][j], nrc_ca[i][j],
                            rc_aa[i][j], rc_ca[i][j]);
                }
            }
            
        }
    }

    if(nba_pp>0  && nba_rc<=0){/* only PP */

         for(i=1; i<=nba_pp; i++){ /*each set (batch)*/
             
            for(j=1; j<=nbach_pp[i]; j++){ 
                fprintf(fout,"ISO_%ld %.2f %.2f   %ld  %ld  %.3f %.3f\n",
                        i,res_L[i][j], res_H[i][j], npp_ai[i][j], npp_ci[i][j],
                        pp_ai[i][j], pp_ci[i][j]);
            }
            if(!strcmp_case(method,"MAD")){ 

                for(j=1; j<=nbach_pp[i]; j++){ 
                    fprintf(fout,"ANO_%ld %.2f %.2f  %ld  %ld   %.3f %.3f\n",
                            i,res_L[i][j], res_H[i][j], npp_aa[i][j], npp_ca[i][j],
                            pp_aa[i][j], pp_ca[i][j]);
                } 
            }
         }
    }
     

    if(nba_rc==nba_pp &&  nba_pp>0 &&  nba_rc>0 ){ /*both Rc and PP */
        for(i=1; i<=nba_rc; i++){ 
            for(j=1; j<=nbach_rc[i]; j++){
                fprintf(fout,"ISO_%ld  %.2f %.2f   %ld  %ld    %.3f %.3f %.3f %.3f\n",
                       i, res_L[i][j], res_H[i][j], nrc_ai[i][j], nrc_ci[i][j], 
                       rc_ai[i][j], rc_ci[i][j], pp_ai[i][j], pp_ci[i][j]);
            }
            
            if(!strcmp_case(method,"MAD")){ 
                for(j=1; j<=nbach_rc[i]; j++){
                    fprintf(fout, "ANO_%ld  %.2f %.2f %ld  %ld  %.3f %.3f   %.3f %.3f\n",
                            i, res_L[i][j], res_H[i][j],nrc_aa[i][j], nrc_ca[i][j],
                            rc_aa[i][j], rc_ca[i][j], pp_aa[i][j], pp_ca[i][j]);
                }
            }
            
        }
    }


// for _phasing_MIR_der or _pdbx_phasing_MAD_set
    
    if(!strcmp_case(method,"MIR")){
        
        fprintf(fout,"\nloop_\n");

        fprintf(fout,"_phasing_MIR_der.id  \n");
        fprintf(fout,"_phasing_MIR_der.der_set_id  \n");
        fprintf(fout,"_phasing_MIR_der.native_set_id  \n");
        fprintf(fout,"_phasing_MIR_der.d_res_low \n");
        fprintf(fout,"_phasing_MIR_der.d_res_high \n");
        fprintf(fout,"_phasing_MIR_der.reflns_acentric\n");
        fprintf(fout,"_phasing_MIR_der.reflns_centric \n");

        if(nba_rc>0 && nbin_rc>0){
            fprintf(fout,"_phasing_MIR_der.R_cullis_acentric\n");
            fprintf(fout,"_phasing_MIR_der.R_cullis_centric \n");
        }
        
        if(nba_pp>0 && nbin_pp>0){
            fprintf(fout,"_phasing_MIR_der.power_acentric\n");
            fprintf(fout,"_phasing_MIR_der.power_centric \n");
        }
    
        if(nba_rc>0 && nbin_rc>0 && nba_pp<=0){ /*Rc only*/
            for(i=1; i<=nba_rc; i++){ 
                fprintf(fout,"ISO_%ld %ld 1 %.2f %.2f  %ld %ld  %.3f %.3f\n",
                        i,i,res_L[i][1], res_H[i][nbin_rc],  nrc_ai_all[i], nrc_ci_all[i],
                        rc_ai_all[i], rc_ci_all[i]);
            }
        }
    
        if(nba_pp>0 && nbin_pp>0 && nba_rc<=0){ /*PP only*/
            for(i=1; i<=nba_pp; i++){ 
                fprintf(fout,"ISO_%ld %ld 1 %.2f %.2f  %ld %ld  %.3f %.3f\n",
                        i,i,res_L[i][1], res_H[i][nbin_pp],  npp_ai_all[i], npp_ci_all[i],
                        pp_ai_all[i], pp_ci_all[i]);
            }
        }

    
        if(nba_rc==nba_pp && nbin_rc==nbin_pp && nba_pp>0 && nbin_pp>0 ){/*PP & Rc*/
            for(i=1; i<=nba_rc; i++){
                fprintf(fout, "ISO_%ld %ld 1 %.2f %.2f  %ld %ld  %.3f %.3f %.3f %.3f\n", i,i,
                        res_L[i][1], res_H[i][nbin_rc],  nrc_ai_all[i],nrc_ci_all[i],
                        rc_ai_all[i], rc_ci_all[i], pp_ai_all[i], pp_ci_all[i]);
            }
        
        }

        
    }else if(!strcmp_case(method,"MAD")){

        fprintf(fout,"\nloop_\n");
        fprintf(fout,"_pdbx_phasing_MAD_set.id  \n");
        fprintf(fout,"_pdbx_phasing_MAD_set.d_res_low \n");
        fprintf(fout,"_pdbx_phasing_MAD_set.d_res_high \n");
        fprintf(fout,"_pdbx_phasing_MAD_set.reflns_acentric \n");
        fprintf(fout,"_pdbx_phasing_MAD_set.reflns_centric \n");
       
        if(nba_rc>0 && nbin_rc>0){
            fprintf(fout,"_pdbx_phasing_MAD_set.R_cullis_acentric\n");
            fprintf(fout,"_pdbx_phasing_MAD_set.R_cullis_centric \n");
        }
        
        if(nba_pp>0 && nbin_pp>0){
            fprintf(fout,"_pdbx_phasing_MAD_set.power_acentric\n");
            fprintf(fout,"_pdbx_phasing_MAD_set.power_centric \n");
        }
   

    
        if(nba_rc>0 && nbin_rc>0 && nba_pp<=0){ /*Rc only*/
            for(i=1; i<=nba_rc; i++){ 
                fprintf(fout,"ISO_%ld %.2f %.2f  %ld %ld  %.3f %.3f\n",
                        i,res_L[i][1], res_H[i][nbin_rc],  nrc_ai_all[i], nrc_ci_all[i],
                        rc_ai_all[i], rc_ci_all[i]);
            }
            for(i=1; i<=nba_rc; i++){ 
                fprintf(fout,"ANO_%ld %.2f %.2f  %ld %ld  %.3f %.3f\n",
                        i,res_L[i][1], res_H[i][nbin_rc],  nrc_aa_all[i], nrc_ca_all[i],
                        rc_aa_all[i], rc_ca_all[i]);
            }
        }
    
        if(nba_pp>0 && nbin_pp>0 && nba_rc<=0){ /*PP only*/
            for(i=1; i<=nba_pp; i++){ 
                fprintf(fout,"ISO_%ld %.2f %.2f  %ld %ld  %.3f %.3f\n",
                        i,res_L[i][1], res_H[i][nbin_pp],  npp_ai_all[i], npp_ci_all[i],
                        pp_ai_all[i], pp_ci_all[i]);
            }
            for(i=1; i<=nba_pp; i++){ 
                fprintf(fout,"ANO_%ld %.2f %.2f  %ld %ld  %.3f %.3f\n",
                        i,res_L[i][1], res_H[i][nbin_pp],  npp_aa_all[i], npp_ca_all[i],
                        pp_aa_all[i], pp_ca_all[i]);
            }
        }

    
        if(nba_rc==nba_pp && nbin_rc==nbin_pp && nba_pp>0 && nbin_pp>0 ){/*PP & Rc*/
            for(i=1; i<=nba_rc; i++){
                fprintf(fout, "ISO_%ld %.2f %.2f  %ld %ld  %.3f %.3f %.3f %.3f\n", i,
                        res_L[i][1], res_H[i][nbin_rc],  nrc_ai_all[i],nrc_ci_all[i],
                        rc_ai_all[i], rc_ci_all[i], pp_ai_all[i], pp_ci_all[i]);
            }

            for(i=1; i<=nba_rc; i++){
                fprintf(fout,"ANO_%ld %.2f %.2f  %ld %ld  %.3f %.3f %.3f %.3f\n", i,
                        res_L[i][1], res_H[i][nbin_rc],  nrc_aa_all[i],nrc_ca_all[i],
                        rc_aa_all[i], rc_ca_all[i], pp_aa_all[i], pp_ca_all[i]);
            }
        
        }
    }
    
    
    free_dmatrix(res_L,0, nba, 0, nbin);
    free_dmatrix(res_H,0, nba, 0, nbin);
    free_dmatrix(rc_ai,0, nba, 0, nbin);
    free_dmatrix(rc_ci,0, nba, 0, nbin);
    free_dmatrix(rc_aa,0, nba, 0, nbin);
    free_dmatrix(rc_ca,0, nba, 0, nbin);

    free_dvector(rc_ai_all,0, nba);
    free_dvector(rc_ci_all,0, nba);
    free_dvector(rc_aa_all,0, nba);
    free_dvector(rc_ca_all,0, nba);

    free_dmatrix(pp_ai,0, nba, 0, nbin);
    free_dmatrix(pp_ci,0, nba, 0, nbin);
    free_dmatrix(pp_aa,0, nba, 0, nbin);
    free_dmatrix(pp_ca,0, nba, 0, nbin);
    
    free_dvector(pp_ai_all,0, nba);
    free_dvector(pp_ci_all,0, nba);
    free_dvector(pp_aa_all,0, nba);
    free_dvector(pp_ca_all,0, nba);
    
}

                        
                    
                    
 void get_data_new_v2(FILE *fp, char *rc, double **res_L, double **res_H, 
                     double **rc_ai, double **rc_ci, long **nrc_ai, long **nrc_ci, 
                     double **rc_aa, double **rc_ca, long **nrc_aa, long **nrc_ca, 
                     double *rc_ai_all, double *rc_ci_all, long *nrc_ai_all, long *nrc_ci_all,
                     double *rc_aa_all, double *rc_ca_all, long *nrc_aa_all, long *nrc_ca_all,
                     long nba, long *nb)
   
                    
{
    float t1, t2,  t5, t6,  t9, t10;
    long   t3=0, t4=0, t7=0, t8=0;
    char tmp[512], str[512];
    long n=0, nbin=0, nt=0;
    
//            printf("THE FILE IS:  %s\n", rc);
    
    while (fgets(str, sizeof str, fp) != NULL) {
        if(strstr_space(str,rc)>0){
            nbin=0;
            while (fgets(str, sizeof str, fp) != NULL) {
        
                n=sscanf(str, "%ld %f %f %ld %ld %f %f %ld %ld %f %f",&nt, &t1,&t2,
                         &t3,&t4,&t5,&t6,&t7,&t8,&t9,&t10);
                
                if(n==11){
                    nbin++;
                
                    res_L[nba][nbin]=t1;
                    res_H[nba][nbin]=t2;
                    
                    nrc_ai[nba][nbin]=t3;
                    nrc_ci[nba][nbin]=t4;
                    rc_ai[nba][nbin]=t5;
                    rc_ci[nba][nbin]=t6;
                            
                    nrc_aa[nba][nbin]=t7;
                    nrc_ca[nba][nbin]=t8;
                    rc_aa[nba][nbin]=t9;
                    rc_ca[nba][nbin]=t10;
                
                }
                
                if (strstr_space( str, "OVERALL")>0){
                    n=sscanf(str, "%s %ld %ld %f %f %ld %ld %f %f",tmp, &t3,&t4,
                             &t5,&t6,&t7,&t8, &t9,&t10);
                    if(n==9) {
                        nrc_ai_all[nba]=t3;
                        nrc_ci_all[nba]=t4;
                        rc_ai_all[nba]=t5;
                        rc_ci_all[nba]=t6;
                        
                        nrc_aa_all[nba]=t7;
                        nrc_ca_all[nba]=t8;
                        rc_aa_all[nba]=t9;
                        rc_ca_all[nba]=t10;
                    }
                    break;
                }
            }
            *nb=nbin;
            return;
        }
        
    }
    
}
