/*
FILE:     check_global.h
*/
/*
VERSION:  1.700
*/
/*
DATE:     7/13/2005
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2005 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/

CHECK_TOKEN_FORMAT Check_Format[NUM_TOKEN] = {
        { "CISPEP", -1, 2, PDB_ONLY,
            {
                {   0,  3,  2,  4,  5 },
                {   0,  7,  6,  8,  9 }
            }
        },
	{ "DBREF", -1, 2, CHANGED,
	    {
		{   0,  2,  0,  3,  4 },
                {   0,  2,  0,  5,  6 }
	    }
	},
	{ "HELIX", -1, 2, NDB_ONLY,
	    {
		{   0,  4,  3,  5,  6 },
                {   0,  8,  7,  9, 10 }
	    }
	},
	{ "HET", -1, 1, PDB_ONLY,
	    {
		{   0,  2,  1,  3,  4 }
	    }
	},
	{ "HYDBND", -1, 3, CHANGED,
	    {
		{   1,  4,  3,  5,  6 },
                {   7,  9,  0, 10, 11 },
                {  12, 15, 14, 16, 17 }
	    }
	},
	{ "LINK", -1, 2, PDB_ONLY,
	    {
		{   1,  4,  3,  5,  6 },
                {   7, 10,  9, 11, 12 }
	    }
	},
	{ "MODRES", -1, 1, CHANGED,
	    {
		{   0,  3,  2,  4,  5 }
	    }
	},
	{ "SHEET", -1, 4, NDB_ONLY,
	    {
		{   0,  5,  4,  6,  7 },
                {   0,  9,  8, 10, 11 },
                {  13, 15, 14, 16, 17 },
                {  18, 20, 19, 21, 22 }
	    }
	},
	{ "SITE", -1, 4, CHANGED,
	    {
		{   0,  5,  4,  6,  7 },
                {   0,  9,  8, 10, 11 },
                {   0, 13, 12, 14, 15 },
                {   0, 17, 16, 18, 19 }
	    }
	},
	{ "SLTBRG", -1, 2, CHANGED,
	    {
		{   1,  4,  3,  5,  6 },
                {   7, 10,  9, 11, 12 }
	    }
	},
	{ "SSBOND", -1, 2, NDB_ONLY,
	    {
		{   0,  3,  2,  4,  5 },
                {   0,  7,  6,  8,  9 }
	    }
	},
	{ "TURN", -1, 2, NDB_ONLY,
	    {
		{   0,  4,  3,  5,  6 },
                {   0,  8,  7,  9, 10 }
	    }
	}
};

CHECK_CATEGORY check_category[NUM_CHECK_CATEGORY] = {
/*
        { "struct_mon_prot_cis", "CISPEP", -1, 2,
           {  "",
              "label_asym_id",
              "label_comp_id",
              "label_seq_id",
              "ndb_label_ins_code"
           },
           {  "",
              "ndb_label_asym_id_2",
              "ndb_label_comp_id_2",
              "ndb_label_seq_id_2",
              "ndb_label_ins_code_2"
           }
        },
*/
        { "struct_conf", "conf_type_id", -1, 2,
           {
              {  "",
                 "beg_auth_asym_id",
                 "beg_auth_asym_id",
                 "beg_auth_seq_id",
                 "ndb_beg_label_ins_code_pdb"
              },
              {  "",
                 "end_auth_asym_id",
                 "end_auth_comp_id",
                 "end_auth_seq_id",
                 "ndb_end_label_ins_code_pdb"
              }
           }
        },
        { "struct_sheet_range", "SHEET", -1, 2,
           {
              {  "",
                 "beg_auth_asym_id",
                 "beg_auth_comp_id",
                 "beg_auth_seq_id",
                 "ndb_beg_label_ins_code_pdb"
              },
              {  "",
                 "end_auth_asym_id",
                 "end_auth_comp_id",
                 "end_auth_seq_id",
                 "ndb_end_label_ins_code_pdb"
              }
           }
        },
        { "struct_sheet_hbond", "SHEET", -1, 2,
           {
              {  "range_1_beg_label_atom_id",
                 "ndb_range_1_beg_auth_asym_id",
                 "ndb_range_1_beg_auth_comp_id",
                 "range_1_beg_auth_seq_id",
                 "ndb_range_1_beg_label_ins_code"
              },
              {  "range_1_end_label_atom_id",
                 "ndb_range_1_end_auth_asym_id",
                 "ndb_range_1_end_auth_comp_id",
                 "range_1_end_auth_seq_id",
                 "ndb_range_1_end_label_ins_code"
              }
           }
        },
        { "struct_site_gen", "SITE", -1, 1,
           {
              {  "",
                 "auth_asym_id",
                 "auth_comp_id",
                 "auth_seq_id",
                 "ndb_label_ins_code"
              }
           }
        },
        { "struct_conn", "conn_type_id", -1, 2,
           {
              {  "ptnr1_label_atom_id",
                 "ptnr1_auth_asym_id",
                 "ptnr1_auth_comp_id",
                 "ptnr1_auth_seq_id",
                 "ndb_ptnr1_label_ins_code"
              },
              {  "ptnr2_label_atom_id",
                 "ptnr2_auth_asym_id",
                 "ptnr2_auth_comp_id",
                 "ptnr2_auth_seq_id",
                 "ndb_ptnr2_label_ins_code"
              }
           }
        },
        { "rcsb_struct_link", "LINK", -1, 2,
           {
              {  "ptnr1_label_atom_id",
                 "ptnr1_label_asym_id",
                 "ptnr1_label_comp_id",
                 "ptnr1_label_seq_id",
                 "ptnr1_label_ins_code"
              },
              {  "ptnr2_label_atom_id",
                 "ptnr2_label_asym_id",
                 "ptnr2_label_comp_id",
                 "ptnr2_label_seq_id",
                 "ptnr2_label_ins_code"
              }
           }
        } 
};

#define  NUM_CHECK_CATEGORY1  2

CHECK_CATEGORY check_category1[NUM_CHECK_CATEGORY1] = {
        { "struct_ncs_dom_lim", "", -1, 2, 
          { { "", "beg_auth_asym_id", "", "beg_auth_seq_id", "" },
            { "", "end_auth_asym_id", "", "end_auth_seq_id", "" }
          }
        },
        { "ccp4_refine_tls_group", "", -1, 2,
          { { "", "beg_auth_asym_id", "", "beg_auth_seq_id", "" },
            { "", "end_auth_asym_id", "", "end_auth_seq_id", "" }
          }
        }
};

typedef struct {
        const char *category1;
        const char *item1;
        const char *category2;
        const char *item2;
        int  contain_value;
        const char *message;
} CHECK_RESOLUTION;

// #define NUM_CHECK_RESOLUTION   9
#define NUM_CHECK_RESOLUTION   11

static CHECK_RESOLUTION check_res[NUM_CHECK_RESOLUTION] = {
       { "ndb_refine", "R_factor_obs_no_cutoff", "ndb_refine", "R_factor_all_no_cutoff", 0, "" },
       { "ndb_refine", "R_factor_obs_4sig_cutoff", "ndb_refine", "R_factor_all_4sig_cutoff", 0, "" },
       { "refine",          "ls_d_res_high",        "refine",          "ls_d_res_low", 0, "" },
       { "reflns",          "d_resolution_high",    "reflns",          "d_resolution_low", 0, "" },
       // { "refine",          "ls_d_res_high",      "reflns",          "d_resolution_high" },
       { "reflns",          "d_resolution_high",    "refine",          "ls_d_res_high", 0, "" },
       { "refine",     "ls_d_res_low",              "reflns",          "d_resolution_low", 0, "" },
       { "refine",          "ls_number_reflns_obs", "reflns",          "number_obs", 1,
         "Please note that the number of observed reflections given for the\n\
       refinement %s is greater than the number of observed reflections\n\
       for the experiment %s. Please provide corrected values.\n" },
       { "refine",          "ls_R_factor_R_work",   "refine",          "ls_R_factor_R_free", 0,
         "Generally, the  R-factor-free is greater than the R-factor-work\n\
       but they are reversed in your case. Please, confirm.\n" },
       { "refine",          "ls_R_factor_R_work",   "refine",          "ls_R_factor_obs", 1,
         "Please note that R-factor-work %s was greater than the R-factor-obs %s.\n\
       Please provide corrected values.\n" },
       { "refine",          "ls_R_factor_R_work",   "refine",          "ls_R_factor_all", 1,
         "Please note that R-factor-work %s was greater than the R-factor-all %s.\n\
       Please provide corrected values.\n" },
       { "reflns_shell",    "d_res_high",           "reflns_shell",    "d_res_low", 0, "" } /* ,
       { "refine_ls_shell", "R_factor_R_work",      "refine_ls_shell", "R_factor_R_free", 0, "" } */
};

#define NUM_SAME_VALUE      2

static CHECK_RESOLUTION check_same[NUM_SAME_VALUE] = {
       { "refine_ls_shell",  "d_res_high",  "refine",  "ls_d_res_high" },
       { "reflns_shell",     "d_res_high",  "reflns",  "d_resolution_high" }
};

typedef struct {
        const char *category;
        const char *item;
        const char *message;
} _Category;

#define NUM_MISSING_VALUE    6

static _Category _Missing_Values[NUM_MISSING_VALUE] = {
       { "computing", "structure_refinement",
         "Please provide the name of the refinement program.\n"
       },
       { "refine", "ls_R_factor_R_work", "" },
       { "refine", "ls_number_reflns_obs",
         "Please provide the total number of crystallographically unique\n\
         observed reflections for the refinement.\n"
       },
/*
       { "refine", "ndb_ls_sigma_F",
         "Please provide the sigma F value for the refinement.\n"
       },
*/
       { "reflns", "number_obs",
         "Please provide the total number of crystallographically unique\n\
         observed reflections for the experiment.\n"
       },
       { "reflns", "d_resolution_high",
         "Please provide the high resolution for data collection.\n"
       },
       { "reflns", "d_resolution_low",
         "Please provide the low resolution for data collection.\n"
       }
};

#define NUM_ZERO_VALUE       5

static _Category _Zero_Values[NUM_ZERO_VALUE] = {
       { "refine", "ls_R_factor_R_free", "" },
       { "refine", "ls_R_factor_R_work", "" },
       { "refine", "ls_R_factor_all", "" },
       { "refine", "ls_R_factor_obs", "" },
       { "refine", "ls_number_reflns_R_free", "" }
};

#define NUM_UPPER_CASE       2

static _Category _Upper_Case[NUM_UPPER_CASE] = {
       { "citation", "title", "" },
       { "struct", "title", "" }
};

typedef struct {
        const char  *category;
        const char  *item;
        int   op;
        float value;
} _Category_Value;

#define NUM_CATEGORY_VALUE   6

static _Category_Value _Check_Category_Values[NUM_CATEGORY_VALUE] =
{
       { "diffrn",          "ambient_temp",     0, 50.0 },
       { "refine_ls_shell", "d_res_low",        1, 50.0 },
       { "reflns",          "ndb_Rmerge_I_obs", 1, 0.20 },
       { "reflns",          "ndb_Rsym_value",   1, 0.20 },
       { "reflns_shell",    "Rmerge_I_obs",     1, 0.40 },
       { "reflns_shell",    "ndb_Rsym_value",   1, 0.40 }
};

typedef struct {
        const char  *category1;
        const char  *item1;
        const char  *category2;
        const char  *item2;
        int   op;      /* 0 for minus, 1 for divide */
        float value;
        const char  *message;
} _Category_Compare;

#define NUM_CATEGORY_COMP   5

static _Category_Compare _Check_Category_Comp[NUM_CATEGORY_COMP] = {
       { "refine",          "ls_number_reflns_all", "refine",          "ls_number_reflns_obs", 1, 3.0, 
         "Please note that the number of all unique reflections %s compared\n\
         to the number of observed unique reflections %s given for the refinement\n\
         is too high.  We are looking for all the crystallographically\n\
         unique measured reflections, not the total number of reflections.\n\
         Please provide the number of crystallographically unique measured\n\
         reflections for the refinement.\n" },
       { "reflns",          "number_all",           "reflns",          "number_obs",           1, 3.0,
         "Please note that the number of all unique reflections %s compared\n\
         to the number of observed unique reflections %s given for the experiment\n\
         is too high.  We are looking for all the crystallographically\n\
         unique measured reflections, not the total number of reflections.\n\
         Please provide the number of crystallographically unique measured\n\
         reflections for the experiment.\n" },
       { "reflns",          "number_obs",           "refine",          "ls_number_reflns_obs", 1, 1.5,
         "The number of unique measured reflections for data collection %s\n\
         is too large when compared to the number of reflections for refinement %s\n\
         Please provide the number of unique measured reflections for data collection.\n" },
       { "refine_ls_shell", "d_res_low",            "refine_ls_shell", "d_res_high",           0, 0.3,
         "Please note that the low resolution range %s and the high\n\
         resolution range %s in the highest resolution shell are expected\n\
         to be closer to the value of the highest resolution range.  We are\n\
         looking for the resolution values only in the highest shell for this\n\
         section. Please provide the low resolution range for the highest\n\
         shell,if available.\n" },
       { "reflns_shell",    "d_res_low",            "reflns_shell",    "d_res_high",           0, 0.3,
         "Please note that the low resolution range %s and the high resolution\n\
         range %s in the highest resolution shell for data collection are expected\n\
         to be closer to the value of the highest resolution range.  We are\n\
         looking for the resolution values only in the highest shell for this\n\
         section. Please provide the low resolution range for the highest\n\
         shell,if available.\n" },
};

typedef struct {
        const char *category;
        const char *item1;
        const char *item2;
        const char *item3;
        const char *message1; /* reversed */
        const char *message2; /* equal */
        const char *message3; /* not equal */
} _Category_Compare3;

// #define NUM_CATEGORY_COMP3  3
#define NUM_CATEGORY_COMP3  1

static _Category_Compare3 _Check_Category_Comp3[NUM_CATEGORY_COMP3] = {
/*
       { "refine", "ndb_ls_sigma_F", "ls_number_reflns_all", "ls_number_reflns_obs", "", "",
         "In the refinement section, shouldn't the number of all unique\n\
         measured reflections equal the number of observed unique measured\n\
         reflections when the Sigma F value is 0?  The numbers reported here\n\
         were %s for all reflections and %s for observed\n\
         reflections. Please correct if necessary.\n" },
*/
       { "refine", "ndb_ls_sigma_F", "ls_R_factor_all", "ls_R_factor_obs", 
         "The R-factor-all should be greater than the R-factor-obs when the\n\
         sigma F cutoff is greater than 0.0 but they are reversed in your\n\
         deposition. The values were switched, please provide correct values if\n\
         this is not correct.\n",
         "The R-factor-all should be greater than the R-factor-obs when the\n\
         sigma F cutoff is greater than 0.0 but they are equal in your\n\
         deposition. Please provide correct values.\n", ""
       }
/*
       ,
       { "reflns", "observed_criterion_sigma_I", "number_all", "number_obs", "", "", "" }
*/
};

#define NUM_UNIQUE_INDEX  11

static UNIQUE_INDEX _Unique_Index[NUM_UNIQUE_INDEX] = {
       { 0, 1, "audit_author",   { "name", "" } },
       { 0, 2, "citation_author", { "citation_id", "name" } },
       { 1, 2, "database_PDB_rev_record", { "rev_num", "type" } },
       { 1, 1, "exptl_crystal_grow_comp", { "id", "" } },
       { 1, 2, "rcsb_database_related", { "db_name", "db_id" } },
       { 1, 1, "refine_ls_restr", { "type", "" } },
       { 1, 2, "struct_biol_gen", { "asym_id", "symmetry" } },
       { 1, 1, "struct_ref", { "id", "" } },
       { 1, 1, "struct_ref_seq", { "align_id", "" } },
       { 1, 1, "struct_sheet", { "id", "" } },
       { 1, 1, "struct_site_gen", { "id", "" } }
};
