/*
FILE:     ndb_atlas_text.h
*/
/*
VERSION:  1.700
*/
/*
DATE:     7/13/2005
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2005 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
#ifndef _NDB_ATLAS_TEXT_
#define _NDB_ATLAS_TEXT_

#define NUM_DESCRIP   137
#define NUM_REPALCE    18
#define NUM_SOLUTION   96

typedef struct {
        char old_string[150];
        char new_string[150];
} HTML_STRING;

#ifdef SUN_OS
#ifdef __cplusplus
extern "C" {
#endif
#endif
static int string_compare(const void *a, const void *b)
{
       return (strcmp(((HTML_STRING *) a)->old_string,
                      ((HTML_STRING *) b)->old_string));
}
#ifdef SUN_OS
#ifdef __cplusplus
}
#endif
#endif

static HTML_STRING descriptor[NUM_DESCRIP] = {
       { "(r)-3'-desamino-3'-(2-methoxy-4-morpholinyl)-doxorubicin ((r)-mmdox)",
         "(R)-3'-desamino-3'-(2-methoxy-4-morpholinyl)-doxorubicin ((R)-MMDOX)"
       },
       { "(s)-3'-desamino-3'-(2-methoxy-4-morpholinyl)-doxorubicin ((s)-mmdox)",
         "(R)-3'-desamino-3'-(2-methoxy-4-morpholinyl)-doxorubicin ((S)-MMDOX)"
       },
       { "-15 c", "-15 C" },
       { "0c", "0 C" },
       { "1,10-phenanthroline-platinum(ii)", "1,10-phenanthroline-platinum (II)" },
       { "100k", "100 K" },
       { "16 k", "16 K" },
       { "2-methyl-4-nitroaniline ethylene dimethylammonium hydrobromide (mnaed)",
         "2-methyl-4-nitroaniline ethylene dimethylammonium hydrobromide (MNAED)"
       },
       { "290 k", "290 K" },
       { "290 k, using anisotropic thermal motion model",
         "290 K, using anisotropic thermal motion model"
       },
       { "291k", "291 K" },
       { "3'-desamino-3'-(2-methoxy-4-morpholinyl)-doxorubicin (fce23672)",
         "3'-desamino-3'-(2-methoxy-4-morpholinyl)-doxorubicin (FCE23672)"
       },
       { "3'-desamino-3'-(3-cyano-4-morpholinyl)-doxorubicin (cn-mdox)",
         "3'-desamino-3'-(3-cyano-4-morpholinyl)-doxorubicin (CN-MDOX)"
       },
       { "3,5,6,8-tetramethyl-n-methyl phenanthrolinium (tnp)",
         "3,5,6,8-tetramethyl-N-methyl phenanthrolinium (TNP)"
       },
       { "310k", "310 K" },
       { "4'-6-diamidine-2-phenyl indole (dapi)", "4'-6-diamidine-2-phenyl indole (DAPI)" },
       { "4-o-demethyl-11-deoxydoxorubicin (dddox)", "4-o-demethyl-11-deoxydoxorubicin (DDDOX)" },
       { "434 cro-dna complex", "434 CRO-DNA Complex" },
       { "434 repressor-operator complex", "434 Repressor-Operator Complex" },
       { "[co(nh3)6]3+", "[Co(NH<SUB>3</SUB>)<SUB>6</SUB>]<SUP>3+</SUP>" },
       { "actinomycin d", "actinomycin D" },
       { "actinomycin d, re-refinement", "actinomycin D, Re-refinement" },
       { "adriamycin, -160c", "adriamycin, -160 C" },
       { "alpha-thrombin (e.c.3.4.21.5) complexed with dna and d-phe-pro-arg-chloromethylketone (ppack) with chloromethylketone replaced by a methylene group",
         "alpha-thrombin (E.C.3.4.21.5) complexed with DNA and d-phe-pro-arg-chloromethylketone (PPACK) with chloromethylketone replaced by a methylene group"
       },
       { "arc repressor-operator complex", "ARC Repressor-Operator Complex" },
       { "aspartyl trna synthetase (asprs) (e.c.6.1.1.12)/trna asp complex",
         "aspartyl tRNA synthetase (ASPRS) (E.C.6.1.1.12)/tRNA ASP complex"
       },
       { "ba2+", "Ba<SUP>2+</SUP>" },
       { "bacteriophage phix174-dna complex", "bacteriophage PHIX174-DNA complex" },
       { "bam hi endonuclease-dna complex", "BAM HI endonuclease-DNA complex" },
       { "barium(ii)chloride soaked", "barium(II) chloride soaked" },
       { "barnase-dna complex", "barnase-DNA complex" },
       { "bean pod mottle virus-(protein-rna complex)",
         "bean pod mottle virus-(protein-RNA complex)"
       },
       { "bovine papillomavirus-1 e2-dna complex", "bovine papillomavirus-1 E2-DNA complex" },
       { "c-fos-c-jun-dna-complex", "c-fos-c-jun-DNA-complex" },
       { "canine-parvovirus-dna complex", "canine-parvovirus-DNA complex" },
       { "catabolite gene activator-dna complex", "catabolite gene activator-DNA complex" },
       { "copper(ii) chloride soaked", "copper(II) chloride soaked" },
       { "cu(ii)meso-(4-n-tetramethylpyridyl)porphyrin",
         "Cu(II)meso-(4-N-tetramethylpyridyl)porphyrin"
       },
       { "daunomycin, -160c", "daunomycin, -160 C" },
       { "daunorubicin (daunomycin) and hcho", "daunorubicin (daunomycin) and HCHO" },
       { "daunorubicin and hcho", "daunorubicin and HCHO" },
       { "deoxyribonuclease i (dnase i)-dna complex", "deoxyribonuclease I (DNase I)-DNA complex" },
       { "distamycin a", "distamycin A" },
       { "dna (cytosine-5) methylase-dna complex", "DNA (cytosine-5) methylase-DNA complex" },
       { "doxorubicin and hcho", "doxorubicin and HCHO" },
       { "e. coli met repressor-operator-complex", "E. Coli met repressor-operator-complex" },
       { "e47-dna-complex", "E47-DNA-complex" },
       { "eco ri endonuclease-dna complex", "eco ri endonuclease-DNA complex" },
       { "eco rv endonuclease-dna complex", "eco rv endonuclease-DNA complex" },
       { "engrailed homeodomain-dna complex", "engrailed homeodomain-DNA complex" },
       { "estrogen receptor-dna-complex", "estrogen receptor-DNA-complex" },
       { "five finger gli-dna complex", "five finger GLI-DNA complex" },
       { "flexi-di", "FLEXI-DI" },
       { "g5 carries a charged, achiral methylene phosphonate",
         "G5 carries a charged, achiral methylene phosphonate"
       },
       { "gal4-dna complex", "GAL4-DNA complex" },
       { "gcn4-dna complex", "GCN4-DNA complex" },
       { "glucocorticoid receptor-dna complex", "glucocorticoid receptor-DNA complex" },
       { "glutaminyl-trna synthetase (gln rs)-trna-gln complex",
         "glutaminyl-tRNA synthetase (gln rs)-trna-gln complex"
       },
       { "glutaminyl-trna synthetase-trna and amp complex (-8 degrees c)",
         "glutaminyl-tRNA synthetase-tRNA and AMP complex (-8 degrees C)"
       },
       { "glutaminyl-trna synthetase-trna and amp complex (8 degrees c)",
         "glutaminyl-tRNA synthetase-tRNA and AMP complex (8 degrees C)"
       },
       { "hammerhead dna-rna ribozyme", "hammerhead DNA/RNA ribozyme" },
       { "hexagonal, 100k", "hexagonal, 100 K" },
       { "hexagonal, 293k", "hexagonal, 293 K" },
       { "hhal methyltransferase-dna complex", "HHAL methyltransferase-DNA complex" },
       { "hin recombinase-dna complex", "HIN recombinase-DNA complex" },
       { "hiv-1 rt-dna complex", "HIV-1 RT-DNA complex" },
       { "hnf-3-dna-complex", "HNF-3-DNA-complex" },
       { "hoechst 33258", "Hoechst 33258" },
       { "hoechst 33258, -100 c, piperazine down", "Hoechst 33258, -100 C, piperazine down" },
       { "hoechst 33258, -25 c, piperazine down", "Hoechst 33258, -25 C, piperazine down" },
       { "hoechst 33258, 0 c, piperazine down", "Hoechst 33258, 0 C, piperazine down" },
       { "hoechst 33258, 0 c, piperazine up", "Hoechst 33258, 0 C, piperazine up" },
       { "hoechst 33342", "Hoechst 33342" },
       { "human serum response factor(srf)/dna complex",
         "human serum response factor(SRF)/DNA complex"
       },
       { "idarubicin (4-methoxy-daunorubicin) (idr)", "idarubicin (4-methoxy-daunorubicin) (IDR)" },
       { "klenow fragment-dna complex", "klenow fragment-DNA complex" },
       { "lambda cro-dna complex", "lambda CRO-DNA complex" },
       { "magnesium, cobalt(ii)chloride soaked", "magnesium, cobalt(II) chloride soaked" },
       { "magnesium, copper(ii)chloride soaked", "magnesium, copper(II) chloride soaked" },
       { "mar70", "MAR70" },
       { "mar70 and hcho", "MAR70 and HCHO" },
       { "mar70 cobalt(ii)chloride soaked", "MAR70 cobalt(II) chloride soaked" },
       { "mat a1/mat alpha2 homeodomain/dna complex", "MAT A1/MAT alpha2 homeodomain/DNA complex" },
       { "mat-alpha2 homeodomain-dna complex", "MAT-alpha2 homeodomain-DNA complex" },
       { "model a4", "model A4" },
       { "model t4", "model T4" },
       { "mpd, 280k", "MPD, 280 K" },
       { "mpd, 293k", "MPD, 293 K" },
       { "myod basic-helix-loop-helix (bhlh)-dna complex",
         "MYOD basic-helix-loop-helix (BHLH)-DNA complex"
       },
       { "n,n-dimethylproflavine", "N,N-dimethylproflavine" },
       { "n-(2-aminoethyl)-1,4-diaminobutane (pa(24))",
         "N-(2-aminoethyl)-1,4-diaminobutane (PA(24))"
       },
       { "n8-actinomycin d", "N8-actinomycin D" },
       { "nf-kappa b p50 homodimer-dna complex", "NF-kappa B P50 homodimer-DNA complex" },
       { "nogalamycin, 150k, prolsq refinement", "nogalamycin, 150 K, PROLSQ refinement" },
       { "nogalamycin, 150k, shelxl-93 refinement", "nogalamycin, 150 K, SHELXL-93 refinement" },
       { "oct-1 pou domain-dna complex", "OCT-1 POU domain-DNA complex" },
       { "paired domain/dna complex", "paired domain/DNA complex" },
       { "pb(ii)-transfer ribo-nucleic acid (yeast,phe) t-rna (ph 5.0)",
         "Pb(II)-transfer ribo-nucleic acid (yeast,phe) t-RNA (pH 5.0)"
       },
       { "pb(ii)-transfer ribo-nucleic acid (yeast,phe) t-rna (ph 7.4)",
         "Pb(II)-transfer ribo-nucleic acid (yeast,phe) t-RNA (pH 7.4)"
       },
       { "ppr1-dna complex", "ppr1-DNA complex" },
       { "proflavine, -130c", "proflavine, -130 C" },
       { "proflavine, -2c", "proflavine, -2 C" },
       { "pvuii endonuclease-dna complex", "PVUII endonuclease-DNA complex" },
       { "rat dna polymerase beta-dna-2',3'-dideoxycytidine 5'-triphosphate (ddctp) complex (space group p 21)",
         "Rat DNA polymerase beta-DNA-2',3'-dideoxycytidine 5'-triphosphate (DDCTP) complex (space group P 21)"
       },
       { "rat dna polymerase beta-dna-2',3'-dideoxycytidine 5'-triphosphate (ddctp) complex (space group p 61)",
         "Rat DNA polymerase beta-DNA-2',3'-dideoxycytidine 5'-triphosphate (DDCTP) complex (space group P 61)"
       },
       { "re-refinement", "Re-refinement" },
       { "re-refinement, corels/nuclsq", "Re-refinement, CORELS/NUCLSQ" },
       { "re-refinement, x-plor", "Re-refinement, X-PLOR" },
       { "rna bacteriophage ms2 coat protein/rna complex",
         "RNA bacteriophage MS2 coat protein/RNA complex"
       },
       { "rna hammerhead ribozyme", "RNA hammerhead ribozyme" },
       { "rna/dna hammerhead ribozyme", "RNA/DNA hammerhead ribozyme" },
       { "seryl-trna synthetase (e.c.6.1.1.11)/trna-ser 2 (gga anticodon) complex",
         "seryl-trna synthetase (E.C.6.1.1.11)/tRNA-SER 2 (GGA anticodon) complex"
       },
       { "single-stranded dna binding protein (t4 gp32)-dna complex",
         "single-stranded DNA binding protein (T4 GP32)-DNA complex"
       },
       { "sn6999", "SN6999" },
       { "spermine, -110c", "spermine, -110 C" },
       { "spermine, cobalt(ii)chloride soaked", "spermine, cobalt(II) chloride soaked" },
       { "tata-box binding polypeptide (tbp)-dna complex",
         "TATA-box binding polypeptide (TBP)-DNA complex"
       },
       { "tata-box binding protein (ytbp)/dna complex", "TATA-box binding protein (YTBP)/DNA complex" },
       { "tetragonal, 115k", "tetragonal, 115 K" },
       { "tetragonal, 115k, re-refinement", "tetragonal, 115 K, re-refinement" },
       { "tetragonal, 288k", "tetragonal, 288 K" },
       { "tetragonal, 293k", "tetragonal, 293 K" },
       { "tramtrack dna-binding domain (ttkdbd)/dna complex",
         "tramtrack DNA-binding domain (TTKDBD)/DNA complex"
       },
       { "transcription factor nf-kappa b p50/dna complex",
         "transcription factor NF-kappa B P50/DNA complex"
       },
       { "transfer ribo-nucleic acid (yeast, phe), t-rna",
         "transfer ribo-nucleic acid (yeast, PHE), t-RNA"
       },
       { "transfer ribo-nucleic acid (yeast,asp) t-rna",
         "transfer ribo-nucleic acid (yeast, ASP) t-RNA"
       },
       { "transfer ribo-nucleic acid (yeast,asp) t-rna (a form)",
         "transfer ribo-nucleic acid (yeast, ASP) t-RNA (A form)"
       },
       { "transfer ribo-nucleic acid (yeast,asp) t-rna (b form)",
         "transfer ribo-nucleic acid (yeast, ASP) t-RNA (B form)"
       },
       { "transfer ribo-nucleic acid (yeast,phe) t-rna",
         "transfer ribo-nucleic acid (yeast, PHE) t-RNA"
       },
       { "transfer ribo-nucleic acid (yeast,phe),t-rna",
         "transfer ribo-nucleic acid (yeast, PHE),t-RNA"
       },
       { "triostin a", "Triostin A" },
       { "trp repressor  operator", "TRP repressor  operator" },
       { "trp repressor-operator-complex", "TRP repressor-operator-complex" },
       { "trp repressor/operator half-site complex", "TRP repressor/operator half-site complex" },
       { "u-58872", "U-58872" },
       { "uia spliceosomal protein-rna complex", "UIA spliceosomal protein-RNA complex" },
       { "zif268-dna complex", "ZIF268-DNA complex" }
};

static HTML_STRING replacement[NUM_REPALCE] = {
       { "br", "Br" },
       { "c2h2", "C<SUB>2</SUB>H<SUB>2</SUB>" },
       { "c2h4o", "C<SUB>2</SUB>H<SUB>4</SUB>O" },
       { "c2h5", "C<SUB>2</SUB>H<SUB>5</SUB>" },
       { "ch2", "CH<SUB>2</SUB>" },
       { "ch2-drug", "CH<SUB>2</SUB>-drug" },
       { "ch3", "CH<SUB>3</SUB>" },
       { "cu", "Cu" },
       { "e", "C<SUB>2</SUB>H<SUB>5</SUB>" },
       { "eth", "C<SUB>2</SUB>H<SUB>2</SUB>" },
       { "hcho", "HCHO" },
       { "m", "CH<SUB>3</SUB>" },
       { "me", "CH<SUB>2</SUB>" },
       { "nh2", "NH<SUB>2</SUB>" },
       { "protein (s cys a 7)", "protein (S cys A 7)" },
       { "protein (s cys b 4)", "protein (S cys B 4)" },
       { "pt", "Pt" },
       { "pt(nh3)2", "Pt(NH<SUB>3</SUB>)<SUB>2</SUB>" }
};

static HTML_STRING solution[NUM_SOLUTION] = {
       { "(co(nh3)6)3+", "(Co(NH<SUB>3</SUB>)<SUB>6</SUB>)<SUP>3+</SUP>" },
       { "(nh4)2so4", "(NH<SUB>4</SUB>)<SUB>2</SUB>SO<SUB>4</SUB>" },
       { "9-nh2-acridine_hcl", "9-NH<SUB>2</SUB>-acridine HCl" },
       { "[co(nh3)6]3+", "Co(NH<SUB>3</SUB>)<SUB>6</SUB><SUP>3+</SUP>" },
       { "[co(nh3)6]cl3", "Co(NH<SUB>3</SUB>)<SUB>6</SUB>Cl<SUB>3</SUB>" },
       { "ba2+", "Ba<SUP>2+</SUP>" },
       { "bacl2", "BaCl<SUB>2</SUB>" },
       { "bis-tris propane_hcl", "bis-tris-propane HCl" },
       { "bis-tris-propane_hcl", "bis-tris-propane HCl" },
       { "bis-tris_hcl", "bis-tris HCl" },
       { "btp", "BTP" },
       { "btp_hcl", "BTP HCl" },
       { "ca acetate", "calcium acetate" },
       { "ca cacodylate", "calcium cacodylate" },
       { "ca chloride", "CaCl<SUB>2</SUB>" },
       { "cabr2", "CaBr<SUB>2</SUB>" },
       { "cacl2", "CaCl<SUB>2</SUB>" },
       { "camp", "CAMP" },
       { "co hexamine", "cobalt hexamine" },
       { "co hexamine trichloride", "cobalt hexamine trichloride" },
       { "co(nh3)6(3+)", "Co(NH<SUB>3</SUB>)<SUB>6</SUB><SUP>3+</SUP>" },
       { "co(nh3)6cl3", "Co(NH<SUB>3</SUB>)<SUB>6</SUB>Cl<SUB>3</SUB>" },
       { "cocl2", "CoCl<SUB>2</SUB>" },
       { "cucl2", "CuCl<SUB>2</SUB>" },
       { "dtt", "DTT" },
       { "edt", "EDT" },
       { "edta", "EDTA" },
       { "epps", "EPPS" },
       { "glycine_hcl", "glycine HCl" },
       { "hcho", "formaldehyde" },
       { "hcl", "HCl" },
       { "hepes", "HEPES" },
       { "hexane-1,6-diol or mpd", "hexane-1,6-diol or MPD" },
       { "hmd", "HMD" },
       { "hmp", "HMP" },
       { "hoechst 33258", "Hoechst 33258" },
       { "isopropanol or mpd", "isopropanol or MPD" },
       { "k cacodylate", "potassium cacodylate" },
       { "k2ptcl4", "K<SUB>2</SUB>PtCl<SUB>4</SUB>" },
       { "k_cacodylate", "potassium cacodylate" },
       { "kcl", "KCl" },
       { "kpo4", "K<SUB>2</SUB>PO<SUB>4</SUB>" },
       { "li cacodylate", "lithium cacodylate" },
       { "li sulfate", "lithium sulfate" },
       { "meoh", "methanol" },
       { "mes", "MES" },
       { "mg acetate", "magnesium acetate" },
       { "mg sulfate", "magnesium sulfate" },
       { "mg2+", "mg<SUP>2+</SUP>" },
       { "mgcl", "MgCl" },
       { "mgcl2", "MgCl<SUB>2</SUB>" },
       { "mgso4", "MgSO<SUB>4</SUB>" },
       { "mpd", "MPD" },
       { "mpd or isopropanol", "MPD or isopropanol" },
       { "mpd/etoh", "MPD/ethanol" },
       { "n-(2-hydroxyethyl)piperazine-n'-(propane sulphonic acid)",
         "N-(2-hydroxyethyl)piperazine-n'-(propane sulphonic acid)"
       },
       { "n-octyl-beta-d-glucopyranoside", "N-octyl-beta-d-glucopyranoside" },
       { "na acetate", "sodium acetate" },
       { "na azide", "sodium azide" },
       { "na cacodylate", "sodium cacodylate" },
       { "na cacodylate_hcl", "sodium cacodylate HCl" },
       { "na citrate", "sodium citrate" },
       { "na dihydrogenphosphate", "sodium dihydrogenphosphate" },
       { "na phosphate", "sodium phosphate" },
       { "na2edta", "Na<SUB>2</SUB>EDTA" },
       { "nacl", "NaCl" },
       { "nan3", "NaN<SUB>3</SUB>" },
       { "nh4 acetate", "ammonium acetate" },
       { "nh4 cacodylate", "ammonium cacodylate" },
       { "nh4 citrate", "ammonium citrate" },
       { "nh4 sulfate", "(NH<SUB>4</SUB>)<SUB>2</SUB>SO<SUB>4</SUB>" },
       { "nh4+", "NH<SUB>4</SUB><SUP>+</SUP>" },
       { "nh4cl", "NH<SUB>4</SUB>Cl" },
       { "nh4oh", "NH<SUB>4</SUB>OH" },
       { "peg", "PEG" },
       { "peg 1000", "PEG 1000" },
       { "peg 1500", "PEG 1500" },
       { "peg 200", "PEG 200" },
       { "peg 3000", "PEG 3000" },
       { "peg 3350", "PEG 3350" },
       { "peg 3500", "PEG 3500" },
       { "peg 400", "PEG 400" },
       { "peg 4000", "PEG 4000" },
       { "peg 6000", "PEG 6000" },
       { "peg 8000", "PEG 8000" },
       { "rh(nh3)6cl3", "Rh(NH<SUB>3</SUB>)<SUB>6</SUB>Cl<SUB>3</SUB>" },
       { "sam", "SAM" },
       { "spermine_hcl", "spermine HCl" },
       { "sr cacodylate", "strontium cacodylate" },
       { "srcl2", "SrCl<SUB>2</SUB>" },
       { "triethylammonium_acetate", "triethylammonium acetate" },
       { "tris_hcl", "tris HCl" },
       { "trismaleate/naoh", "trismaleate/NaOH" },
       { "ybcl3", "YbCl<SUB>3</SUB>" },
       { "zn sulfate", "zinc sulfate" },
       { "zncl2", "ZnCl<SUB>2</SUB>" }
};

#endif
