/*
FILE:     plot.h
*/
/*
VERSION:  1.700
*/
/*
DATE:     7/13/2005
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2005 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
#ifndef _RAM_PLOT_H_
#define _RAM_PLOT_H_

#include "color_util.h"

#define XRAMC1            104.0
#define XRAMC2            508.0
#define YRAMC1            293.0
#define YRAMC2            689.0
#define BBOXX1             30.0
#define BBOXX2            582.0
#define BBOXY1             30.0
#define BBOXY2            780.0
#define MAPSIZ             36

#define BOX                 1
#define TRIANGLE            2
#define DIAMOND             3
#define CIRCLE              4

#define ADNA                1
#define BDNA                2
#define ZDNA                4

#define SIZE               36

#define FONT_TIMES_BOLD     1
#define FONT_HELVETICA_OBL  2
#define FONT_COURIER_BOLD   3
#define FONT_SYMBOL         4
#define FONT_TIMES_ROMAN    5
#define FONT_HELVETICA      6

#define LJUSTIFY            1
#define CENTERX             2
#define CENTERY             3
#define LJUSTIFY_CENTERY    3
#define CENTERXY            4
#define RJUSTIFY            5
#define RJUSTIFY_CENTERY    6

#define LINE_SOLID          1
#define LINE_DASH1          2
#define LINE_DASH2          3
#define LINE_DASH3          4

class _plot {
  public:
      _plot();
      _plot(const char *, const int);
      _plot(const char *, const double, const double, const double, const double);
      _plot(const char *, const double, const double, const double, const double,
                        const double, const double, const double, const double);
      void set_view_xmin_and_max(const double, const double);
      void set_view_ymin_and_max(const double, const double);
      void set_actual_value_xmin_and_max(const double, const double);
      void set_actual_value_ymin_and_max(const double, const double);
      void set_axes_grid_num(const int, const int);
      void set_axes_interval(const int, const int);
      void set_x_axis_title(const char *x_title) { strcpy(x_axis_title, x_title); }
      void set_y_axis_title(const char *y_title) { strcpy(y_axis_title, y_title); }
      void set_picture_title(const char *p_title) {strcpy(title, p_title); }
      void set_axes_label_precision(const int, const int);
      void draw_view_window(const double, const double, const double, const double,
                 const char*);
      void draw_view_window(const int, const int, const double, const double, 
             const double, const double, const int);
      void project_map_on_view_window(int map[SIZE][SIZE] /*, const int color_mode */);
      void plot_a_point(const double, const double, const COLOR, const int, const int,
                        const char *);
      void plot_a_point(const double, const double, const double, const double,
                        const double, const int, const int, const char *);
      void plot_a_bar(const double, const double, const double, const double, const COLOR);
      void plot_a_bar(const double, const double, const double, const double, const double,
                      const double, const double);
      void plot_a_line(const double, const double, const double, const double, const int);
      void print_string(const char*, const int, const double, const double, const double,
                const int);
      void newpage(const int);
      void close(void);
      double page_xmin(void) { return user_define_page_xmin; }
      double page_ymin(void) { return user_define_page_ymin; }
      double page_xmax(void) { return user_define_page_xmax; }
      double page_ymax(void) { return user_define_page_ymax; }
      double view_xmin(void) { return user_define_view_xmin; }
      double view_xmax(void) { return user_define_view_xmax; }
      double view_ymin(void) { return user_define_view_ymin; }
      double view_ymax(void) { return user_define_view_ymax; }

      void line(const double, const double, const double, const double);
      void line_style(const int option);
      void setline_width(const double line_width);
      void box(const double, const double, const double, const double,
                const COLOR, const int);
      void box(const double, const double, const double, const double,
               const double, const double, const double, const int);
      void box(const COLOR, const double, const double, const double,
               const double, const double, const double, const double,
               const double, const char *);
      void curve(const double, const double, const double, const double,
                 const double, const COLOR, const int);
      void curve(const double, const double, const double, const double,
                 const double, const double, const double, const double,
                 const int);
      void triangle(const double, const double, const double, const double,
                 const double, const double, const COLOR, const int);
      void triangle(const double, const double, const double, const double,
                 const double, const double, const double, const double,
                 const double, const int);
      void diamond(const double, const double, const double, const double,
                 const double, const double, const double, const double,
                 const COLOR, const int);
      void diamond(const double, const double, const double, const double,
                 const double, const double, const double, const double,
                 const double, const double, const double, const int);
      void setcolor(COLOR col);
      void setcolor(const double, const double, const double);
      void setfont(const int font, const double size, const double angle);
      void wrtstr_xy(const char *, const double, const double, const int);
      void wrt_litstr_xy(const char *, const double, const double, const int);

  private:
     void axes(const double, const double, const double, const double, const int,
             const int, const double, const double, const double, const double,
             const double, const int, const int, const double);
 
     char   filename[80];
     char   title[80];
     char   x_axis_title[80];
     char   y_axis_title[80];

     double user_define_page_xmin;
     double user_define_page_xmax;
     double user_define_page_ymin;
     double user_define_page_ymax;
     double user_define_view_xmin;     // user_define_page_xmin <= user_define_view_xmin,
     double user_define_view_xmax;     // user_define_view_xmax <= user_define_page_xmax
     double user_define_view_ymin;     // user_define_page_ymin <= user_define_view_ymin,
     double user_define_view_ymax;     // user_define_view_ymax <= user_define_page_ymax

     double user_define_actual_value_xmin;
     double user_define_actual_value_xmax;
     double user_define_actual_value_ymin;
     double user_define_actual_value_ymax;

     int x_axis_interval;
     int y_axis_interval;
     int x_axis_grid_num;
     int y_axis_grid_num;
     int intrlx, intrly;
     double x_axis_grid_size;
     double y_axis_grid_size;

     int     pages;
     int     line_type;
     COLOR   color;
     double  linewidth;
     double  font_size;
     double  font_rotation;

     int     is_new_page;

     FILE *ps;
     
};

#endif
